/***************************************************************************
                          cbibbasis.cpp  -  description
                             -------------------
    begin                : Fri Aug 10 2001
    copyright            : (C) 2001 by Heinz Schumann
    email                : heinz@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//#include

#include "cbibbasis.h"
#include "kernprogress.h"


CBibBasis::CBibBasis()
{
  heb_out_abschn.reserve(1000);
  nbr_von_inter=1;
  progstat=0;
  kp = new KernProgress();
}

CBibBasis::~CBibBasis()
{}


void CBibBasis::setzBasVerzeichnis(string v)
{
  bas_verz=v;
  tmp_verz=bas_verz; // +"/tmp/";
}

void CBibBasis::setzBasBuchVerzeichnis(string b)
{
  buch_verz=b;
}

void CBibBasis::setzBasOutVerzeichnis(string b)
{
  out_verz=b;
}

void CBibBasis::setzNbrVonIntervall(int v)
{
  nbr_von_inter=v;
}

bool CBibBasis::setProgressStatus(int s, int i)
{
  bool ok=true;
  if(progstat<=(i*100)/s)
  {
    progstat=(i*100)/s;
    progstep=s;
  }
  ok=kp->progressSchritt(progstat);
  return ok;
}

void CBibBasis::setProgressText(string t)
{
  bool ok=true;
  progtxt=t;
  kp->progressStart(progtxt);
  ok=kp->progressSchritt(1);
}

void CBibBasis::setProgressStop()
{
  kp->progressStop();
  delete kp;
  return;
}


