/***************************************************************************
                          cbibeltext.cpp  -  description
                             -------------------
    begin                : Sun Aug 12 2001
    copyright            : (C) 2001 by Heinz Schumann
    email                : heinz@bitana.de
 
 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>

#include "cbibeltext.h"
#include "cbibgematria.h"
//#include "ceingabedaten.h"

CBibeltext::CBibeltext()
{
  gerbuch="";
}
CBibeltext::~CBibeltext()
{}

int CBibeltext::bibelAbschnitt(string buch,
                               int vkap, int vvers,
                               int bkap, int bvers,
                               string sprache, //="de",
                               string datei) // ="bibabsch.bta")

{
  FILE *fdatei;
  string zwtxt="";
  int i;
  int status=0;

  if(buch.compare("torah"))
    status=kapPos(buch,1,1);
  else
    status=kapPos(buch,101,1);
  if(status)
    return status;

  // Oeffnen Hebr. Text
  if(schltmodifi)
    hebbuch="999";              // Buch im HS ist modifiziert

  // Oeffnen Datei Sprachversion (deutsch/engl)
  string verz=buch_verz+sprache+"/";
  verz.append(buch);
  verz.append(".txt");
  fbuch=fopen(verz.c_str(),"rb");
  if(fbuch==NULL)
    return 16;
  string gerbuch=buch;
  int gerkap=0;
  int gervers=0;
  int gerbunr=0;

  // Vorsetzen des Textes nach Kap/Vers Sprachversion
  // Die Kap/Vers Einteilung ist nicht immer fuer Hebr.
  // und Sprachversion gleich
  int a,b;
  int hebend, gerend;
  int vpos, bpos;
  int lfd=0;
  char c;
  bool ok=true;
  bool sh=true;
  char refe[4];
  char hebzeile[40];

  string hebtxt;
  string hebzwtxt;
  string gertxt;
  string bu;

  while(ok)   // Text Sprachversion vorspulen
    {
      gertxt="";
      c=' ';
      while(c!='\n')
        {
          c=fgetc(fbuch);
          if(c!='\n')
            gertxt+=c;
        }
      zwtxt="(";
      gertxt.copy(refe,3);         // Buchnummer konvertieren
      refe[3]='\0';
      gerbunr=atoi(refe);
      gertxt.erase(0,3);           // Buchnummer abtrennen
      gertxt.copy(refe,3);         // Kapitel konvertieren
      refe[3]='\0';
      zwtxt.append(refe);
      zwtxt.append(":");
      gerkap=atoi(refe);
      gertxt.erase(0,3);           // Kapitel abtrennen

      gertxt.copy(refe,3);         // Vers konvertieren
      refe[3]='\0';
      zwtxt.append(refe);
      zwtxt.append(")");
      gervers=atoi(refe);
      gertxt.erase(0,4);           // Vers abtrennen

      /*
              if(gerkap==vkap && gervers==vvers)
                  ok=false;   // Vorspul ende
              if((gerkap!=ikapitel || gervers!=ivers) && ikapitel==vkap && ivers==vvers)
                  ok=false;
      */
      if(ikapitel==vkap && ivers==vvers)
        ok=false;   // Vorspul ende

      if(ok)
        {
          if(gerkap>vkap && ikapitel>vkap)
            return 22;
          if(gerkap==vkap && ikapitel==vkap && gervers>vvers && ivers>vvers)
            return 22;
          // Heb Vers bei Numeri 25:19 überlesen
          if((ikapitel==425 || (buch=="numeri" && ikapitel==25)) && ivers==18)
            status=nextHebVers(buch,ikapitel,ivers);
          if(status)
            return status;
          // Naechsten Heb Vers
          status=nextHebVers(buch,ikapitel,ivers);
          if(status)
            return status;
        }
      else
        {
          if(gerkap!=ikapitel || gervers!=ivers)
            gertxt.insert(0,zwtxt);  // Einfügen Klammer (kap:vers) in Deutschtext
        }
    }

  vpos=kapvpos;                          // Startpositionen für Hebtext lesen
  bpos=kapbpos;

  // Oeffnen Ausgabedatei
  verz=out_verz;
  verz.append(datei);
  fdatei=fopen(verz.c_str(),"w+b");
  if(fdatei==NULL)
    return 13;

  // Listenparameter schreiben
  status=kapPos(buch,bkap,bvers);
  zwtxt=kap_vers;                             // Bis Kapitel/Vers fuer Listenkopf
  status=kapPos(buch,vkap,vvers);             // Von Kapitel/Vers
  if(status)
    return status;

  string zeile="\a11\t1\t";
  zeile.append(buch);
  zeile.append("\t");          // Wort 1
  zeile.append("\t\t\t");     // Wort 2-3 leer
  zeile.append(kap_vers);     // Von Position
  zeile.append("\t");
  zeile.append(zwtxt);        // Bis Position
  zeile.append("\t");
  zeile.append("\t");         // Von Position
  zeile.append("\t");         // Bis Position
  zeile.append(datei);        // Ausgabedatei
  zeile.append("\n");
  fwrite(zeile.c_str(),1,zeile.length(),fdatei);

  // Listenkopf schreiben
  char cbuch[10];
  strcpy(cbuch,buch.c_str());           // Buchnamen in Grossbuchstaben
  for(i=0;i<(int)strlen(cbuch);i++)
    cbuch[i]=toupper(cbuch[i]);

  zeile="Bibeltextabschnitt aus dem Buch ";
  zeile.append(cbuch);
  zeile.append("\n");
  zeile.append("von Kapitel:Vers ");
  zeile.append(kap_vers);
  zeile.append(" bis ");
  zeile.append(zwtxt);
  zeile.append("\n    \n");
  zeile.append("\brcl\n");          // Beginn Tabelle Direktausdruck (nach formatierter Vorgabe)
  fwrite(zeile.c_str(),1,zeile.length(),fdatei);
  zeile="Originaltext\t Kap:Vers \t Deutscher Text\n";
  fwrite(zeile.c_str(),1,zeile.length(),fdatei);

  // Liste aufbauen
  bool dr=true;
  bool nokor=true;
  while(dr)
    {
      // Heb Text lesen und Hebzeile bilden
      hebtxt="";
      hebzwtxt="";
      a=0;
      b=hebwrtstru[a];      // Anzahl Buchstaben
      while(vpos<=bpos)
        {
          status=lesHebBuchstaben(buch,vpos);
          if(status)
            return status;
          hebtxt+=heb_buchst;
          vpos++;
          b--;
          if(b==0)            // Nächstes Wort
            {
              hebtxt+=' ';
              a++;
              b=hebwrtstru[a];
            }
        }

      // Zeile für Liste zusammenstellen
      ok=true;
      sh=true;
      while(ok)
        {
          zeile="";
          for(i=0;i<31;i++)
            hebzeile[i]=' ';
          hebzeile[30]='\0';
          hebend=hebtxt.size();
          if(hebend>30)
            hebend=30;
          if(hebend>0)
            hebtxt.copy(hebzeile,hebend);
          if(hebend==30)
            {
              while(hebzeile[hebend-1]!=' ')
                {
                  hebzeile[hebend-1]=' ';
                  hebend--;
                }
            }
          if(hebend>0)
            hebtxt.erase(0,hebend);

          // Heb Text für Ausgabe übertragen
          for(i=0;i<30;i++)
            {
              bu=hebzeile[i];
              zeile.append(bu);         // Text für Ausgabezeile eintragen
            }

          // Zeile Mittelstück    (Kapitel:Vers)
          if(sh)
            zeile.append("\t"+kap_vers+"\t");
          else
            zeile.append("\t\t");

          // Zeile mit Sprachversion ergänzen
          for(i=0;i<39;i++)
            hebzeile[i]=' ';
          hebzeile[33]='\0';
          gerend=gertxt.size();
          if(gerend>33)
            gerend=33;
          if(gerend>0)
            gertxt.copy(hebzeile,gerend);
          if(gerend==33)
            {
              while(hebzeile[gerend-1]!=' ')
                {
                  hebzeile[gerend-1]=' ';
                  gerend--;
                }
            }
          if(gerend>0)
            gertxt.erase(0,gerend);

          if(!sh)
            zeile.append("  ");
          zeile.append(hebzeile);
          zeile.append("\n");           // Zeilenabschluss
          sh=false;

          fwrite(zeile.c_str(),1,zeile.length(),fdatei);  // Zeile Schreiben
          lfd++;

          if(!gertxt.size() && !hebtxt.size())
            ok=false;

        }  // end ok = Vers geschrieben
      nokor=true; 
      if(ikapitel==bkap && ivers==bvers)
        dr=false;   // Druck ende
      if(dr)
        {
          if(gerkap>bkap && ikapitel>bkap)
            return 22;
          if(gerkap==bkap && ikapitel==bkap && gervers>bvers && ivers>bvers)
            return 22;
          zeile="\n";
          fwrite(zeile.c_str(),1,zeile.length(),fdatei);  // Vers optisch trennen

          // Nächsten Vers bearbeiten
          status=nextHebVers(buch,ikapitel,ivers);
          vpos=kapvpos;                          // Startpositionen für next Hebtext lesen
          bpos=kapbpos;
          // Deutsch Vers (25:19) gibt es nicht deshalb nur Heb Vers
          if((ikapitel==425 || (buch=="numeri" && ikapitel==25)) && ivers==19)
            nokor=false;

          // Sprachversion Vers einlesen
          gertxt="";
          if(nokor)
            {
              c=' ';
              while(c!='\n')
                {
                  c=fgetc(fbuch);
                  if(c!='\n')
                    gertxt+=c;
                }
              zwtxt="(";
              gertxt.erase(0,3);           // Buchnummer abtrennen

              gertxt.copy(refe,3);         // Kapitel konvertieren
              refe[3]='\0';
              zwtxt.append(refe);
              zwtxt.append(":");
              gerkap=atoi(refe);

              gertxt.erase(0,3);
              gertxt.copy(refe,3);         // Vers konvertieren
              refe[3]='\0';
              zwtxt.append(refe);
              zwtxt.append(")");
              gervers=atoi(refe);

              gertxt.erase(0,4);

              if(gerkap!=ikapitel || gervers!=ivers)
                {
                  gertxt.insert(0,zwtxt);
                }
            }
        }  // end neuen Vers einlesen
    } // end dr

  fclose(fdatei);

  return 0;
}

/******************************************************************/
int CBibeltext::bibelAbschnittAnalyse(string buch,
                                      int vkap, int vvers,
                                      int bkap, int bvers,
                                      string datei) //="bibabana.bta")
{
  FILE *fdatei;
  string zwtxt="";
  int i;

  // Pruefen Bibel Textbereich
  int status=kapPos(buch,bkap,bvers);         // Bis Kapitel/Vers
  if(status)
    return status;
  zwtxt=kap_vers;                             // Bis Kapitel/Vers fuer Listenkopf
  int epos=kapbpos;                           // Endposition fuer Hauptzyklus
  status=kapPos(buch,vkap,vvers);             // Von Kapitel/Vers
  if(status)
    return status;
  if(kapbpos>epos)
    return 22;

  // Oefnen Ausgabedatei
  string verz=out_verz;
  verz.append(datei);
  fdatei=fopen(verz.c_str(),"w+b");
  if(fdatei==NULL)
    return 13;

  // Listenparameter schreiben
  status=kapPos(buch,bkap,bvers);
  zwtxt=kap_vers;                             // Bis Kapitel/Vers fuer Listenkopf
  status=kapPos(buch,vkap,vvers);             // Von Kapitel/Vers
  if(status)
    return status;

  string zeile="\a12\t1\t";
  zeile.append(buch);
  zeile.append("\t");          // Wort 1
  zeile.append("\t\t\t");     // Wort 2-3 leer
  zeile.append(kap_vers);     // Von Position
  zeile.append("\t");
  zeile.append(zwtxt);        // Bis Position
  zeile.append("\t");
  zeile.append("\t");         // Von Position
  zeile.append("\t");         // Bis Position
  zeile.append(datei);        // Ausgabedatei
  zeile.append("\n");
  fwrite(zeile.c_str(),1,zeile.length(),fdatei);

  // Listenkopf schreiben
  char cbuch[10];
  strcpy(cbuch,buch.c_str());           // Buchnamen in Grossbuchstaben
  for(i=0;i<(int)strlen(cbuch);i++)
    cbuch[i]=toupper(cbuch[i]);

  zeile="Analyse des Bibelabschnittes aus dem Buch ";
  zeile.append(cbuch);
  zeile.append("\n");
  zeile.append(" von Kapitel:Vers ");
  zeile.append(kap_vers);
  zeile.append(" bis ");
  zeile.append(zwtxt);
  zeile.append("\n\n");
  zeile.append("\bcrrr\n");            // Beginn Tabelle
  fwrite(zeile.c_str(),1,zeile.length(),fdatei);

  // Tabellenkopf schreiben
  zeile="Kap/Vers\tAnz Worte\tAnz Buchst\tSumme Absolut\n";
  fwrite(zeile.c_str(),1,zeile.length(),fdatei);

  // Verse bearbeiten
  // int i=0;
  int bu=0;
  char zwsp[8];

  do
    {
      zeile=kapitel+":"+vers+"\t";
      i=0;
      bu=0;
      while(hebwrtstru[i]!=0)
        {
          bu+=hebwrtstru[i];
          i++;
        }
      sprintf(zwsp,"% d",i);
      zeile+=zwsp;
      zeile+="\t";
      sprintf(zwsp,"% d",bu);
      zeile+=zwsp;
      zeile+="\t";
      lesHebAbschnitt(buch,kapvpos,kapbpos);
      i=wertZeile(heb_out_abschn, 0);
      sprintf(zwsp,"% d",i);
      zeile+=zwsp;
      zeile.append("\n");
      fwrite(zeile.c_str(),1,zeile.length(),fdatei);
      // Naechsten Vers bearbeiten
      if(status==23)
        break;                         // Buchende erreicht
      status=nextHebVers(buch,ikapitel,ivers);
      if(status!=0 && status!=23)
        return status;
    }
  while(kapbpos<=epos);

  fclose(fdatei);
  return 0;

}

