/***************************************************************************
                          cbuchheb.cpp  -  description
                             -------------------
    begin                : Fri Aug 10 2001
    copyright            : (C) 2001 by Heinz Schumann
    email                : heinz@bitana.de
 
***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cbuchheb.h"
// Include fuer cout Ausgabe ***********************************************
#include <iostream>
using namespace std;             //      Zum einbinden von cout

CBuchHeb::CBuchHeb()
{
  hebbuch="";
  schltmodifi=false;
}
CBuchHeb::~CBuchHeb()
{}
/**************************************************************************/
int CBuchHeb::lesHebAbschnitt(string buch, int vpos, int bpos)
{
  // Lesen eines Hebr. Textabschnittes und ausgabe in das Feld heb_out_abschn

  if(!openHebBuch(buch))
    return 12;

  // Pruefen Parameterdaten
  if(vpos<0 || vpos>hebbuchlng)
    return 21;
  if(bpos<0 || bpos>hebbuchlng)
    return 21;
  if(vpos>bpos)
    return 21;

  // Lesen Textabschnitt
  heb_out_abschn="";
  string c="";
  while(vpos<=bpos)
    {
      c=daten[vpos];
      heb_out_abschn.append(c);
      vpos++;
    }
  return 0;
}
/*************************************************************/
int CBuchHeb::lesHebBuchstaben(string buch, int pos)
{
  if(!openHebBuch(buch))
    return 12;

  // Pruefen Parameterdaten
  if(pos<0 || pos>hebbuchlng)
    return 21;

  heb_buchst=daten[pos];
  return 0;
}
/***************************************************************/
void CBuchHeb::loeschHebBuch()
{
  hebbuch="";
}
/***************************************************************/
int CBuchHeb::suchIntervall(string buch, string inwort,
                            int vinter, int binter,
                            int vpos, int bpos,
                            int richtung,
                            string datei="interlst.zwi",
                            bool modifi=true)
{

  // Aufsuchen von Intervallen zu einem vorgegebenen Wort
  FILE *a1;
  UNIINTER aus;
  string swort=inwort;
  string verz;

  if(!modifi && schltmodifi)
    hebbuch="999";   // Neuoeffnen erzwingen
  if(!openHebBuch(buch))
    return -12;  // Oeffnen Hebr.Buch
  if(modifi)
    {
      if(modifiBuch(buch))
        return -12;   // modifizieren Bibeltext
      swort=modifiWort(inwort);
    }

  swort=textUmkehr(swort);

  if(bpos>=hebbuchlng)
    bpos=hebbuchlng-1;
  if(vpos>=bpos)
    return -21;

  int wlng=inwort.size();
  if(wlng<3)
    return -25;
  int suchlng=1+bpos-vpos;
  int aktpos=vpos;
  int endpos=bpos;

  if(vinter==0 || vinter>binter)
    return -24;
  if(vinter==0)
    vinter=1;
  if(binter>(suchlng/(wlng-1)))
    binter=(suchlng/(wlng-1));

  int lfdpos,lfd,lfdbu;
  int maxint,lfdiv,lfdir;
  int anz=0;
  char wort[51];               // Suchwort max 50 Buchstaben

  // Defaultwerte Ausgabedaten setzen
  aus.s.proz=0;
  aus.s.aber=0;
  aus.s.eber=0;

  // Oeffnen Ausgabedatei
  verz=tmp_verz;
  verz.append(datei);
  a1=fopen(verz.c_str(),"w+b");
  if(a1==NULL)
    return -13;

  // Such Intervall
  swort.copy(wort,wlng,0);         // Konvertieren zum C-String  (char *)

  while(aktpos<endpos)
    {
      while(daten[aktpos]!=wort[0] && aktpos<endpos)
        aktpos++;
      if(aktpos>endpos)
        break;
      if(richtung<2)
        {
          // Suche Vorwaerts
          maxint=(suchlng-(aktpos-vpos))/(wlng-1);
          if(maxint>binter)
            maxint=binter;
          lfdpos=aktpos+vinter;
          while(lfdpos<=endpos)
            {
              while(daten[lfdpos]!=wort[1] && lfdpos<=endpos)
                lfdpos++;
              lfdiv=lfdpos-aktpos;
              if(lfdiv>maxint)
                break;
              if(lfdpos+((wlng-2)*lfdiv)>endpos)
                break;
              if(lfdpos<=endpos && lfdiv<=maxint)
                {
                  lfdbu=1;
                  lfd=lfdpos;
                  while(daten[lfd]==wort[lfdbu] && lfd<=bpos && lfdbu<wlng)
                    {
                      lfdbu++;
                      if(lfdbu==wlng)
                        {
                          aus.s.apos=aktpos;
                          aus.s.epos=lfd;
                          aus.s.inter=lfdiv;
                          aus.s.richt=0;
                          fwrite(aus.c,1,sizeof(STRINTER),a1);
                          anz++;
                          break;
                        }
                      lfd+=lfdiv;
                    }
                }
              lfdpos++;
            }
        }

      // Suche Rueckwaerts
      if(richtung==0 || richtung==2)
        {
          maxint=(aktpos-vpos)/(wlng-1);
          if(maxint>binter)
            maxint=binter;
          lfdpos=aktpos-vinter;
          while(lfdpos>=vpos)
            {
              while(daten[lfdpos]!=wort[1] && lfdpos>vpos)
                lfdpos--;
              lfdir=aktpos-lfdpos;
              if(lfdir>maxint)
                break;
              if(lfdpos>vpos && lfdir<=maxint)
                {
                  lfdbu=1;
                  lfd=lfdpos;
                  while(daten[lfd]==wort[lfdbu] && lfd>=vpos && lfdbu<wlng)
                    {
                      lfdbu++;
                      if(lfdbu==wlng)
                        {
                          aus.s.apos=aktpos;
                          aus.s.epos=lfd;
                          aus.s.inter=lfdir;
                          aus.s.richt=1;
                          fwrite(aus.c,1,sizeof(STRINTER),a1);
                          anz++;
                          break;
                        }
                      lfd-=lfdir;
                    }
                }
              lfdpos--;
            }
        }
      aktpos++;
    }
  fclose(a1);
  return anz;
}
/*************************************************************/
int CBuchHeb::suchBlock(string buch, string wort,
                        int vonpos,
                        int bispos,
                        int blk,
                        int ianz,
                        bool mod,
                        string datei)
{
  string verz;
  FILE *fein, *faus;

  int imax=mindestIntervall(buch, wort, ianz+1,0,999999,0,true);
  if(imax>ianz)
    imax=ianz;
  int anz=suchIntervall(buch, wort, 2, imax+1, vonpos, bispos, 0,"interlst.zwi", mod);
  if(anz<0)
    return abs(anz);
  if(anz<2)
    return -1;
  sortListeIntervall(0,"interlst.zwi", "interlst.zwi");

  // Quersumme Suchwort berechnen
  long int qsum=0;
  char wrt[51];
  int i,k;

  wort.copy(wrt,wort.size(),0);                     // Konvertieren zum C-String  (char *)
  for(unsigned int ii=0;ii<wort.length();ii++)
    qsum+=wertBuchstabe(wrt[ii],0);

  // Oeffnen Eingabedatei
  verz=tmp_verz;
  verz.append("interlst.zwi");

  fein=fopen(verz.c_str(),"r");
  if(fein==NULL)
    return 14;

  // Oeffnen Ausgabedatei
  verz=tmp_verz;
  verz.append(datei);
  faus=fopen(verz.c_str(),"w+b");
  if(faus==NULL)
    return -13;

  UNIINTER ein;
  UNIBLOCK aus;

  int lfdv=0;
  int lfdr=0;
  int lfd=0;
  int inter=0;
  int gap=0;
  int gep=0;
  int gr=0;
  int fe;
  int apv[150];
  int apr[150];
  int epv[150];
  ldiv_t fak;

  for(i=0;i<150;i++)
    {
      apv[i]=0;
      apr[i]=0;
      epv[i]=0;
    }
  anz=0;
  aus.s.qdiv=0;
  aus.s.qrest=0;
  aus.s.idiv=0;
  aus.s.irest=0;

  // Daten einlesen und Bloecke suchen
  rewind(fein);
  fread(ein.c,1,sizeof(STRINTER),fein);

  do
    {
      if(ein.s.inter!=inter)        // Neue Intervallweite;
        {
          if(lfdv!=0 && lfdr!=0)    // Daten zusammenstellen
            {
              gap=apv[0];
              gep=epv[0];
              gr=apr[0];
              for(i=1;i<lfd;i++)
                {
                  if(gr!=apr[i])
                    {
                      aus.s.inter=inter;
                      aus.s.qswrt=qsum;
                      if(gap<epv[i])
                        {
                          aus.s.apos=gap;
                          aus.s.epos=epv[i];
                        }
                      else
                        {
                          aus.s.apos=apv[i];
                          aus.s.epos=gep;
                        }
                      aus.s.banz=aus.s.epos-aus.s.apos;  // Anzahl Buchstaben
                      aus.s.qsblk=0;                   // Quersumme Block berechnen
                      for(k=0;k<aus.s.banz;k++)
                        {
                          fe=lesHebBuchstaben(buch,(aus.s.apos+k));
                          if(fe!=0)
                            return -fe;
                          aus.s.qsblk+=wertBuchstabe(heb_buchst,0);
                        }
                      fak=ldiv(aus.s.qsblk,aus.s.qswrt);   // Quersumme Block durch Quersumme Wort
                      aus.s.qdiv=fak.quot;
                      aus.s.qrest=fak.rem;

                      fak=ldiv(aus.s.banz,(aus.s.inter*(wort.length()-1))); // Laenge Block durch Intervallweite
                      aus.s.idiv=fak.quot;
                      aus.s.irest=fak.rem;

                      if(blk==0)
                        {
                          aus.s.trest=0;                      // Laenge Block durch 1
                          aus.s.tdiv=aus.s.banz;
                          lfdr++;
                        }
                      else
                        {
                          lfdr++;
                          aus.s.tdiv=aus.s.banz/blk;          // Laenge Block durch Blockvorgabe
                          aus.s.trest=aus.s.banz%blk;
                        }

                      if(blk==0)
                        {
                          fwrite(aus.c,1,sizeof(STRBLOCK),faus);
                          anz++;
                        }
                      else if(aus.s.trest==0)
                        {
                          fwrite(aus.c,1,sizeof(STRBLOCK),faus);
                          anz++;
                        }
                    }
                  gap=apv[i];
                  gep=epv[i];
                  gr=apr[i];
                }
            }

          lfdv=0;
          lfdr=0;
          inter=ein.s.inter;
          lfd=0;
          for(i=0;i<150;i++)
            {
              apv[i]=0;
              apr[i]=0;
              epv[i]=0;
            }
        }

      if(ein.s.richt==0)
        lfdv++;
      else
        lfdr++;
      apv[lfd]=ein.s.apos;
      epv[lfd]=ein.s.epos;
      apr[lfd]=ein.s.richt;
      lfd++;

      fread(ein.c,1,sizeof(STRINTER),fein);
    }
  while(!feof(fein));

  fclose(fein);
  fclose(faus);
  return anz;
}

/***************************************************************/
int CBuchHeb::sortListeIntervall(int art, string outdatei, string indatei)
{

  FILE *e1, *a1;

  // Oeffnen Eingabedatei
  string verz=tmp_verz;
  verz.append(indatei);
  e1=fopen(verz.c_str(),"rb");
  if(e1==NULL)
    return 14;
  if(fseek(e1,0,SEEK_END))
    return 14;
  int anz=ftell(e1)/sizeof(STRINTER);    // Anzahl Datensaetze ermitten

  STRINTER *srt;
  int l,j;
  int a=0;
  int zw=0;
  int zl=0;

  UNIINTER ein;
  srt=new STRINTER[anz];

  for(l=0;l<anz;l++)
    {
      srt[l].inter=999999;
      srt[l].apos=999999;
      srt[l].epos=999999;
      srt[l].richt=0;
    }
  // Sort ELS
  rewind(e1);
  fread(ein.c,1,sizeof(STRINTER),e1);
  a=0;
  while(!feof(e1))
    {
      if(ein.s.apos>ein.s.epos)
        {
          zw=ein.s.apos;
          ein.s.apos=ein.s.epos;
          ein.s.epos=zw;
        }
      l=0;
      if(art==0)  // Sortieren nach Intervall
        {
          while(ein.s.inter>srt[l].inter && l<a)
            l++;
          while(ein.s.inter==srt[l].inter &&
                ein.s.apos>=srt[l].apos   && l<a)
            l++;
        }
      if(art==1)  // Sortieren nach Position
        {
          while(ein.s.apos>srt[l].apos   && l<a)
            l++;
          while(ein.s.apos==srt[l].apos   &&
                ein.s.inter>=srt[l].inter && l<a)
            l++;
        }
      if(art==2)  // Sortieren nach Prozent
        {
          while(ein.s.proz<srt[l].proz && l<a)
            l++;
          while(ein.s.proz==srt[l].proz &&
                ein.s.apos>=srt[l].apos   && l<a)
            l++;
        }

      // Einordnen
      if(a<=anz)
        {
          for(j=a;j>l;j--)
            srt[j]=srt[j-1];
          a++;
          srt[l].inter=ein.s.inter;
          srt[l].apos=ein.s.apos;
          srt[l].epos=ein.s.epos;
          srt[l].richt=ein.s.richt;
          srt[l].proz=ein.s.proz;
          srt[l].aber=ein.s.aber;
          srt[l].eber=ein.s.eber;
        }
      fread(ein.c,1,sizeof(STRINTER),e1);
      zl++;
    }
  fclose(e1);

  // Oeffnen Ausgabedatei
  verz=tmp_verz;
  verz.append(outdatei);
  a1=fopen(verz.c_str(),"w+b");
  if(a1==NULL)
    return 13;

  l=0;
  while(l<anz)
    {
      ein.s.inter=srt[l].inter;
      ein.s.apos=srt[l].apos;
      ein.s.epos=srt[l].epos;
      ein.s.richt=srt[l].richt;
      ein.s.proz=srt[l].proz;
      ein.s.aber=srt[l].aber;
      ein.s.eber=srt[l].eber;
      fwrite(ein.c,1,sizeof(STRINTER),a1);
      l++;
    }
  fclose(a1);
  delete srt;
  return 0;
}
/************************************************************/
float CBuchHeb::intervallErwartung(string buch, string wort,
                                   int vinter, int binter,
                                   int vpos, int bpos,
                                   int richtung, bool modifi)
{
  int i;
  int j;
  int bu;

  if(!modifi && schltmodifi)
    hebbuch="999";   // Neuoeffnen erzwingen
  if(!openHebBuch(buch))
    return 0.0;
  ;
  if(modifiBuch(buch))
    return 0.0;
  string mwort=modifiWort(wort);

  int wlng=wort.size();
  int bispos;
  if(bpos>hebbuchlng-1)
    bispos=hebbuchlng-1;
  else
    bispos=bpos;
  int sulng=bispos-vpos+1;
  zaehlBuchstaben(vpos, bispos);
  j=sulng/(wlng-1);
  if(j<binter)
    binter=j;
  float wert=1.0;
  for(i=0;i<wlng;i++)
    {
      bu=mwort.at(i)+32;
      if(hebbuchst[bu]<=0)
        return 0.0; // Dieser Buchstabe ist nicht im Text vorhanden
      if(bu>=0 && bu<=26)
        wert=wert*(float(hebbuchst[bu])/sulng);
    }
  float erg=0.0;
  for(j=vinter;j<=binter;j++)
    erg=erg+(sulng-((wlng-1)*j));
  if(richtung==0)
    erg=erg*2;               // weil Vorwaerts und Rueckwaerts
  erg=erg*wert;
  return erg;
}
/*********************************************************************/
int CBuchHeb::mindestIntervall(string buch, string wort, int mindest,
                               int vpos, int bpos,
                               int richtung, bool modifi)
{
  float erw=0.0;
  int maxint=1;
  float vgl=mindest;

  while(erw<vgl)
    {
      if(maxint<10)
        maxint++;
      else if(maxint<100)
        maxint+=10;
      else if(maxint<1000)
        maxint+=100;
      else
        maxint+=1000;

      erw=intervallErwartung(buch,wort,2,maxint,vpos,bpos,richtung,modifi);
      if(bpos==999999)
        bpos=hebbuchlng;
      if(maxint>((bpos-vpos)/((int)wort.size()-1)))
        break;
    }
  return maxint;
}
/*******************************************************************/
int CBuchHeb::ermittleMinimalbereich(string outdatei="interlst.min",
                                     string indatei="interlst.sor")
{
  FILE *e1, *a1;
  STRINTER *fld;

  // Oeffnen Eingabedatei
  string verz=tmp_verz;
  verz.append(indatei);
  e1=fopen(verz.c_str(),"rb");
  if(e1==NULL)
    return 14;
  if(fseek(e1,0,SEEK_END))
    return 14;
  int anz=ftell(e1)/sizeof(STRINTER);    // Anzahl Datensaetze ermitten

  // Einlesen Daten
  int ls,j;
  fld = new STRINTER[anz];
  UNIINTER ein;

  rewind(e1);
  for(ls=0;ls<anz;ls++)
    {
      fread(ein.c,1,sizeof(STRINTER),e1);
      fld[ls].inter=ein.s.inter;
      fld[ls].apos=ein.s.apos;
      fld[ls].epos=ein.s.epos;
      fld[ls].richt=ein.s.richt;
      fld[ls].proz=0;
      fld[ls].aber=0;
      fld[ls].eber=hebbuchlng;
    }
  fclose(e1);

  // Ermitteln minimalbereiche fuer Intervalle

  ls=0;
  while(ls<anz)
    {
      if(fld[ls].inter==999999)
        break;
      j=0;
      while(j<anz)
        {
          if(ls!=j)
            {
              if(fld[ls].inter<=fld[j].inter || fld[ls].eber==0)
                break;

              // Untere Bereichsgrenze
              if(fld[ls].apos>=fld[j].epos &&
                  fld[ls].aber<fld[j].epos)
                fld[ls].aber=fld[j].epos+1;

              // Obere Bereichsgrenze
              if(fld[ls].epos<=fld[j].apos   &&
                  fld[ls].eber>fld[j].apos)
                fld[ls].eber=fld[j].apos-1;

              // Innerhalb der Bereichsgrenzen
              if(fld[ls].aber<=fld[j].apos &&
                  fld[ls].eber>=fld[j].epos)
                {
                  fld[ls].aber=fld[j].apos;
                  fld[ls].eber=fld[j].epos;
                  if(fld[ls].aber>fld[ls].apos || fld[ls].eber<fld[ls].epos)
                    {
                      fld[ls].aber=0;
                      fld[ls].eber=0;
                    }
                  break;
                }
            }
          j++;
        }
      fld[ls].proz=((fld[ls].eber-fld[ls].aber)*100)/hebbuchlng;
      ls++;
    }

  // Ausgabedatei oeffnen
  verz=tmp_verz;
  verz.append(outdatei);
  a1=fopen(verz.c_str(),"w+b");
  if(a1==NULL)
    return 13;

  for(ls=0;ls<anz;ls++)
    {
      ein.s.inter=fld[ls].inter;
      ein.s.apos=fld[ls].apos;
      ein.s.epos=fld[ls].epos;
      ein.s.richt=fld[ls].richt;
      ein.s.proz=fld[ls].proz;
      ein.s.aber=fld[ls].aber;
      ein.s.eber=fld[ls].eber;
      fwrite(ein.c,1,sizeof(STRINTER),a1);
    }
  fclose(a1);
  delete [] fld;
  return 0;
}
/**************************************************************************/
int CBuchHeb::ermittleBuchlaenge(string buch)
{
  if(!openHebBuch(buch))
    return 12;
  return hebbuchlng;
}

/**************************************************************************/
int CBuchHeb::lesIntervall(string buch, int intervall,
                           int zeilenbreite,
                           int vpos, int bpos,
                           string datei,
                           bool modifi)
{
  FILE *a1;

  if(!openHebBuch(buch))
    return 12;
  if(modifi)
    if(modifiBuch(buch))
      return 12;

  bool fzl=false;
  if(zeilenbreite>MAXHEBLNG)
    {
      zeilenbreite=MAXHEBLNG;
      fzl=true;
    }
  // Oeffnen Ausgabedatei
  string verz=out_verz;
  verz.append(datei);
  a1=fopen(verz.c_str(),"w+b");
  if(a1==NULL)
    return 13;

  char zwsp[15];
  int i,j;


  string zeile="Textdarstellung aus dem Buch ";
  strcpy(zwsp,buch.c_str());              // Buchnamen in Grossbuchstaben
  for(i=0;i<(int)strlen(zwsp);i++)
    zwsp[i]=toupper(zwsp[i]);
  zeile.append(zwsp);
  zeile.append(" mit Schrittweite ");
  sprintf(zwsp,"% d",intervall);
  zeile.append(zwsp);
  zeile.append("\n");
  zeile.append("von Position ");
  sprintf(zwsp,"% d",vpos);
  zeile.append(zwsp);
  zeile.append(" bis Position ");
  sprintf(zwsp,"% d",bpos);
  zeile.append(zwsp);
  zeile.append(" bei Darstellungsbreite ");
  sprintf(zwsp,"% d",zeilenbreite);
  zeile.append(zwsp);
  zeile.append("\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);
  if(fzl)
  {
   zeile="Maximale Zeilenbreite ist 150, Zeilenbreite wurde auf 150 reduziert \n";
   fwrite(zeile.c_str(),1,zeile.length(),a1);
  }
  // Matrixdaten fuer Listensteuerung
  zeile="\v";
  sprintf(zwsp,"% d",zeilenbreite);
  zeile.append(zwsp);
  zeile.append("\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  int anz=0;
  int aktpos=vpos;
  if(bpos>=hebbuchlng)
    bpos=hebbuchlng-1;

  char c;
  char text[MAXHEBLNG];

  for(j=0;j<MAXHEBLNG;j++) text[j]=0;
  while(aktpos<=bpos)
    {
      for(i=0;i<zeilenbreite;i++)
        {
          text[i]=daten[aktpos];
          aktpos+=intervall;
          if(aktpos>bpos)
            break;
        }
      for(j=i-1;j>=0;j--) fputc(text[j],a1);
      fputc('\n',a1);
      anz++;
    }

  fclose(a1);
  return 0;
}

/***********************************************************************/
int CBuchHeb::suchWortBlock(string buch, string wort,
                            int blk,
                            int ianz,
                            string datei)
{
  string verz;
  FILE *fein, *faus;

  int imax=mindestIntervall(buch, wort, ianz,0,999999,0,true);
  if(imax>1000)
    imax=1000;
  int anz=suchIntervall(buch, wort, 1, imax,0,999999,0,"interlst.zwi",true);
  if(anz<0)
    return abs(anz);
  if(anz<2)
    return 1;
  sortListeIntervall(0,"interlst.zwi", "interlst.zwi");

  // Quersumme Suchwort berechnen
  CBibGematria *ge = new(CBibGematria);
  long int qsum=0;
  char wrt[51];
  int i,j,k;
  wort.copy(wrt,wort.size(),0);         // Konvertieren zum C-String  (char *)
  for(unsigned int ii=0;ii<wort.length();ii++)
    qsum+=wertBuchstabe(wrt[ii],0);

  // Oeffnen Eingabedatei
  verz=tmp_verz;
  verz.append("interlst.sor");

  fein=fopen(verz.c_str(),"r");
  if(fein==NULL)
    return 14;

  // Oeffnen Ausgabedatei
  verz=tmp_verz;
  verz.append(datei);
  faus=fopen(verz.c_str(),"w+b");
  if(faus==NULL)
    return -13;

  UNIINTER ein;
  UNIBLOCK aus;

  int lfdv=0;
  int lfdr=0;
  int inter=0;
  int fe;
  int apv[50];
  int apr[50];
  int epv[50];
  int epr[50];

  for(i=0;i<50;i++)
    {
      apv[i]=0;
      apr[i]=0;
      epv[i]=0;
      epr[i]=0;
    }
  anz=0;
  aus.s.qdiv=0;
  aus.s.qrest=0;
  aus.s.idiv=0;
  aus.s.irest=0;

  // Daten einlesen und Bloecke suchen
  rewind(fein);
  fread(ein.c,1,sizeof(STRINTER),fein);
  while(!feof(fein))
    {
      if(ein.s.inter!=inter)        // Neue Intervallweite;
        {
          if(lfdv!=0 && lfdr!=0)               // Daten ausgeben
            {
              for(i=0;i<lfdv;i++)
                for(j=0;j<lfdr;j++)
                  {
                    aus.s.inter=inter;
                    aus.s.qswrt=qsum;
                    if(apv[i]<epr[j])
                      {
                        aus.s.apos=apv[i];
                        aus.s.epos=epr[j];
                      }
                    else
                      {
                        aus.s.apos=apr[j];
                        aus.s.epos=epv[i];
                      }
                    aus.s.banz=aus.s.epos-aus.s.apos;  // Anzahl Buchstaben
                    aus.s.qsblk=0;                     // Quersumme Block berechnen
                    for(k=0;k<aus.s.banz;k++)
                      {
                        fe=lesHebBuchstaben(buch,(aus.s.apos+k));
                        if(fe!=0)
                          return -fe;
                        aus.s.qsblk+=ge->wertBuchstabe(heb_buchst,0);
                      }
                    if(blk==0)
                      {
                        aus.s.qdiv=aus.s.qsblk/aus.s.qswrt;  // Quersumme Block durch Quersumme Wort
                        aus.s.qrest=aus.s.qsblk%aus.s.qswrt;

                        aus.s.idiv=aus.s.banz/aus.s.inter;   // Laenge Block durch Intervallweite
                        aus.s.irest=aus.s.banz%aus.s.inter;

                        aus.s.trest=0;                      // Laenge Block durch 1
                        aus.s.tdiv=aus.s.banz;
                      }
                    else
                      {
                        aus.s.tdiv=aus.s.banz/blk;          // Laenge Block durch Blockvorgabe
                        aus.s.trest=aus.s.banz%blk;
                      }

                    if(blk==0)
                      {
                        fwrite(aus.c,1,sizeof(STRBLOCK),faus);
                        anz++;
                      }
                    else if(aus.s.trest==0)
                      {
                        fwrite(aus.c,1,sizeof(STRBLOCK),faus);
                        anz++;
                      }
                  }
            }
          lfdv=0;
          lfdr=0;
          inter=ein.s.inter;
        }
      if(ein.s.richt==0)
        {
          apv[lfdv]=ein.s.apos;
          epv[lfdv]=ein.s.epos;
          lfdv++;
        }
      if(ein.s.richt==1)
        {
          apr[lfdr]=ein.s.apos;
          epr[lfdr]=ein.s.epos;
          lfdr++;
        }
      fread(ein.c,1,sizeof(STRINTER),fein);

    }

  fclose(fein);
  fclose(faus);
  return anz;
}
/*******************************************************************
---------------------- Private Methoden ---------------------------
********************************************************************/

bool CBuchHeb::openHebBuch(string buch)
{
  string verz="";

  if(buch.compare(hebbuch))
    {
      if(hebbuch!="")
        delete daten;
      schltmodifi=false;
      verz=buch_verz;
      verz.append(buch);
      verz.append(".cod");
      fhebbuch=fopen(verz.c_str(),"rb");
      if(fhebbuch==NULL)
        return false;
      if(fseek(fhebbuch,0,2))
        return false;
      hebbuchlng=ftell(fhebbuch);             // Dateilaenge
      rewind(fhebbuch);
      hebbuch=buch;
      daten = new char[hebbuchlng];
      long anz=fread(daten,1,hebbuchlng,fhebbuch);
      if(anz!=hebbuchlng)
        return false;
    }
  return true;
}
/**********************************************************************/
int CBuchHeb::modifiBuch(string buch)
{
  int i=0;
  char bu;

  if(!openHebBuch(buch))
    return 12;
  if(!schltmodifi)
    {
      for(i=0;i<hebbuchlng;i++)
        if(daten[i]==-22 || daten[i]==-19 || daten[i]==-17 ||
            daten[i]==-13 || daten[i]==-11)
          {
            bu=daten[i];
            daten[i]=bu+1;
          }

      schltmodifi=true;
    }
  return 0;
}
/*********************************************************************/
string CBuchHeb::modifiWort(string wort)
{
  string w="";
  char ca[2]=" ";

  for(int i=0;i<(int)wort.size();i++)
    {
      ca[0]=wort.at(i);
      if(ca[0]==-22 || ca[0]==-19 ||
          ca[0]==-17 || ca[0]==-13 ||
          ca[0]==-11)
        ca[0]++;
      w+=ca[0];
    }
  return w;
}
/**********************************************************************/
string CBuchHeb::pruefWort(string wort)
{
  string w="";
  char ca[2]=" ";

  for(int i=0;i<(int)wort.size();i++)
    {
      ca[0]=wort.at(i);
      if(ca[0]!=32) w+=ca[0];
    }
  return w;
}
/**********************************************************************/
string CBuchHeb::textUmkehr(string text)
{
  string t="";
  if(text.size()>0)
    for(int i=text.size();i>0;i--)
      t+=text.at(i-1);
  return t;
}
/**********************************************************************/
void CBuchHeb::zaehlBuchstaben(int vpos, int bpos)
{
  char bu;
  for(int i=0;i<28;i++)
    hebbuchst[i]=0;
  int akt=vpos;
  while(akt<=bpos)
    {
      bu=daten[akt];
      hebbuchst[bu+32]++;
      akt++;
    }
}

