/***************************************************************************
                          cbuchindex.cpp  -  description
                             -------------------
    begin                : Thu Aug 9 2001
    copyright            : (C) 2001 by Heinz Schumann
    email                : heinz@bitana.de

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cbuchindex.h"

// Include für cout Ausgabe ***********************************************
#include <iostream>
using namespace std;             //      Zum einbinden von cout

CBuchIndex::CBuchIndex()
{
 idxbuch="";
 for(int i=0;i<ANZHEBWRT;i++) hebwrtstru[i]=0;
}

CBuchIndex::~CBuchIndex()
{
}

int CBuchIndex::posKap(string buch, int pos)
{
// Bestimmen von Kapitel und Vers zur Position
 if(!openIdxBuch(buch)) return 11;            // Fehler Idx Datei oder Verz nicht gefunden
 if(buch.compare(hebbuch)) if(!openHebBuch(buch)) return 12; // Fehler Heb Datei oder Verz
 if(pos>=hebbuchlng) return 21;               // Fehler Position zu gross if(pos<idxkopf.vpos)
 {
  rewind(fidxbuch);
  nextIdxSatz();
 }
 while(pos>idxkopf.bpos) nextIdxSatz();
 idxDatenEintragen();
 return 0;
}

int CBuchIndex::kapPos(string buch, int kap, int vers)
{
// Bestimmen von Position zu Kapitel und Vers
 if(!openIdxBuch(buch)) return 11;            // Fehler Datei oder Verz nicht gefunden
 int v=(int)idxkopf.kvbez[1];                 // Arbeitsvariable mit akt Stand initialisieren
 int k=(int)idxkopf.kvbez[0]+(v*256);
 v=(int)idxkopf.kvbez[2];

 if(k>kap || (k==kap && v>vers))
 {
  rewind(fidxbuch);
  nextIdxSatz();
  v=(int)idxkopf.kvbez[1];
  k=(int)idxkopf.kvbez[0]+(v*256);
  v=(int)idxkopf.kvbez[2];
 }

 while(k<kap || (k==kap && v<vers))
 {
  if(!nextIdxSatz()) return 22;
  v=(int)idxkopf.kvbez[1];
  k=(int)idxkopf.kvbez[0]+(v*256);
  v=(int)idxkopf.kvbez[2];
 }
 idxDatenEintragen();
 return 0;
}

int CBuchIndex::nextHebVers(string buch, int kap, int vers)
{
// Bereitstellen der Daten zum naechsten Vers
 int status=kapPos(buch, kap, vers);
 if(status) return status;

 if(!nextIdxSatz()) return 23;        // Buchende erreicht
 idxDatenEintragen();
 return 0;
}

bool CBuchIndex::openIdxBuch(string buch)
{
 string verz="";

 if(buch.compare(idxbuch))
 {
  if(!openHebBuch(buch)) return false;    // Wegen hebbuchlng xxx.cod oeffnen
  if(idxbuch!="") fclose(fidxbuch);
  verz=buch_verz;                        // Indexdatei oeffnen
  verz.append(buch);
  verz.append(".idx");
  fidxbuch=fopen(verz.c_str(),"rb");
  if(fidxbuch==NULL) return false;
  if(fseek(fidxbuch,0,SEEK_END)) return false;
  idxbuchlng=ftell(fidxbuch);             // Dateilaenge
  rewind(fidxbuch);
  idxbuch=buch;
  if(!nextIdxSatz()) return false;
 }
 return true;
}

bool CBuchIndex::nextIdxSatz()
{

// Lesen naechsten Idx Satz
 for(int i=0;i<ANZHEBWRT;i++) hebwrtstru[i]=0;
 if(feof(fidxbuch)) return false;
 size_t anz=fread(&idxkopf,1,sizeof(idxkopf),fidxbuch);  // Lesen Daten in Kopfstruktur
 if(anz!=sizeof(idxkopf)) return false;

// Lesen Wortinformationen zum Vers
 unsigned char c;
 int b=0;
 while(!feof(fidxbuch))
 {
  c=fgetc(fidxbuch);
  if((int)c==0xff) break;
  hebwrtstru[b]=(int)c;
  b++;
 }
 return true;
}

void CBuchIndex::idxDatenEintragen()
{

//Uebertragen Daten, Kapitel Vers, in globale Struktur CBibBasis
 char zwsp[8];

 int b=(int)idxkopf.kvbez[1];
 ikapitel=(int)idxkopf.kvbez[0]+(b*256);
 ivers=(int)idxkopf.kvbez[2];
 kapvpos=idxkopf.vpos;             // Vers Vonposition
 kapbpos=idxkopf.bpos;             // Vers Bisposition
//Kap-Vers konvertieren in String kap_vers;
 if(idxbuch.compare("torah")) sprintf(zwsp,"%2d%c%02d",ikapitel,':',ivers); //Kap-Vers konvertieren in String kap_vers;
 else sprintf(zwsp,"%3d%c%02d",ikapitel,':',ivers); //Kap-Vers konvertieren in String kap_vers;
 kap_vers=zwsp;
 sprintf(zwsp,"%3d",ikapitel);
 kapitel=zwsp;
 sprintf(zwsp,"%02d",ivers);
 vers=zwsp;
 return;
}
