/***************************************************************************
                          clexikon.cpp  -  description
                             -------------------
    begin                : Wed Nov 7 2001
    copyright            : (C) 2001 by Heinz Schumann
    email                : heinz.schumann@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "clexikon.h"

CLexikon::CLexikon()
{
 sprache=999;
}
CLexikon::~CLexikon()
{
}
/***********************************************************************/
string CLexikon::findWort(string wo, int sp)
{
 int i;
 int j[3];
 int a,x;
 bool nf=true;
 bool ok=false;
 char wort[20];

 string zeile="";

 ok=false;
 if(!sp) wo.append("\n");        // Sprache ist Hebraeisch

 if(sprache!=sp) nf=ladIndex(sp);
 if(!nf)
 {
  zeile.append("4");               // Fehler bei öffnen Index oder Datendatei
  return zeile;
 }

 for(i=0;i<20;i++) wort[i]=0;
 wo.copy(wort,wo.length(),0);     // Konvertieren zum C-String (char *)

// Erzeuge Index für Wortsuche
 for(i=0;i<3;i++) j[i]=0;

 if(wort[0]==10 || wort[0]==32)
 {
  zeile.append("3");                     // Ende Lexikon
  return zeile;
 }

 for(i=0;i<3;i++)
 {
  x=wort[i];
  if(x==32) break;
  if(sp)
  {
   if(x>64 && x<91) x-=64;
   if(x>96 && x<123) x-=96;
  }
  else  if(x>-33) x+=33;
  if(x==39) x=27;
  if(x==45) x=28;
  if(x<0 || x>28) x=0;
  j[i]=x;
 }

 if(tab.idx[j[0]][j[1]][j[2]]>=lexbuchlng)
 {
  zeile.append("3");                     // Ende Wortbereich Lexikon
  return zeile;
 }
 else ok=true;
 fseek(dat,tab.idx[j[0]][j[1]][j[2]],0);  // Dateizeiger positionieren

 nf=false;
 while(ok)
 {
  aktidx=ftell(dat);                      // Lesen Dateiposition
  a=lesWort();                            // Lesen Wort für Vergleich (nach vgl)
  if(a<0)
  {
   zeile.append("3");                     // End Lexikondaten
   return zeile;
  }
  if(sp)          // Englisch Wort
  {
   while(vgl[0]<=32 || vgl[0]<0)
   {
    a=lesWort();
    if(a<0)                                 // Hebr. Wort ueberlesen
    {
     zeile.append("3");                     // End Lexikondaten
     return zeile;
    }
   }
  }
  else           // Hebräisch Wort
  {
   while(vgl[0]>0)
   {
    a=lesWort();                            // Engl Wort ueberlesen
    if(a<=0)
    {
     zeile.append("3");                     // End Lexikondaten
     return zeile;
    }
   }
  }
  if(sp)           // Englisch Word modifizieren
  {
   for(i=0;i<80;i++)
     if(vgl[i]==32 || vgl[i]==10 || vgl[i]==0)
                              {
                               x=vgl[i];
                               vgl[i]=0;
                               break;
                              }
  }
  if(strncmp(wort,vgl,strlen(wort))<=0) ok=false; // Vergl Wort (ja=suchen abbrechen)
  if(sp && i<(int)strlen(wort)) ok=true;   // Laengenprfung bei englischem Wort
  if(strcmp(wort,vgl)==0) nf=true;   // Wort gefunden
  if(sp && !ok) vgl[i]=x;
 }

 if(nf)              // Wort gefunden
 {
  while(nf)
  {
   if(vgl[0]<0)
   {
    for(i=0;i<a-1;i++) if(vgl[i]==-33) vgl[i]=45;
    zeile.append(vgl);                           // Schreibe hebr Wort in Zeile
   }
   else
   {
    for(i=0;i<a-1;i++)
    {
     if(vgl[i]==27) vgl[i]=39;
     if(vgl[i]==28) vgl[i]=45;
    }
    zeile.append(vgl);                           // Schreibe engl. Wort in Zeile
   }
   if(sp && vgl[0]<0) ok=true;
   if(!sp && vgl[0]>0) ok=true;
   for(a=0;a<80;a++) vgl[a]=' ';                // Wortspeicher loechen
   a=lesWort();                                 // Worte der anderen Sprache lesen
   if(a<0) nf=false;
   if(!sp && vgl[0]<0) nf=false;
   if(sp && vgl[0]>0) nf=false;
  }
 }                                             // Wort nicht gefunden
 else
 {
  x=strncmp(wort,vgl,strlen(wort));          // Prüfen ob Lexikonwort laenger ist
  if(x!=0 || tab.idx[j[0]][j[1]][j[2]]>=lexbuchlng) zeile.append("2"); //Nein=nicht gefunden
  else zeile.append("1"); // An Vorgabewort (Suchwort) einen Buchstaben anhaengen
 }
 return zeile;
}
/***********************************************************************/
string CLexikon::nextHebWort()
{
 int a,i;
 bool nf=false;
 string zeile="";

 fseek(dat,aktidx,0);            // Datenzeiger positionieren
 a=lesWort();                    // Lesen Wort fuer Vergleich nach vgl
 if(a>0)
 {
  nf=true;
  aktidx+=a+1;                     // Index weitersetzen
 }
 else
 {
  zeile.append("3");                     // Ende Lexikon
  return zeile;
 }

 if(nf)
 {
  while(nf)
  {
   if(vgl[0]<0)
   {
    for(i=0;i<a-1;i++) if(vgl[i]==-33) vgl[i]=45;
    zeile.append(vgl);                           // Schreibe hebr. Wort
   }
   else
   {
    for(i=0;i<a-1;i++)
    {
     if(vgl[i]==27) vgl[i]=39;
     if(vgl[i]==28) vgl[i]=45;
    }
    zeile.append(vgl);                           // Schreibe englisch wort
   }
   for(a=0;a<80;a++) vgl[a]=' ';
   a=lesWort();
   if(a<0) nf=false;
   if(!sprache && vgl[0]<0) nf=false;
   if(sprache && vgl[0]>0) nf=false;
   if(nf) aktidx+=a+1;                            // Index weitersetzen
  }
 }
 return zeile;
}

/***********************************************************************
Private Funktionen
***********************************************************************/
bool CLexikon::ladIndex(int sp)
{
 FILE *e1;
 string verz;
 if(sprache!=sp)
 {
  verz=lbuch_verz;
  if(sp) verz.append("lex/traheb.idx");
  else verz.append("lex/hebtra.idx");
  e1=fopen(verz.c_str(),"r");
  if(e1==NULL) return false;
  if(fseek(e1,0,2)) return false;
  int lng=ftell(e1);              // Dateilaenge
  rewind(e1);
  fread(tab.idxca,1,lng,e1);
  fclose(e1);

  verz=lbuch_verz;
  if(sp) verz.append("lex/traheb.lex");
  else verz.append("lex/hebtra.lex");
  dat=fopen(verz.c_str(),"r");
  if(dat==NULL) return false;
  if(fseek(dat,0,2)) return false;
  lexbuchlng=ftell(dat);           // Dateilaenge
  rewind(dat);
  sprache=sp;
 }

 return true;
}

int CLexikon::lesWort()
{
 int i;
 for(i=0;i<80;i++) vgl[i]=0;        // vgl Speicher löschen
 for(i=0;i<80;i++)
 {
  vgl[i]=fgetc(dat);                // Wort in vgl Speicher eintragen
  if(feof(dat)) return -1;           // Lexikonende erreicht
  if(vgl[i]==10) break;             // Wortende im Lexikon erreicht
 }
 return i;         // Anzahl Buchstaben
}

void CLexikon::setLexBuchVerzeichnis(string v)
{
 lbuch_verz=v;
}
