//
// C++ Implementation: cmatrix
//
// Description:
//
//
// Author: Heinz Schumann <kontakt@heinz-schumann.de>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "cmatrix.h"
#include "math.h"

// Include fuer cout Ausgabe ***********************************************
#include <iostream>
using namespace std;             //      Zum einbinden von cout

CMatrix::CMatrix()
{}
CMatrix::~CMatrix()
{}

int CMatrix::suchMatrix(string buch, string worte, bool in1, bool mod, string datei)
{
  FILE *e1,*e2, *a1;
  string swort="";
  char nrdat[2];
  bool ok;

  setProgressText("Matrix suchen");        // Progressbar starten
  ok = setProgressStatus(100,2);

  if(!mod && schltmodifi)
    hebbuch="999";  // Buch neuoeffnen erzwingen
  if(!openHebBuch(buch))
    return 12;        // Oeffnen Hebr.Buch

  swort=worte;
  if(mod)
    {
      if(modifiBuch(buch))
        return 12;   // modifizieren Bibeltext
      swort=modifiWort(worte);
    }

  int i;
  for(i=0;i<WRTMATRIX;i++)
    {
      bas[i].anzint=0;
      bas[i].lfdsatz=0;
      bas[i].inter=0;
      bas[i].apos=0;
      bas[i].epos=0;
      bas[i].aber=0;
      bas[i].eber=0;
      bas[i].anzbu=0;
      bas[i].proz=0;
      bas[i].abst=0;
      bas[i].distanz=0;
      bas[i].idxint=0;
      bas[i].wrt="";
      erg[i]=bas[i];
    }

  // Prozentwertspeicher fuer Listausgabe
  int prozsp[WRTMATRIX];
  for(i=0;i<WRTMATRIX;i++)
    prozsp[i]=0;

  // Worttabelle aufbauen
  int j,k;
  int anzwrt=0;
  k=swort.size();
  for(i=0;i<WRTMATRIX;i++)
    {
      j=swort.find("\t");
      bas[i].wrt=swort.substr(0,j);
      swort.erase(0,j+1);
      if(bas[i].wrt!="")
        {
          bas[i].wrt=pruefWort(bas[i].wrt);
          bas[i].anzbu=bas[i].wrt.size();
          anzwrt++;
        }
    }

  // Intervallisten erstellen
  int anz;
  int bint;
  int status=0;
  string datnam;

  ok=setProgressStatus(100,1);

  for(i=0;i<anzwrt;i++)
    {
      bint=mindestIntervall(buch, bas[i].wrt, 200,0,999999,0,true); // Bestimmen Intervallbereich fuer 200 ELS
      anz=suchIntervall(buch, bas[i].wrt, 2, bint, 0, 999999, 0, "interlst.zwi", true);
      if(anz<0)
        return abs(anz);                                    // Fehler bei Intervallsuche
      ok=setProgressStatus(100,(i*4)+1);
      if(!ok)
        return 31;                                           // Abbruch durch Benutzer
      bas[i].anzint=anz;
      if(anz!=0)
        {
          status=sortListeIntervall(0, "interlst.zwi", "interlst.zwi"); // Sortieren nach Intervall
          if(status>0)
            return status;
          ok=setProgressStatus(100,(i*4)+2);
          if(!ok)
            return 31;                                           // Abbruch durch Benutzer
          status=ermittleMinimalbereich("interlst.min", "interlst.zwi"); // Ermitteln Minimalbereich
          if(status!=0)
            return status;
          ok=setProgressStatus(100,(i*4)+3);
          if(!ok)
            return 31;                                           // Abbruch durch Benutzer
          sprintf(nrdat,"%.d",i+1);
          datnam="wort";
          datnam.append(nrdat);
          datnam.append(".min");
          status=sortListeIntervall(2, datnam, "interlst.min");       // Sortieren nach Minimalbereich
          if(status!=0)
            return status;
        }
      ok=setProgressStatus(100,(i*4)+4);
      if(!ok)
        return 31;                                           // Abbruch durch Benutzer
    }

  // Aufsuchen der kleinsten Intervalle
  int klin=0;
  j=99999;
  for(i=0;i<anzwrt;i++)
    {
      if(bas[i].anzint<j)
        {
          j=bas[i].anzint;
          klin=i;
        }
    }

  // Ermitteln Wert 100% fuer Progressbar
  int supro=0;
  int zlpro=anzwrt*4;
  if(bas[klin].anzint<ANZELS)
    supro=bas[klin].anzint;
  else
    supro=30;
  supro=supro+zlpro;

  float dislst[ANZELS];
  float modlst[ANZELS];
  float disalt=999999;
  int stzlst[ANZELS];
  int lfdstz=0;
  int lfddat=0;
  int zlstz=0;
  lindnz=999999;
  linalt=999999;

  for(i=0;i<ANZELS;i++)
    dislst[i]=0;
  for(i=0;i<ANZELS;i++)
    modlst[i]=0;
  for(i=0;i<ANZELS;i++)
    stzlst[i]=0;

  // Einlesen ELS Daten zum Wort mit minimalsten Intervallanzahl
  // Oeffnen Eingabedatei
  sprintf(nrdat,"%.d",klin+1);
  datnam="wort";
  datnam.append(nrdat);
  datnam.append(".min");
  string verz=tmp_verz;
  verz.append(datnam);
  e1=fopen(verz.c_str(),"rb");
  if(e1==NULL)
    return 14;

  rewind(e1);

  while(lfdstz<bas[klin].anzint && lfdstz<ANZELS)
    {
      fread(ein.c,1,sizeof(STRINTER),e1);           // Einlesen Werte zum Wort mit kleinsten Intervallanzahl
      if(feof(e1))
        break;
      zlpro++;
      ok=setProgressStatus(supro,zlpro);
      if(!ok)
        return 31;

      // Eintragen der Daten in die Basisdatei
      bas[klin].lfdsatz=lfdstz;
      bas[klin].inter=ein.s.inter;
      bas[klin].apos=ein.s.apos;
      bas[klin].epos=ein.s.epos;
      bas[klin].aber=ein.s.aber;
      bas[klin].eber=ein.s.eber;
      bas[klin].proz=ein.s.proz;
      bas[klin].idxint=ein.s.inter;
      basint=ein.s.inter;                         // Basisdaten eintragen in den header fuer Berechnung Euklid

      if(basint<5)
        basint=50;


      /******* Aufsuchen des kleinsten Abstandes ***************/
      float disdnz=999999;
      int ls=0;
      lfddat=0;
      linalt=999999;
      while(lfddat<anzwrt)
        {
          if(lfddat!=klin && bas[lfddat].anzint)
            {
              // Oeffnen Intervalldatei
              sprintf(nrdat,"%.d",lfddat+1);
              datnam="wort";
              datnam.append(nrdat);
              datnam.append(".min");
              string verz=tmp_verz;
              verz.append(datnam);
              e2=fopen(verz.c_str(),"rb");
              if(e2==NULL)
                return 14;

              // Aufsuchen der minimalen Distanz zu diesem Intervall
              zlstz=0;
              linalt=999999;
              bas[lfddat].idxint=-1;                           // Kein Intervall gefunden vorerst merken
              while(!feof(e2))
                {
                  fread(ein.c,1,sizeof(STRINTER),e2);
                  if(feof(e2))
                    break;
                  zlstz++;
                  // Abstand ermitteln und Satz evt. eintragen
                  for(k=1;k<8;k++)
                    {
                      for(i=0;i<2;i++)
                        {

                          if(i)
                            ls=ein.s.inter*k;
                          else
                            ls=basint*k; // Zeilenbreite als Vielfaches des Intervall
                          if(ls>hebbuchlng/(bas[klin].anzbu))
                            continue;

                          lindnz=abstand(bas[klin].apos,bas[klin].epos,ein.s.apos,ein.s.epos,ls,bas[klin].inter,ein.s.inter);
                          if(lindnz<linalt)
                            eintragen(lfddat, zlstz, ls);
                        }
                    }
                  for(k=1;k<8;k++)
                    {
                      for(i=0;i<2;i++)
                        {

                          if(i)
                            ls=ein.s.inter/k;
                          else
                            ls=basint/k;           // Zeilenbreite als ein Teil des Intervall
                          if(ls<5)
                            continue;

                          lindnz=abstand(bas[klin].apos,bas[klin].epos,ein.s.apos,ein.s.epos,ls,bas[klin].inter,ein.s.inter);
                          if(lindnz<linalt)
                            eintragen(lfddat, zlstz, ls);
                        }
                    }
                }
              fclose(e2);
              if(in1)
                {
                  // Distanz pruefen mit Intervall 1
                  anz=suchIntervall(buch, bas[lfddat].wrt, 1, 1, 0, 999999, 0, "interlst.zwi", true);
                  if(anz>0)
                    {
                      verz=tmp_verz;
                      verz.append("interlst.zwi");
                      e2=fopen(verz.c_str(),"rb");
                      if(e2==NULL)
                        return 14;

                      while(!feof(e2))
                        {
                          fread(ein.c,1,sizeof(STRINTER),e2);
                          if(feof(e2))
                            break;
                          // Abstand ermitteln und Satz evt. eintragen
                          for(k=1;k<8;k++)
                            {
                              ls=basint*k; // Zeilenbreite als Vielfaches des Intervall
                              if(ls>hebbuchlng/bas[klin].anzbu)
                                break;

                              lindnz=abstand(bas[klin].apos,bas[klin].epos,ein.s.apos,ein.s.epos,ls,bas[klin].inter,ein.s.inter);
                              if(lindnz<linalt)
                                eintragen(lfddat, zlstz, ls);
                            }
                          for(k=1;k<8;k++)
                            {
                              ls=basint/k;           // Zeilenbreite als ein Teil des Intervall
                              if(ls<6)
                                break;

                              lindnz=abstand(bas[klin].apos,bas[klin].epos,ein.s.apos,ein.s.epos,ls,bas[klin].inter,ein.s.inter);
                              if(lindnz<linalt)
                                eintragen(lfddat, zlstz, ls);
                            }
                        }
                      fclose(e2);
                    }
                }
            }
          lfddat++;
        }

      // Ermitteln des Minimalbereiches
      int adom=0;
      int edom=999999;
      int proz=0;

      for(i=0;i<anzwrt;i++)
        {
          if(bas[i].eber!=0)
            {
              if(bas[i].aber>adom)
                adom=bas[i].aber;
              if(bas[i].eber<edom)
                edom=bas[i].eber;
            }
          else
            {
              adom=edom=0;
              break;
            }
        }

      if(edom!=0)
        for(i=0;i<anzwrt;i++)
          if(bas[i].apos<adom || bas[i].apos>edom
              || bas[i].epos<adom || bas[i].epos>edom)
            adom=edom=0;

      if(adom<edom)
        proz=((edom-adom)*100)/hebbuchlng;
      else
        adom=edom=0;
      disdnz=0;

      for(i=0;i<anzwrt;i++)
        disdnz=disdnz+bas[i].distanz;
      dislst[lfdstz]=1/disdnz;

      if(proz==0)
        proz=1;
      modlst[lfdstz]=(1/disdnz)*proz;

      if(disalt>disdnz)
        {
          for(i=0;i<anzwrt;i++)
          {
            erg[i]=bas[i];
            prozsp[i]=bas[i].proz;
          }
          disalt=disdnz;
        }
      lfdstz++;                                // Next ELS
    }
  fclose(e1);

  // Sortieren der Abstandswerte
  float maab=0;
  float miab=99999999;
  int gesanz=0;

  for(j=1;j<ANZELS;j++)
    {
      for(i=0;i<j;i++)
        {
          if(modlst[j]>modlst[i])
            {
              maab=modlst[j];
              modlst[j]=modlst[i];
              modlst[i]=maab;
            }
        }
    }

  // Normalisieren der Abstandswerte der untersuchten (30) Matrixen
  maab=0;
  for(i=0;i<ANZELS;i++)
    if(modlst[i]!=0)
      gesanz++;
  for(i=0;i<ANZELS;i++)
    if(modlst[i]!=0 && modlst[i]<miab)
      miab=modlst[i];    // Ermitteln Minimalwert
  for(i=0;i<ANZELS;i++)
    if(modlst[i]!=0)
      modlst[i]-=miab;                     // Reduzieren um Minimalwert
  for(i=0;i<ANZELS;i++)
    if(modlst[i]!=0 && modlst[i]>maab)
      maab=modlst[i];    // Ermitteln Maximalwert
  for(i=0;i<ANZELS;i++)
    if(modlst[i]!=0)
      modlst[i]/=maab;                     // Normalisieren

  // ************** Aufbau der Textmatrix ***********************
  // Bestimmen der Anfang und Endwerte zu den Intervallworten
  int beg=0;
  int end=0;
  int brt=0;

  if(gesanz!=0)                                 // Es wurden Intervalle gefunden
    {
      // Anfang und Ende der Matrix bestimmen
      beg=99999999;
      for(i=0;i<anzwrt;i++)
        {
          if(erg[i].inter)
            {
              if(erg[i].apos<beg)
                beg=erg[i].apos;
              if(erg[i].apos>end)
                end=erg[i].apos;
              if(erg[i].epos<beg)
                beg=erg[i].epos;
              if(erg[i].epos>end)
                end=erg[i].epos;
            }
        }

      // Vorbereiten fuer Matrixermitteln
      int refe=0;
      for(i=0;i<anzwrt;i++)
        {
          refe=0;
          if(erg[i].inter!=0)
            {

              if(erg[i].apos>erg[i].epos)
                {
                  refe=erg[i].apos;
                  erg[i].apos=erg[i].epos;
                  erg[i].epos=refe;
                }
            }
        }

      // Minimale Anordnungsbreite bestimmen
      div_t zw;
      int bre1, bre2;
      int begf=0;
      int begalt=0;
      int intalt=0;
      int bre=999999;
      int begzw=beg;
      int brealt=999999;

      for(k=0;k<anzwrt;k++)
        {
          basint=erg[k].idxint;
          if(basint<8)
            basint=46;
          bre=999999;
          for(i=0;i<basint;i++)
            {
              bre1=999999;
              bre2=0;
              for(j=0;j<anzwrt;j++)
                {
                  if(erg[j].inter!=0)
                    {
                      ok=inFlaeche(begzw,basint,erg[j].apos,erg[j].inter,erg[j].anzbu);
                      if(ok)
                        {
                          zw=div(erg[j].apos-begzw,basint);
                          if(bre1>zw.rem)
                            bre1=zw.rem;
                          if(bre2<zw.rem)
                            bre2=zw.rem;
                          zw=div(erg[j].epos-begzw,basint);
                          if(bre1>zw.rem)
                            bre1=zw.rem;
                          if(bre2<zw.rem)
                            bre2=zw.rem;
                        }
                    }
                  if(!ok)
                    break;
                }
              if(ok && (bre2-bre1)<bre)
                {
                  bre=bre2-bre1;
                  begf=begzw;
                }
              begzw--;
            }
          if(bre<brealt)
            {
              brealt=bre;
              begalt=begf+1;
              intalt=basint;
            }
        }
      if(brealt!=999999)
        {
          bre=brealt;
          bre++;
          beg=begalt;
          basint=intalt;
        }
      else
        {
          gesanz=99;
          bre=basint;
        }

      beg=beg-((basint-bre)/2);                      // zum zentrieren Schnittlinie verschieben

      brt=basint;
      if(basint>46 && basint>bre)
        {
          if(bre<46)
            brt=46;
          else
            brt=bre+8;
          beg=beg-(basint-((basint-brt)/2));
        }

      int hoe=((end-beg)/basint);                       // Anzahl Zeilen
      while(hoe<28)                                     // Hoehe erweitern auf 28 Zeilen
        {
          beg=beg-basint;
          end=end+basint;
          hoe+=2;
        }

      // Bestimmen Endposition der Darstellung
      end=(hoe*basint)+beg;
      if(end>hebbuchlng-1)
        end=hebbuchlng-1;
      while(beg<0)
        beg+=basint;
 // cout<<beg<<", "<<end<<", "<<brt<<", "<<hoe<<", "<<basint<<", "<<bre<<"/ "
//<<erg[0].apos<<", "<<erg[0].inter<<": "<<erg[1].apos<<", "<<erg[1].inter<<":" <<erg[2].apos<<", "<<erg[2].inter<<endl;
    }
  // Kompaktheit ermitteln
  float komp=0;
  k=0;

  for(i=0;i<anzwrt;i++)
    {
      for(j=i+1;j<anzwrt;j++)
        {
          komp+=kompakt(erg[i].apos,erg[i].epos,erg[j].apos,erg[j].epos,basint);
          k++;
        }
    }
  komp=komp/k;


  // Oeffnen Ausgabedatei
  verz=out_verz;
  verz.append(datei);
  a1=fopen(verz.c_str(),"w+b");
  if(a1==NULL)
    return 13;

  char zwsp[15];
  string zeile=" Darstellung der Textmatrix aus dem Buch ";
  strcpy(zwsp,buch.c_str());                       // Buchnamen in Grossbuchstaben
  for(i=0;i<(int)strlen(zwsp);i++)
    zwsp[i]=toupper(zwsp[i]);
  zeile.append(zwsp);
  zeile.append("\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);
  /*
    zeile=" : ";
    for(i=0;i<anzwrt;i++)
      zeile.append(erg[i].wrt+", ");
    zeile.append("\n\n");
   
    fwrite(zeile.c_str(),1,zeile.length(),a1);
  */
  zeile=" Textausschnitt mit Zeilenbreite";
  sprintf(zwsp,"% d",basint);             // Zeilenbreite
  zeile.append(zwsp);
  zeile.append("\n");
  zeile.append(" bei Darstellung von");
  //  zeile="Textausschnitt bei Darstellung von ";
  sprintf(zwsp,"% d",brt);
  zeile.append(zwsp);
  zeile.append(" Buchstaben/Zeile\n");
  zeile.append(" von Position ");
  sprintf(zwsp,"% d",beg);
  zeile.append(zwsp);
  zeile.append(" (");
  posKap(buch, beg);
  zeile.append(kap_vers);
  zeile.append(") bis Position ");
  sprintf(zwsp,"% d",end);
  zeile.append(zwsp);
  zeile.append(" (");
  posKap(buch, end);
  zeile.append(kap_vers);
  zeile.append(")\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);
  zeile=" \n";
  fwrite(zeile.c_str(),1,zeile.length(),a1);
  for(i=0;i<anzwrt;i++)
    {
      if(erg[i].inter==0)                                  // Keine Intervalle gefunden
        {
          zeile="\nZu Wort ";
          zeile.append(erg[i].wrt);
          zeile.append(" keine passenden Intervalle gefunden\n");
          fwrite(zeile.c_str(),1,zeile.length(),a1);
          gesanz=0;
        }
      zeile="Wort ";
      sprintf(zwsp,"% d",i+1);
      zeile.append(zwsp);
      zeile.append("   ");
      zeile.append(erg[i].wrt);
      zeile.append("\t Intervall ");
      sprintf(zwsp,"% d",erg[i].inter);
      zeile.append(zwsp);
      zeile.append("\t von Position ");
      sprintf(zwsp,"% d",erg[i].apos);
      zeile.append(zwsp);
      zeile.append("\t Maximalbereich ");
      sprintf(zwsp,"% d",erg[i].proz);
      zeile.append(zwsp);
      zeile.append("%\n");
      fwrite(zeile.c_str(),1,zeile.length(),a1);
    }
  if(gesanz==0)
    {
      zeile="Es wurde keine Textmatrix erstellt \n";
      fwrite(zeile.c_str(),1,zeile.length(),a1);
      fclose(a1);
      setProgressStop();
      return 3;
    }
  if(gesanz==99)
    {
      zeile="Darstellung als gueltige Textmatrix nicht moeglich \n";
      fwrite(zeile.c_str(),1,zeile.length(),a1);
    }

  /*
    zeile="Kompaktheitswert: ";
    maab=modlst[0]-modlst[1];
    sprintf(zwsp,"% .7f",komp);
    zeile.append(zwsp);
    zeile.append(" Abstandswert: ");
    sprintf(zwsp,"% .7f",maab);
    zeile.append(zwsp);
    if(maab==1)
      zeile.append(", es wurden wehniger als 3 Matrix gefunden");
    if(maab==0)
      zeile.append(", Bewertung der Matrix nicht moeglich");
    zeile.append("\n");
    fwrite(zeile.c_str(),1,zeile.length(),a1);
   
    zeile="Die Anordnung als Matrix ist ";
    if(maab>=0.0)
      {
        if(maab>0.5)
          zeile.append("sehr wahrscheinlich");
        else if(maab>0.4)
          zeile.append("wahrscheinlich");
        else if(maab>0.2)
          zeile.append("unwahrscheinlich");
        if(maab<0.2)
          zeile.append("nicht zutreffend");
      }
    zeile.append("\n");
    fwrite(zeile.c_str(),1,zeile.length(),a1);
  */
  // Matrix schreiben
  int f;
  char mbu[3];

  // Matrixdaten fuer Listensteuerung
  zeile="\v";
  sprintf(zwsp,"% d",brt);
  zeile.append(zwsp);
  zeile.append("\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  mbu[1]=0;
  while(beg<end)
    {
      j=0;
      zeile="";
      while(j<basint)
        {
          f=0;
          for(i=0;i<anzwrt;i++)
            {
              if(erg[i].apos==beg)
                {
                  f=i+3;
                  sprintf(zwsp,"%.1d",f);
                  if(erg[i].apos<erg[i].epos)
                    erg[i].apos+=erg[i].inter;
                }
            }
          i=lesHebBuchstaben(buch,beg);
          mbu[0]=heb_buchst;
          if(j<brt)
            {
              zeile.insert(0,mbu);
              if(f)
                {
                  zeile.insert(0,zwsp);
                  zeile.insert(0,"\f");
                }
              zeile.insert(0,"\t");
            }
          j++;
          beg++;
          if(beg>(int)hebbuchlng)
            break;
        }
      zeile.append("\n");
      fwrite(zeile.c_str(),1,zeile.length(),a1);
      if(beg>(int)hebbuchlng)
        break;
    }
  fclose(a1);
  setProgressStop();
  return 0;
}

float CMatrix::abstand(int pa1, int pe1, int pa2, int pe2, int inl, int in1, int in2)
{
  float refe1=0;
  float refe2=0;
  refe1=wurzel(pa1,pe2,inl);
  refe2=wurzel(pe1,pe2,inl);
  if(refe1>refe2)
    refe1=refe2;
  refe2=wurzel(pa1,pa2,inl);
  if(refe1>refe2)
    refe1=refe2;
  refe2=wurzel(pe1,pa2,inl);
  if(refe1>refe2)
    refe1=refe2;
  refe1+=wurzel(pa1,pa1+in1,inl);
  refe1+=wurzel(pa2,pa2+in2,inl);
  return refe1;
}

float CMatrix::kompakt(int pa1, int pe1, int pa2, int pe2, int inl)
{
  float refe1=0;
  float refe2=0;
  refe1=wurzel(pa1,pe2,inl);
  refe2=wurzel(pe1,pe2,inl);
  if(refe1>refe2)
    refe1=refe2;
  refe2=wurzel(pa1,pa2,inl);
  if(refe1>refe2)
    refe1=refe2;
  refe2=wurzel(pe1,pa2,inl);
  if(refe1>refe2)
    refe1=refe2;
  return refe1;
}

float CMatrix::wurzel(int p1, int p2, int s)
{

  // Abstand nach Phytagoras berechnen
  float wur=0;
  div_t dp1,dp2;

  dp1=div(p1,s);
  dp2=div(p2,s);
  dp1.quot=abs(dp1.quot-dp2.quot);
  dp1.rem=abs(dp1.rem-dp2.rem);

  if(dp1.rem!=0 && dp1.quot!=0)
    wur=hypot((double)dp1.rem,(double)dp1.quot);
  if(dp1.rem==0)
    wur=(float)dp1.quot;
  if(dp1.quot==0)
    wur=(float)dp1.rem;
  return wur;
}

void CMatrix::eintragen(int lfddat, int zlstz, int ls)
{
  bas[lfddat].lfdsatz=zlstz;
  bas[lfddat].inter=ein.s.inter;
  bas[lfddat].apos=ein.s.apos;
  bas[lfddat].epos=ein.s.epos;
  bas[lfddat].proz=ein.s.proz;
  bas[lfddat].aber=ein.s.aber;
  bas[lfddat].eber=ein.s.eber;
  bas[lfddat].abst=int(lindnz);
  bas[lfddat].distanz=lindnz;
  bas[lfddat].idxint=ls;
  linalt=lindnz;
}
