/***************************************************************************
                          cnachbar.cpp  -  description
                             -------------------
    begin                : Thu Nov 1 2001
    copyright            : (C) 2001 by Heinz Schumann
    email                : heinz.schumann@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <math.h>
#include <stdio.h>

#include "cnachbar.h"

#include <iostream>
using namespace std;

CNachbar::CNachbar()
{}
CNachbar::~CNachbar()
{}


/******************************************************************/
float CNachbar::berechneNachbar(int anzwrt, string datei="gruppen.nbr",
                                bool norma=true)
{
  FILE *e1;
  UNIINTER ein;
  UNIGRP gra;
  STRNBR fld[MAXWRT][ANZELS];
  STRGRP grp[ANZGRP];

  int refe=0;
  int lw,ls,lg,i,j;

  for(lw=0;lw<3;lw++)
    for(ls=0;ls<ANZELS;ls++)
      fld[lw][ls].inter=999999;


  // Oeffnen Eingabedatei
  string verz=tmp_verz;
  verz.append("wort1.nbr");
  e1=fopen(verz.c_str(),"rb");
  if(e1==NULL)
    return 14;

  // Einlesen ELS Daten Wort1
  rewind(e1);
  for(ls=0;ls<ANZELS;ls++)
    {
      fread(ein.c,1,sizeof(STRINTER),e1);
      if(feof(e1))
        break;
      fld[0][ls].inter=ein.s.inter;
      fld[0][ls].apos=ein.s.apos;
      fld[0][ls].epos=ein.s.epos;
      fld[0][ls].richt=ein.s.richt;
      fld[0][ls].proz=ein.s.proz;
      fld[0][ls].aber=ein.s.aber;
      fld[0][ls].eber=ein.s.eber;
    }
  fclose(e1);

  // Oeffnen Eingabedatei
  verz=tmp_verz;
  verz.append("wort2.nbr");
  e1=fopen(verz.c_str(),"rb");
  if(e1==NULL)
    return 14;

  // Einlesen ELS Daten Wort2
  rewind(e1);
  for(ls=0;ls<ANZELS;ls++)
    {
      fread(ein.c,1,sizeof(STRINTER),e1);
      if(feof(e1))
        break;
      fld[1][ls].inter=ein.s.inter;
      fld[1][ls].apos=ein.s.apos;
      fld[1][ls].epos=ein.s.epos;
      fld[1][ls].richt=ein.s.richt;
      fld[1][ls].proz=ein.s.proz;
      fld[1][ls].aber=ein.s.aber;
      fld[1][ls].eber=ein.s.eber;
    }
  fclose(e1);

  if(anzwrt==3)
    {
      // Oefnen Eingabedatei
      verz=tmp_verz;
      verz.append("wort3.nbr");
      e1=fopen(verz.c_str(),"rb");
      if(e1==NULL)
        return 14;

      // Einlesen ELS Daten Wort3
      rewind(e1);
      for(ls=0;ls<ANZELS;ls++)
        {
          fread(ein.c,1,sizeof(STRINTER),e1);
          if(feof(e1))
            break;
          fld[2][ls].inter=ein.s.inter;
          fld[2][ls].apos=ein.s.apos;
          fld[2][ls].epos=ein.s.epos;
          fld[2][ls].richt=ein.s.richt;
          fld[2][ls].proz=ein.s.proz;
          fld[2][ls].aber=ein.s.aber;
          fld[2][ls].eber=ein.s.eber;
        }
      fclose(e1);
    }

  // Ermitteln Linearabstand ELS
  for(lw=0;lw<anzwrt;lw++)
    {
      for(ls=0;ls<ANZELS;ls++)
        {
          if(fld[lw][ls].inter==999999)
            break;
          fld[lw][ls].satz[lw]=ls;

          // Berechne minimal Liniarabstand der Nachbarwoerter
          for(i=0;i<MAXWRT;i++)
            fld[lw][ls].entf[i]=999999;

          for(i=0;i<anzwrt;i++)
            if(i!=lw)
              for(j=0;j<ANZELS;j++)
                {
                  if(fld[i][j].inter==999999)
                    break;
                  fld[i][j].tmp=999999;
                  refe=abs(fld[lw][ls].apos-fld[i][j].apos);
                  if(fld[i][j].tmp>refe)
                    fld[i][j].tmp=refe;
                  refe=abs(fld[lw][ls].epos-fld[i][j].epos);
                  if(fld[i][j].tmp>refe)
                    fld[i][j].tmp=refe;
                  refe=abs(fld[lw][ls].apos-fld[i][j].epos);
                  if(fld[i][j].tmp>refe)
                    fld[i][j].tmp=refe;
                  refe=abs(fld[lw][ls].epos-fld[i][j].apos);
                  if(fld[i][j].tmp>refe)
                    fld[i][j].tmp=refe;
                  if(fld[lw][ls].entf[i]>fld[i][j].tmp)
                    {
                      fld[lw][ls].entf[i]=fld[i][j].tmp;
                      fld[lw][ls].satz[i]=j;
                    }
                }
        }
    }

  // Initialisieren Gruppenspeicher
  for(lg=0;lg<ANZGRP;lg++)
    {
      grp[lg].entf=999999;
      grp[lg].seq=0;
      grp[lg].abst=0.0;
      grp[lg].koab=0.0;
      grp[lg].proz=0;
      for(j=0;j<MAXWRT;j++)
        grp[lg].els[j]=0;
    }

  // Summieren Liniarabsteande zu allen Worten
  // und uebertragen in den Gruppenspeicher
  for(lw=0;lw<anzwrt;lw++)
    for(ls=0;ls<ANZELS;ls++)
      {
        if(fld[lw][ls].inter==999999)
          break;
        refe=0;
        for(i=0;i<anzwrt;i++)
          if(fld[lw][ls].entf[i]<999999)
            refe+=fld[lw][ls].entf[i];

        // Einsortieren in die Ausgeweahlten Gruppen
        lg=0;
        while(grp[lg].entf<=refe && lg<ANZGRP)
          lg++;

        if(lg<ANZGRP)
          {
            for(j=ANZGRP-1;j>lg;j--)
              grp[j]=grp[j-1];
            grp[lg].entf=refe;
            for(j=0;j<anzwrt;j++)
              grp[lg].els[j]=fld[lw][ls].satz[j];

            // Suche gleiche Gruppen und loeschen einer davon
            for(j=0;j<ANZGRP;j++)
              {
                if(grp[j].entf==999999)
                  break;
                if(j!=lg)
                  {
                    i=0;
                    while(i<anzwrt && grp[lg].els[i]==grp[j].els[i] && grp[j].entf<999999)
                      i++;
                    if(i==anzwrt)
                      {
                        if(lg<j)
                          i=j;
                        else
                          i=lg;
                        for(j=i;j<ANZGRP-1;j++)
                          grp[j]=grp[j+1];
                        grp[ANZGRP-1].entf=999999;
                      }
                  }
              }
          }
      }

  // Berechne den Maximalbereich und den euklidischen Abstand der Gruppen
  for(lg=0;lg<ANZGRP;lg++)
    {
      if(grp[lg].entf!=999999)
        {
          for(i=0;i<anzwrt;i++)
            {
              aber[i]=fld[i][grp[lg].els[i]].aber;
              eber[i]=fld[i][grp[lg].els[i]].eber;
              apos[i]=fld[i][grp[lg].els[i]].apos;
              epos[i]=fld[i][grp[lg].els[i]].epos;
              inter[i]=fld[i][grp[lg].els[i]].inter;
              prozi[i]=fld[i][grp[lg].els[i]].proz;
            }

          abstand(anzwrt,hebbuchlng);
          grp[lg].proz=proz;
          grp[lg].abst=abst;
          grp[lg].seq=seq;
          grp[lg].koab=1.0/abst;
          grp[lg].adom=adom;
          grp[lg].edom=edom;
          if(proz!=0)
            grp[lg].koab*=proz;
        }
      else
        {
          grp[lg].proz=0;
          grp[lg].abst=999999;
          grp[lg].seq=seq;
          grp[lg].koab=0.0;
          grp[lg].adom=adom;
          grp[lg].edom=edom;
        }
    }

  // Sortieren der Gruppen nach euklidischen Abstand
  STRGRP zwi;
  float sum=0.0;
  for(lg=1;lg<ANZGRP;lg++)
    {
      sum+=grp[lg].koab;
      for(i=0;i<lg;i++)
        {
          if(grp[lg].koab>grp[i].koab)
            {
              zwi=grp[lg];
              grp[lg]=grp[i];
              grp[i]=zwi;
            }
        }
    }

  // Normalisierung der Grupenwerte
  float misp,masp;
  if(norma)
    {
      misp=grp[ANZGRP-1].koab; // Minimalwert
      for(lg=0;lg<ANZGRP;lg++)
        grp[lg].koab-=misp;  // Reduzieren um Minimalwert
      masp=grp[0].koab;  // Maximalwert

      // Normalisierung
      for(lg=0;lg<ANZGRP;lg++)
        grp[lg].koab/=masp;
    }

  float diff=grp[0].koab-grp[1].koab; // Differenz zur zweiten Gruppe

  // Oeffnen Ausgabedatei
  FILE *a1;
  verz=tmp_verz;
  verz.append(datei);
  a1=fopen(verz.c_str(),"w+b");
  if(a1==NULL)
    return 13;

  // Daten umlagern und ausgeben
  for(lg=0;lg<ANZGRP;lg++)
    {
      gra.s.entf=grp[lg].entf;
      gra.s.seq=grp[lg].seq;
      gra.s.proz=grp[lg].proz;
      gra.s.adom=grp[lg].adom;
      gra.s.edom=grp[lg].edom;
      gra.s.abst=grp[lg].abst;
      gra.s.koab=grp[lg].koab;
      for(i=0;i<MAXWRT;i++)
        gra.s.aber[i]=fld[i][grp[lg].els[i]].aber;
      for(i=0;i<MAXWRT;i++)
        gra.s.eber[i]=fld[i][grp[lg].els[i]].eber;
      for(i=0;i<MAXWRT;i++)
        gra.s.apos[i]=fld[i][grp[lg].els[i]].apos;
      for(i=0;i<MAXWRT;i++)
        gra.s.epos[i]=fld[i][grp[lg].els[i]].epos;
      for(i=0;i<MAXWRT;i++)
        gra.s.els[i]=fld[i][grp[lg].els[i]].inter;
      for(i=0;i<40;i++)
        gra.s.heb[i]=0;
      fwrite(gra.c,1,sizeof(STRGRP),a1);
    }
  fclose(a1);

  return diff;
}
/********************************************************************/
int CNachbar::nbrFindHebWorte(string buch, string wort, int intervall, int pos,
                              int wrtlst=200,
                              string outdatei="hebwrtls.nbr",
                              string wrtbuch="kuhebdeu.lex")
{
  suinter=intervall;
  lexwrt=wrtlst;             // Max. Anzahl von Woertern in Liste
  if(lexwrt==0 || lexwrt>MAXLEXWRT)
    lexwrt=MAXLEXWRT;
  anzbu=wort.length();

  setProgressText("Worte in Textmatrix aufsuchen");        // Progressbar starten
  setProgressStatus(100,10);
  if(!openHebBuch(buch))
    return -13;
  modifiBuch(buch);

  // Pruefen des Intervall und der Beginposition des Vorgabewortes
  int pr=0;
  int l=0;
  for(l=0;l<anzbu;l++)
    {
      pr=lesHebBuchstaben(buch,pos+(l*intervall));
      if(pr!=0)
        return pr*-1;
      if(heb_buchst!=wort.at(l))
        if(heb_buchst!=wort.at(anzbu-(l+1)))             // Pruefen Schreibweise Rueckwaerts
          return -3;
    }

  // Berechne Textbereich
  int beg=pos;
  int end=pos;
  bool klint=false;

  if(intervall<8)
    {
      klint=true;
      if((intervall*anzbu)<ZLBRT)
        zlbrt=ZLBRT;
      else
        zlbrt=intervall*anzbu;
    }
  else
    zlbrt=intervall;

  end=pos+((anzbu-1)*intervall);             // Endposition des Suchwortes
  if(end>hebbuchlng-1)
       return -3;

  int anzl=0;                               // Anzahl Zeilen ermitteln
  if(klint)
  {
    anzl=ZLHOE;
    beg=beg-(((ZLHOE/2)*zlbrt)-(abs(end-beg)/2));      // Wort vertikal in die Mitte schieben
  }
  else
  {
    anzl=1+((end-beg)/zlbrt);                  // Worthoehe in Zeilen
    beg=beg-(((ZLHOE/2)-(anzl/2))*zlbrt);      // Wort vertikal in die Mitte schieben
  }

  while(beg<0)
    beg+=intervall;                     // Pruefen auf Textbeginn und evt.korrigieren

  if(zlbrt>ZLBRT)
    beg=beg-(ZLBRT/2);                       // Wort horizontal in die Mitte schieben
  else
    beg=beg-(zlbrt/2);

  while(beg<0)
    beg+=intervall;                    // Pruefen auf Textbeginn und evt.korrigieren

  end=beg+(ZLHOE*zlbrt);               // Darstellungsbereich Ende
  if(end>hebbuchlng)
    end=hebbuchlng-1;

  int suwrtpos=pos;
  begpos=beg;
  int endpos=end;
  int z=0;

  // Datenfeld fuer Suche im Lexikon vorbereiten
  anzl=(endpos-begpos)/zlbrt;
  if(zlbrt<ZLBRT)
    z=zlbrt;
  else
    z=ZLBRT;

  // Position des Suchwortes im Datenfeld ermitteln
  div_t erg=div((suwrtpos-begpos),zlbrt);
  spsuwrt=erg.rem+1;
  zlsuwrt=erg.quot+1;
  begsuwrt=(erg.quot*z)+erg.rem;
  endsuwrt=begsuwrt+((anzbu-1)*z);
  // int begfldpos=0;
  int endfldpos=0;
  int anzzl=0;

  // Schreibe Datenfeld
  int lfd=begpos;
  int status=0;
  char *fidaten;
  fidaten=new char[ANZZL*(z+1)];
  for(int i=0;i<ANZZL*(z+1);i++)
    fidaten[i]=' ';    // Datenbereich loeschen
  
  while(lfd<endpos)
    {
      if((lfd+z+1)>hebbuchlng-1)
        z=hebbuchlng-lfd-1;
      status=lesHebAbschnitt(buch, lfd,lfd+z+1);
      if(status)
        return status*-1;
      if(lfd<0)    // Beginn mit Leerzeichen wenn Textfeldanfang vor Buchanfang liegt
        {
          int zwrt=abs(lfd)-1;
          heb_out_abschn.erase(0,zwrt);
          for(int i=0;i<zwrt;i++)
            heb_out_abschn.insert(0," ");
        }
      for(int c=0;c<z;c++)
        {
          fidaten[endfldpos]=heb_out_abschn.at(c);  // Eintragen in Datenfeld
          endfldpos++;
        }
      anzzl++;
      lfd+=zlbrt;
    }
  endfldpos--;
  if(zlbrt>ZLBRT)
    zlbrt=ZLBRT;         // Neue Zeilenlaenge

  // Suche im Lexikon vorbereiten
  lex=new CWortBuch();
  status=lex->openWortBuch(buch_verz,wrtbuch,true);  // Wortbuch oeffnen (Hebr. sortiert)
  if(status)
    return anzgef=status*-1;
  fisor=new STRHEBWRT[MAXLEXWRT+2];           // Gefundene Worte zwischenspeichern
  for (int m=0;m<MAXLEXWRT;m++)
    fisor[m].abst=0;

  // Suche im Lexikon
  int maxint;
  int zlpro=0;
  int lfdch=0;
  int lfdzl=0;
  bool ok;
  beglfdzl=0;
  anzgef=0;
  anzwrt=0;
  anzchar=0;
  lfdint=0;
  fak=1;
  faki=1;

  pr=(anzzl*3)+(zlbrt*3);                         // max Steps fuer Progressbar
  int lfpr=1;

  // Such Worte in den Zeilen (Waagerecht)
  maxint=zlbrt/5;
  gef.la='W';                                     // Wortgeometrie Waagerecht

  while(lfdzl<anzzl)
    {
      zlpro++;
      lfdint=1;
      while(lfdint<=maxint)
        {
          for(int i=0;i<MAXBRT;i++)
            text[i]=0;
          lfdch=0;
          anzchar=0;
          while(lfdch<zlbrt)       // Erzeuge Buchstabenkette entspr. lfd Intervall
            {
              text[anzchar]=fidaten[lfdzl*zlbrt+lfdch];
              anzchar++;
              lfdch+=lfdint;
            }
          beglfdzl=(lfdzl*zlbrt);
          check(); // Pruefe Buchstabenzeile auf gueltige Worte mit eintragen in Speicher sort
          lfdint++;
        }
      lfdzl++;
      lfpr++;
      ok=setProgressStatus(pr,lfpr);
      if(!ok)
        return -31;
    }

  // Such Worte in den Spalten (Senkrecht)
  maxint=anzzl/4;
  lfdzl=0;
  lfdch=0;
  if(intervall<8)
    faki=ZLBRT;
  else
    faki=intervall;
  fak=zlbrt;
  gef.la='S';
  while(lfdch<zlbrt)
    {
      lfdint=1;
      zlpro++;
      while(lfdint<=maxint)
        {
          for(int i=0;i<MAXBRT;i++)
            text[i]=0;
          lfdzl=0;
          anzchar=0;
          while(lfdzl<anzzl)         // Erzeuge Buchstabenkette entspr.lfd Intervall
            {
              text[anzchar]=fidaten[lfdzl*zlbrt+lfdch];
              anzchar++;
              lfdzl+=lfdint;
            }
          beglfdzl=lfdch;
          check();
          lfdint++;
        }
      lfdch++;
      lfpr++;
      ok=setProgressStatus(pr,lfpr);
      if(!ok)
        return -31;
    }

  // Such Worte in Diagonale von links nach rechts
  char zw[MAXBRT];
  int  lfdpos;
  int  lng;

  lfdzl=0;
  lfdch=3;
  if(intervall<8)
    faki=ZLBRT-1;
  else
    faki=intervall-1;
  fak=zlbrt-1;
  gef.la='R';
  while(lfdch<zlbrt && lfdzl<anzzl-3)
    {
      zlpro++;
      lfdpos=lfdch+(lfdzl*zlbrt);
      for(int i=0;i<MAXBRT;i++)
        zw[i]=0;
      lng=0;
      do
        {
          zw[lng]=fidaten[lfdpos];
          lng++;
          lfdpos+=fak;
          erg=div(lfdpos,zlbrt);
          if(erg.rem==0 || lfdpos>endfldpos)
            break;
        }
      while(lfdpos<endfldpos);

      maxint=lng/4;
      lfdint=1;
      while(lfdint<=maxint)
        {
          for(int i=0;i<MAXBRT;i++)
            text[i]=0;
          anzchar=0;
          lfdpos=0;
          while(lfdpos<lng)              // Erzeuge Buchstabenkette entspr. lfd Intervall
            {
              text[anzchar]=zw[lfdpos];
              anzchar++;
              lfdpos+=lfdint;
            }
          beglfdzl=lfdch+(lfdzl*zlbrt);
          check();
          lfdint++;
        }
      if(lfdch<zlbrt-1)
        lfdch++;
      else
        lfdzl++;
      lfpr++;
      ok=setProgressStatus(pr,lfpr);
      if(!ok)
        return -31;
    }

  // Such Worte in Diagonale von rechts nach links
  lfdzl=anzzl-4;
  lfdch=0;
  if(intervall<8)
   faki=ZLBRT+1;
  else 
    faki=intervall+1;
  fak=zlbrt+1;
  gef.la='L';
  while(lfdch<zlbrt-3)
    {
      zlpro++;
      lfdpos=lfdch+(lfdzl*zlbrt);
      for(int i=0;i<MAXBRT;i++)
        zw[i]=0;
      lng=0;
      do
        {
          zw[lng]=fidaten[lfdpos];
          lng++;
          lfdpos+=fak;
          erg=div(lfdpos,zlbrt);
          if(erg.rem==zlbrt-1 || lfdpos>endfldpos)
            break;
        }
      while(lfdpos<endfldpos);

      maxint=lng/4;
      lfdint=1;
      while(lfdint<=maxint)
        {
          for(int i=0;i<MAXBRT;i++)
            text[i]=0;
          anzchar=0;
          lfdpos=0;
          while(lfdpos<lng)              // Erzeuge Buchstabenkette entspr. lfd Intervall
            {
              text[anzchar]=zw[lfdpos];
              anzchar++;
              lfdpos+=lfdint;
            }
          if(lfdzl)
            beglfdzl=lfdzl*zlbrt;
          else
            beglfdzl=lfdch;
          check();
          lfdint++;
        }
      if(lfdzl==0)
        lfdch++;
      else
        lfdzl--;
      lfpr++;
      ok=setProgressStatus(pr,lfpr);
      if(!ok)
        return -31;
    }

  delete lex;
  delete fidaten;

  // Oeffnen Ausgabedatei
  FILE *a1;
  string verz=tmp_verz;
  verz.append(outdatei);
  a1=fopen(verz.c_str(),"w+b");
  if(a1==NULL)
    return -13;

  UNIHEBWRT aus;

  // Daten umlagern und ausgeben

  for(int k=0;k<anzwrt;k++)
    {
      aus.s.abst=fisor[k].abst;               // Euklidischer Abstand zum Basiswort
      aus.s.pos=fisor[k].pos;                 // Beginnposition des Wortes
      aus.s.seq=fisor[k].seq;                 // Intervall des Wortes
      aus.s.zl=fisor[k].zl;                   // Nr. Zeile im Datenfeld
      aus.s.sp=fisor[k].sp;                   // Nr. Spalte im Datenfeld
      aus.s.ri=fisor[k].ri;                   // Leserichtung
      aus.s.la=fisor[k].la;                   // Lage im Datenfeld
      for(int j=0;j<MAXWRTLNG;j++)
        {
          aus.s.heb[j]=fisor[k].heb[j]; // Gefundenes Wort (hebr)
          aus.s.deu[j]=fisor[k].deu[j]; // Gefundenes Wort (deutsch)
        }
      fwrite(aus.c,1,sizeof(STRHEBWRT),a1);
    }
  fclose(a1);
  delete fisor;
  setProgressStop();
  return anzgef;
}
/******************************************************************/
int CNachbar::suchHebNachbar(string buch,
                             char vonbu=-32,
                             char bisbu=-6,
                             string outdatei="signbrls.bta",
                             string wrtbuch="kuhebdeu.lex")
{
  if(!openHebBuch(buch))
    return -12;

  setProgressText("Nachbarschaftsworte suchen");        // Progressbar starten
  int ok=setProgressStatus(100,1);
  if(!ok)
    return -31;

  lex=new CWortBuch();
  ok=lex->openWortBuch(buch_verz,wrtbuch,true);   // Buchverzeichniss fuer Woerterbuch
  if(ok!=0)
    return ok*-1;

  FILE *e1;
  UNIGRP ein;
  string zeile="";
  char deuwrt[MAXWRTLNG];
  char gefwrt[MAXWRTLNG];
  char zwrt[MAXWRTLNG];
  char vglbu;
  // char bu[3];
  // int fw=0;
  int status=0;
  int anz=0;
  int bint=0;
  int anzgef=0;
  int anzwrt=0;
  int i,j,k;
  float abst=0.0;

  int pr=abs(vonbu-bisbu)+1;
  int lfpr=1;
  int vglpr=0;

  // Oeffnen Ausgabedatei
  FILE *a1;
  string verz=tmp_verz;
  verz.append(outdatei);
  a1=fopen(verz.c_str(),"w+b");
  if(a1==NULL)
    return -13;

  status=lex->nextWort();
  if(status!=0)
    return -15;
  anzwrt++;

//  nbr_von_inter=2;                         // Von Intervall

  // Hebr. und Deutsch Wort uebertragen
  for(i=0;i<MAXWRTLNG;i++)
    zwrt[i]=0;
  for(i=0;i<MAXWRTLNG;i++)
    deuwrt[i]=0;
  i=lex->strwrb.lndeuwrt;
  k=lex->strwrb.deuwrb.copy(deuwrt,i);
  j=lex->strwrb.lnhebwrt;
  k=lex->strwrb.hebwrb.copy(zwrt,j);
  vglbu=zwrt[0];

  while(zwrt[0]<=bisbu && zwrt[0]!='3')
    {
      if(vglpr!=zwrt[0])
        {
          vglpr=zwrt[0];
        }
      for(i=0;i<20;i++)
        gefwrt[i]=0;
      j=0;
      for(i=0;i<20;i++)
        {
          if(zwrt[i]!=32 && zwrt[i]!=45)
            gefwrt[i-j]=zwrt[i];
          else
            j++;                             // Leerzeichen ausblenden
        }

      //cout<<gefwrt<<" ->"<<anzwrt<<"/"<<anzgef<<" :"<<zeile.length()<<"/"<<i-j<<":: ";

      for(i=0;i<MAXWRTLNG;i++)
        if(gefwrt[i]==0)
          break;   //  Laenge Suchwort
      if(i>2 && i<8 && zeile.length()<MAXHEBLNG)  //  Wortlaenge 3 bis 7 Buchstaben
        {
          // Wort2 vorbereiten
          bint=mindestIntervall(buch, gefwrt, ANZELS+5,nbr_von_inter,999999,0,true); // Bestimmen Intervallbereich fuer 30 ELS
          anz=suchIntervall(buch, gefwrt, nbr_von_inter, bint, 0, 999999, 0, "interlst.zwi", true);
          if(anz<0)
            return abs(anz);
          if(anz>0)                                     // Intervalle gefunden
            {
              status=sortListeIntervall(0,"interlst.sor","interlst.zwi");   // Sortieren nach Intervall
              if(status!=0)
                return status;
              status=ermittleMinimalbereich("wort2.nbr", "interlst.sor");
              if(status!=0)
                return status;
              abst=berechneNachbar(2);
              //cout<<abst;
              if(abst>0.65)                             // Nur Worte mit 2/3 Mehrheit
                {
                  // Oeffnen Eingabedatei
                  string verz=tmp_verz;
                  verz.append("gruppen.nbr");
                  e1=fopen(verz.c_str(),"rb");
                  if(e1==NULL)
                    return 14;
                  fread(ein.c,1,sizeof(STRGRP),e1);
                  fclose(e1);
                  if(abst==1.0 && ein.s.proz<80)
                    ein.s.koab=abst;   // Nicht uebernehmen
                  else
                    {
                      ein.s.koab=abst;                        // Abstand
                      for(i=0;i<MAXWRTLNG;i++)
                        {
                          ein.s.deu[i]=deuwrt[i];
                          ein.s.heb[i]=zwrt[i];
                        }
                      fwrite(ein.c,1,sizeof(STRGRP),a1);
                      anzgef++;
                    }
                }
            }
        }
      //cout<<endl;

      status=lex->nextWort();
      if(status==1)
        break;

      // Hebr. und Deutsch Wort uebertragen
      for(i=0;i<MAXWRTLNG;i++)
        zwrt[i]=0;
      for(i=0;i<MAXWRTLNG;i++)
        deuwrt[i]=0;
      i=lex->strwrb.lndeuwrt;
      k=lex->strwrb.deuwrb.copy(deuwrt,i);
      j=lex->strwrb.lnhebwrt;
      k=lex->strwrb.hebwrb.copy(zwrt,j);
      anzwrt++;
      ok=setProgressStatus(pr,lfpr);
      if(!ok)
        return -31;

      if(zwrt[0]!=vglbu)
        {
          lfpr++;
          vglbu=zwrt[0];
        }
    }

  setProgressStop();
  fclose(a1);
  return anzgef;
}
/***********************************************************************/
int CNachbar::sortSuchNachbar(string outdatei="nbrwrt.sor",
                              string indatei="nbrwrt.nbr")
{
  FILE *e1, *a1;

  // Oeffnen Eingabedatei
  string verz=tmp_verz;
  verz.append(indatei);
  e1=fopen(verz.c_str(),"rb");
  if(e1==NULL)
    return 14;
  if(fseek(e1,0,SEEK_END))
    return 14;
  int anz=ftell(e1)/sizeof(STRGRP);    // Anzahl Datensaetze ermitten

  STRGRP *srt;
  int l,j;
  int a=0;
  int zw=0;

  UNIGRP ein;
  srt=new STRGRP[anz];

  for(l=0;l<anz;l++)
    {
      srt[l].els[0]=999999;
      srt[l].apos[0]=999999;
      srt[l].seq=999999;
    }


  // Sort ELS
  rewind(e1);
  fread(ein.c,1,sizeof(STRGRP),e1);
  a=0;
  while(!feof(e1))
    {
      if(ein.s.apos[0]>ein.s.epos[0])
        {
          zw=ein.s.apos[0];
          ein.s.apos[0]=ein.s.epos[0];
          ein.s.epos[0]=zw;
        }
      l=0;

      // Sortieren nach Intervall, Startposition und Zeilenbreite
      while(ein.s.apos[0]>srt[l].apos[0] && l<a)
        l++;
      while(ein.s.apos[0]==srt[l].apos[0] &&
            ein.s.els[0]>srt[l].els[0] && l<a)
        l++;
      while(ein.s.apos[0]==srt[l].apos[0] &&
            ein.s.els[0]==srt[l].els[0] &&
            ein.s.seq>=srt[l].seq && l<a)
        l++;

      // Einordnen
      if(a<=anz)
        {
          for(j=a;j>l;j--)
            srt[j]=srt[j-1];  // Platz freimachen
          a++;
          srt[l].seq=ein.s.seq;         // Daten auf freien Platz eintragen
          srt[l].entf=ein.s.entf;
          srt[l].proz=ein.s.proz;
          srt[l].adom=ein.s.adom;
          srt[l].edom=ein.s.edom;
          srt[l].abst=ein.s.abst;
          srt[l].koab=ein.s.koab;
          srt[l].apos[0]=ein.s.apos[0];
          srt[l].epos[0]=ein.s.epos[0];
          srt[l].apos[1]=ein.s.apos[1];
          srt[l].epos[1]=ein.s.epos[1];
          srt[l].els[0]=ein.s.els[0];
          srt[l].els[1]=ein.s.els[1];
          srt[l].aber[0]=ein.s.aber[0];
          srt[l].eber[0]=ein.s.eber[0];
          srt[l].aber[1]=ein.s.aber[1];
          srt[l].eber[1]=ein.s.eber[1];
          strcpy(srt[l].heb,ein.s.heb);
          strcpy(srt[l].deu,ein.s.deu);
        }
      fread(ein.c,1,sizeof(STRGRP),e1);
    }
  fclose(e1);

  // �ffnen Ausgabedatei
  verz=tmp_verz;
  verz.append(outdatei);
  a1=fopen(verz.c_str(),"w+b");
  if(a1==NULL)
    return 13;

  l=0;
  while(l<anz)
    {
      ein.s.seq=srt[l].seq;         // Daten zur Ausgabe uebertragen
      ein.s.entf=srt[l].entf;
      ein.s.proz=srt[l].proz;
      ein.s.adom=srt[l].adom;
      ein.s.edom=srt[l].edom;
      ein.s.abst=srt[l].abst;
      ein.s.koab=srt[l].koab;
      ein.s.apos[0]=srt[l].apos[0];
      ein.s.epos[0]=srt[l].epos[0];
      ein.s.apos[1]=srt[l].apos[1];
      ein.s.epos[1]=srt[l].epos[1];
      ein.s.els[0]=srt[l].els[0];
      ein.s.els[1]=srt[l].els[1];
      ein.s.aber[0]=srt[l].aber[0];
      ein.s.eber[0]=srt[l].eber[0];
      ein.s.aber[1]=srt[l].aber[1];
      ein.s.eber[1]=srt[l].eber[1];
      strcpy(ein.s.heb,srt[l].heb);
      strcpy(ein.s.deu,srt[l].deu);
      fwrite(ein.c,1,sizeof(STRGRP),a1);
      l++;
    }
  fclose(a1);
  delete srt;
  return 0;
}

/*******************************************************************
Private Funktionen
*******************************************************************/
void CNachbar::abstand(int aw, int lng)
{
  int ls=0;
  int i,j,y;
  float refe,refe2;

  // Minimalbereich der Gruppe ermitteln
  proz=0;
  adom=0;
  edom=999999;

  for(i=0;i<aw;i++)
    {
      if(eber[i]!=0)
        {
          if(aber[i]>adom)
            adom=aber[i];
          if(eber[i]<edom)
            edom=eber[i];
        }
      else
        {
          adom=edom=0;
          break;
        }
    }
  if(edom!=0)
    for(i=0;i<aw;i++)
      if(apos[i]<adom || apos[i]>edom
          || epos[i]<adom || epos[i]>edom)
        adom=edom=0;

  if(adom<edom)
    proz=((edom-adom)*100)/lng;
  else
    adom=edom=0;

  // Minimalabstand in Abhaengigkeit der Zeilenbreite
  float fabst=999999;
  seq=0;

  for(i=0;i<aw;i++)
    {
      if(fabst==0)
        break;
      for(y=1;y<8;y++)
        {
          refe=0.0;
          refe2=0.0;
          for(j=0;j<aw;j++)
            {
              ls=inter[i]*y; // Zeilenbreite als Vielfaches des Intervall
              if(i!=j)
                {
                  refe=wurzel(apos[i],epos[j],ls);
                  refe2=wurzel(epos[i],apos[j],ls);
                  if(refe>refe2)
                    refe=refe2;
                  refe2=wurzel(apos[i],apos[j],ls);
                  if(refe>refe2)
                    refe=refe2;
                  refe2=wurzel(epos[i],epos[j],ls);
                  if(refe>refe2)
                    refe=refe2;
                  refe+=wurzel(apos[i],apos[i]+inter[i],ls);
                  refe+=wurzel(apos[j],apos[j]+inter[j],ls);
                }
            }
          if(refe<fabst)
            {
              fabst=refe;
              abst=(int)refe;
              seq=ls;
            }
          if(y>1)
            {
              refe=0.0;
              for(j=0;j<aw;j++)
                {
                  ls=inter[i]/y;  // Zeilenbreite als ein Teil des Intervall
                  if(ls<4)
                    break;
                  if(i!=j)
                    {
                      refe=wurzel(apos[i],epos[j],ls);
                      refe2=wurzel(epos[i],apos[j],ls);
                      if(refe>refe2)
                        refe=refe2;
                      refe2=wurzel(apos[i],apos[j],ls);
                      if(refe>refe2)
                        refe=refe2;
                      refe2=wurzel(epos[i],epos[j],ls);
                      if(refe>refe2)
                        refe=refe2;
                      refe+=wurzel(apos[i],apos[i]+inter[i],ls);
                      refe+=wurzel(apos[j],apos[j]+inter[j],ls);
                    }
                }
              if(refe<abst && ls>3)
                {
                  fabst=refe;
                  abst=(int)refe;
                  seq=ls;
                }
            }
        }
    }
}

/*****************************************************************/
float CNachbar::wurzel(int p1, int p2, int s)
{

  // Abstand nach Phytagoras berechnen
  float wur=0;
  div_t dp1,dp2;

  dp1=div(p1,s);
  dp2=div(p2,s);
  dp1.quot=abs(dp1.quot-dp2.quot);
  dp1.rem=abs(dp1.rem-dp2.rem);

  if(dp1.rem!=0 && dp1.quot!=0)
    wur=hypot((double)dp1.rem,(double)dp1.quot);
  if(dp1.rem==0)
    wur=(float)dp1.quot;
  if(dp1.quot==0)
    wur=(float)dp1.rem;
  return wur;
}
/********************************************************************/
bool CNachbar::check()
{
  bool ok;
  int m,n;
  unsigned int i;
  int status;
  div_t erg;
  char strchar[2];
  string wort="";
  string zeile="";
  string tmp="";
  string zwrt="";

  m=0;
  n=0;
  strchar[1]=0;
  lfdbu=3;
  while(m<(anzchar-lfdbu))
    {
      lfdbu=3;
      beglfdwrt=beglfdzl+(m*lfdint*fak);
      wort="";
      while(text[m+n]==32)
        m++;
      for(n=0;n<lfdbu;n++)
        {
          strchar[0]=text[m+n];
          wort.insert(n,strchar);       // Wort zusammenstellen
        }
      ok=true;
      while(ok)
        {
          status=lex->findWort(wort);
          if(status==4)
            return false;             // 4 = Fehler Lexikon
          if(status==0)              // Wort gefunden -> Eintragen in Speicher
            {
              gef.pos=absPosition();
              erg=div(beglfdwrt,zlbrt);
              gef.zl=erg.quot+1;
              gef.sp=erg.rem+1;
              gef.abst=wrtAbstand(gef.zl,gef.sp);
              gef.seq=lfdint*faki;
              gef.ri='V';
              for(i=0;i<MAXWRTLNG;i++)
                {
                  gef.heb[i]=0;
                  gef.deu[i]=0;
                }
              for(i=0;i<lex->strwrb.hebwrb.size();i++)
                gef.heb[i]=lex->strwrb.hebwrb.at(i);
              for(i=0;i<lex->strwrb.deuwrb.size();i++)
                gef.deu[i]=lex->strwrb.deuwrb.at(i);
              einsort();                   // Speicher sortieren nach Abstand
            }
          if(status<2)                    // 1 = Wort im Lexikon gleich aber groesser 0 = Wortgefunden
            {
              strchar[0]=text[m+lfdbu];
              wort.insert(lfdbu,strchar); // An Wort einen Buchstaben anhaengen und weitersuchen
              if(m<anzchar-(m+lfdbu))
                lfdbu++;
              else
                {
                  ok=false;
                  lfdbu=3;
                }
            }
          else
            {
              ok=false;    // Suche abbrechen nicht gefunden naechstes Wort
              lfdbu=3;
            }
        }
      m++;
    }


  // Intervallrichtung rueckwaerts
  m=anzchar-1;
  strchar[0]=0;
  lfdbu=3;
  while(m>=lfdbu)
    {
      lfdbu=3;
      n=0;
      beglfdwrt=beglfdzl+(m*lfdint*fak);
      wort="";
      while(text[m-n]==32)
        m--;         // Leerzeichen am Ende vom Text(bei Überlänge) ueberlesen
      for(n=0;n<lfdbu;n++)
        {
          strchar[0]=text[m-n];
          wort.insert(n,strchar);       // Wort zusammenstellen
        }
      ok=true;
      while(ok)
        {
          status=lex->findWort(wort);
          if(status==4)
            return false;       // 4 = Fehler Lexikon
          if(status==0)              // Wort gefunden -> Eintragen in Speicher
            {
              gef.pos=absPosition();
              erg=div(beglfdwrt,zlbrt);
              gef.zl=erg.quot+1;
              gef.sp=erg.rem+1;
              gef.abst=wrtAbstand(gef.zl,gef.sp);
              gef.seq=lfdint*faki;
              gef.ri='R';
              for(i=0;i<MAXWRTLNG;i++)
                {
                  gef.heb[i]=0;
                  gef.deu[i]=0;
                }
              for(i=0;i<lex->strwrb.hebwrb.size();i++)
                gef.heb[i]=lex->strwrb.hebwrb.at(i);
              for(i=0;i<lex->strwrb.deuwrb.size();i++)
                gef.deu[i]=lex->strwrb.deuwrb.at(i);
              einsort();                   // Speicher sortieren nach Abstand
            }
          if(status<2)                   // 1 = Wort im Lexikon gleich aber groesser 0 = Wortgefunden
            {
              strchar[0]=text[m-lfdbu];
              wort.insert(lfdbu,strchar); // An Wort einen Buchstaben anhaengen
              if(m-lfdbu>0)
                lfdbu++;
              else
                ok=false;
            }
          else
            {
              ok=false;    // Suche abbrechen nicht gefunden naechstes Wort
              lfdbu=3;
            }
        }
      m--;
    }
  return true;
}

/**********************************************************************/
void CNachbar::einsort()
{
  int i=0;
  int l=0;

  while(l<lexwrt+2)
    {
      if(gef.abst<fisor[l].abst || fisor[l].abst==0.0)
        {
          if(anzwrt)
            for(i=anzwrt;i>=l;i--)
              fisor[i+1]=fisor[i];
          fisor[l]=gef;
          anzwrt++;
          anzgef++;
          if(anzwrt>lexwrt)
            anzwrt=lexwrt;    // Anzahl Worte fuer Liste
          break;
        }
      l++;
    }
}
/**********************************************************************/
float CNachbar::wrtAbstand(int zl, int sp)
{
  int qzl=(abs(zlsuwrt-zl)*abs(zlsuwrt-zl));
  int qsp=(abs(spsuwrt-sp)*abs(spsuwrt-sp));
  float abst=sqrt(double(qzl+qsp));
  if(abst==0)
    abst=0.1;

  return abst;
}
/**********************************************************************/
int CNachbar::absPosition()
{
  div_t erg;
  int  pos;

  erg=div(beglfdwrt,zlbrt);
  if(suinter<8 && anzbu<10)
    pos=erg.quot*ZLBRT;
  else
    pos=erg.quot*suinter;
  pos+=erg.rem;
  return pos+begpos;
}
/**********************************************************************/
float CNachbar::diff(int p1, int p2) //, int s)
{
  float wur=0;
  div_t dp1,dp2;

  dp1=div(p1,zlbrt);
  dp2=div(p2,zlbrt);
  dp1.quot=abs(dp1.quot-dp2.quot);
  dp1.rem=abs(dp1.rem-dp2.rem);

  if(dp1.rem!=0 && dp1.quot!=0)
    wur=hypot((double)dp1.rem,(double)dp1.quot);
  if(dp1.rem==0)
    wur=(float)dp1.quot;
  if(dp1.quot==0)
    wur=(float)dp1.rem;
  return wur;
}
/***************************************************************************/
bool CNachbar::inFlaeche(int beg, int brt, int apos, int inter, int anzbu)      // Autor Hans-Juergen Schumann
{
  div_t p1, p;
  int xd, yd;

  p1 = div(apos-beg, brt);
  p  = div((apos-beg)+inter, brt);

  // Abstand der Punkte
  xd = p.rem - p1.rem;
  yd = p.quot - p1.quot;

  for (int i=1; i<anzbu; i++)
    {
      p = div(((i*inter)+(apos-beg)), brt);
      if (((p1.rem+xd*i)!=p.rem ) || ((p1.quot+yd*i)!=p.quot))
        return false;
    }
  return true;
}
