/***************************************************************************
                          cnbrlisten.cpp  -  description
                             -------------------
    begin                : Sun Nov 4 2001
    copyright            : (C) 2001 by Heinz Schumann
    email                : heinz.schumann@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cnbrlisten.h"
#include "math.h"

#include <iostream>
using namespace std;             //      Zum einbinden von cout

CNbrListen::CNbrListen()
{}
CNbrListen::~CNbrListen()
{}

/*************************************************************/
int CNbrListen::pruefNachbar(string buch, string wo1, string wo2, string wo3,
                             bool in1=false,
                             bool mod=true,
                             int zlnr=1,
                             string outdatei1="datnbr.bta",
                             string outdatei2="bldnbr.bta")
{
  if(zlnr==0)
    zlnr=1;       // Setze Default Zeilennummer fuer Flex- Fixliste

  int wrt=2;
  if(wo3!="")
    wrt=3;

  // Aufstellen der Intervalllisten
  if(!mod && schltmodifi)
    hebbuch="999";               // Buch neuoeffnen erzwingen
  if(!openHebBuch(buch))
    return 12;

  wo1=pruefWort(wo1);
  wo2=pruefWort(wo2);
  if(wrt==3)
     wo3=pruefWort(wo3);

  if(mod)
    {
      if(modifiBuch(buch))
        return 12;              // modifizieren Bibeltext
      wo1=modifiWort(wo1);
      wo2=modifiWort(wo2);
      if(wrt==3)
        wo3=modifiWort(wo3);
    }
  int fw=0;                    // Nr.Fehlwort (keine Intervalle gefunden)
  int i=0;
  int wlng=0;
  int status=0;
  int pr=3;
  string zwrt="";

  if(wrt==3)
    pr++;

  int klint=2;
  if (in1)
    klint=1;

  for(i=0;i<3;i++)
    wrtlng[i]=0;         //  Wotlaengenspeicher initialisieren
  // Wort1 ************************
  wrtlng[0]=wo1.size();
  int bint=mindestIntervall(buch, wo1, ANZELS+5,0,999999,0,true); // Bestimmen Intervallbereich fuer 50 ELS
  int anz=suchIntervall(buch, wo1,klint, bint, 0, 999999, 0, "interlst.zwi", true);
  if(anz<0)
    return abs(anz);
  if(anz==0)
    fw=1;                              // Keine Intervalle gefunden
  else
    {
      status=sortListeIntervall(0,"interlst.zwi", "interlst.zwi");            // Sortieren nach Intervall
      if(status!=0)
        return status;
      status=ermittleMinimalbereich("wort1.nbr", "interlst.zwi");
      if(status!=0)
        return status;
      status=sortListeIntervall(2,"wort1.nbr", "wort1.nbr");                  // Sortieren nach Minimalbereich
      if(status!=0)
        return status;
      // Wort 2
      wrtlng[1]=wo2.size();
      bint=mindestIntervall(buch, wo2, ANZELS+5, 0, 999999,0,true);  // Bestimmen Intervallbereich fuer 50 ELS
      anz=suchIntervall(buch, wo2,klint, bint, 0, 999999, 0, "interlst.zwi", true);
      if(anz<0)
        return abs(anz);
      if(anz==0)
        fw=2;                           // Keine Intervalle gefunden
      else
        {
          status=sortListeIntervall(0,"interlst.zwi", "interlst.zwi");             // Sortieren nach Intervall
          if(status!=0)
            return status;
          status=ermittleMinimalbereich("wort2.nbr", "interlst.zwi");
          if(status!=0)
            return status;
          status=sortListeIntervall(2,"wort2.nbr", "wort2.nbr");                    // Sortieren nach Minimalbereich
          if(status!=0)
            return status;
          // Wort3 **************************************
          if(wrt==3)
            {
              wrtlng[2]=wo3.size();
              bint=mindestIntervall(buch, wo3, ANZELS+5, 0,999999,0,true);  // Bestimmen Intervallbereich fuer 30 ELS
              anz=suchIntervall(buch, wo3, klint, bint, 0, 999999, 0, "interlst.zwi", true);
              if(anz<0)
                return abs(anz);
              if(anz==0)
                fw=3;                            // Keine Intervalle gefunden
              else
                {
                  status=sortListeIntervall(0,"interlst.zwi", "interlst.zwi");               // Sortieren nach Intervall
                  if(status!=0)
                    return status;
                  status=ermittleMinimalbereich("wort3.nbr", "interlst.zwi");
                  if(status!=0)
                    return status;
                  status=sortListeIntervall(2,"wort3.nbr", "wort3.nbr");                    // Sortieren nach Minimalbereich
                  if(status!=0)
                    return status;
                }
            }
        }
    }

  status=nbrDatenListe(buch, wo1, wo2, wo3, fw, outdatei1,"gruppen.nbr"); // Datenliste erstellen
  status=nbrFlexAbbildung(buch, wo1, wo2, wo3, zlnr, fw, outdatei2,"gruppen.nbr"); // Textabbild erstellen

  return status;
}

/******************************************************************/
int CNbrListen::findNachbar(string buch, string wort, int intervall, int pos,
                            int zl=0,
                            int wrtlst=100,
                            string outdatei1="txtnbr.bta",
                            string outdatei2="txtabbld.bta",
                            string wrtbuch="kuhebdeu.lex")
{
  if(zl!=0)
    {
      FILE *e1;
      UNIINTER ein;

      // Oeffnen Eigabedatei
      string verz=tmp_verz;
      verz.append("interlst.sor");
      e1=fopen(verz.c_str(),"rb");
      if(e1==NULL)
        return 14;

      int i=0;
      rewind(e1);
      while(i++<zl)
        fread(ein.c,1,sizeof(STRINTER),e1);
      intervall=ein.s.inter;
      pos=ein.s.apos;
      fclose(e1);
    }

  wort=pruefWort(wort);
  int anzgef=nbrFindHebWorte(buch,wort,intervall,pos,wrtlst,"hebwrtls.nbr",wrtbuch);
  if(anzgef<-3)
    return abs(anzgef);
  if(anzgef==-3)
    {
      // Oeffnen Ausgabedatei
      FILE *a1;
      string verz=out_verz;
      verz.append(outdatei2);
      a1=fopen(verz.c_str(),"w+b");
      if(a1==NULL)
        return 13;

      // Schreiben Listenkopf
      char zwsp[20];
      string uwort=textUmkehr(wort);
      string zeile="Liste der Nachbarschaftsworte zu ";
      zeile.append(wort);
      zeile.append("\n");
      zeile.append("im Buch ");
      strcpy(zwsp,hebbuch.c_str());
      int i=0;
      // Buchnamen in Grossbuchstaben
      for(i=0;i<(int)strlen(zwsp);i++)
        zwsp[i]=toupper(zwsp[i]);
      zeile.append(zwsp);
      zeile.append("\n");
      fwrite(zeile.c_str(),1,zeile.length(),a1);

      zeile="mit Intervall ";
      sprintf(zwsp,"% d",intervall);
      zeile.append(zwsp);
      zeile.append(" bei Position ");
      sprintf(zwsp,"% d",pos);
      zeile.append(zwsp);
      zeile.append(" wurde mit Fehler abgebrochen\n");
      zeile.append("Intervallwort nicht an angegebener Position gefunden\n\n");
      zeile.append("Intervall und Position sind der Liste Intervallsuche zu entnehmen");
      zeile.append("\n\n");
      fwrite(zeile.c_str(),1,zeile.length(),a1);
      fclose(a1);
      return 3;
    }

  int status=txtAbbildung(buch,wort,intervall,pos,outdatei2);
  if(status!=0 && status!=3)
    return status;
  if(status==3)
    return 0;
  status=nbrWortListe(wort,intervall,pos,anzgef,wrtlst,outdatei1,"hebwrtls.nbr");
  return status;
}

/**************************************************************************/
int CNbrListen::suchNachbar(string buch, string wort,
                            char vonbu=-32,
                            char bisbu=-6,
                            string outdatei="signbrls.bta",
                            string wrtbuch="kudeuheb.lex")
{

  if(!openHebBuch(buch))
    return -12;
  wort=pruefWort(wort);

  int anzgef=0;
  int status=0;
  int pr=6;
  int lfpr=1;

  // Wort1 vorbereiten
  nbr_von_inter=2;
  int bint=mindestIntervall(buch, wort, ANZELS+5,nbr_von_inter,999999,0,true); // Bestimmen Intervallbereich fuer 25 ELS
  int anz=suchIntervall(buch, wort, nbr_von_inter, bint, nbr_von_inter, 999999, 0, "interlst.zwi", true);
  if(anz<0)
    return abs(anz);

  if(anz!=0)                               // Intervalle gefunden
    {
      status=sortListeIntervall(0,"interlst.sor","interlst.zwi");           // Sortieren nach Intervall
      if(status!=0)
        return status;
      status=ermittleMinimalbereich("wort1.nbr", "interlst.sor");
      if(status!=0)
        return status;
    }

  if(anz)
    {
      anzgef=suchHebNachbar(buch,vonbu,bisbu, "nbrwrt.nbr",wrtbuch);
      status=sortSuchNachbar("nbrwrt.sor", "nbrwrt.nbr");
      if(status!=0)
        return status;
    }

  pr=anzgef;
  lfpr=1;

  // Oeffnen Ausgabedatei
  FILE *a1;
  string verz=out_verz;
  verz.append(outdatei);
  a1=fopen(verz.c_str(),"w+b");
  if(a1==NULL)
    return 13;

  // Listenparameter schreiben
  string zeile="\a33\t1\t";
  zeile.append(buch);
  zeile.append("\t");          // Wort 1
  zeile.append(wort);
  zeile.append("\t\t\t");     // Wort 2-3 leer
  zeile.append("\t");         // Von Position
  zeile.append("\t");         // Bis Position
  zeile.append("\t");         // Von Intervall
  zeile.append("\t");         // Bis Intervall
  zeile.append(outdatei);     // Ausgabedatei
  zeile.append("\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  // Schreiben Listenkopf
  char  zwsp[20];
  string uwort=textUmkehr(wort);

  zeile="Liste der signifikanten Nachbarschafen zu ";
  zeile.append(wort);
  zeile.append("\n");
  zeile.append("im Buch ");
  strcpy(zwsp,buch.c_str());           // Buchnamen in Grossbuchstaben
  for(int i=0;i<(int)strlen(zwsp);i++)
    zwsp[i]=toupper(zwsp[i]);
  zeile.append(zwsp);
  zeile.append("\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  zeile="Es wurden ";
  sprintf(zwsp,"% d",anzgef);
  zeile.append(zwsp);
  zeile.append(" Worte gefunden\n  \n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  zeile=" Bewertung der Nachbarschaften\n";
  zeile.append("\brrrrrrrrrrl\n");
  zeile.append("Nr\tBewertung\tInt Suwrt\tPos\tZlbrt\tInt Gefwrt\tBeg-\tEndber\t%");
  zeile.append("\tHebr\tDeutsch\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  if(anz==0)
    zeile="Zum Suchwort keine Intervalle gefunden\n     \n";
  if(anzgef)
    {
      // Oeffnen Eingabedatei
      FILE *e1;
      verz=tmp_verz;
      verz.append("nbrwrt.sor");
      e1=fopen(verz.c_str(),"rb");
      if(e1==NULL)
        return 14;

      UNIGRP grp;
      char c[3];
      c[1]=0;

      // Aufbau der Tabelle Nachbarschaftsworte
      for(int j=0;j<anzgef;j++)
        {
          fread(grp.c,1,sizeof(STRGRP),e1);
          if(grp.s.entf==999999)
            break;
          sprintf(zwsp,"% d",j+1);            // Lfd. Nummer
          zeile=zwsp;
          zeile.append("\t");
          sprintf(zwsp,"% .6f",grp.s.koab);   // Wert Abstand
          zeile.append(zwsp);
          zeile.append("\t");
          sprintf(zwsp,"% d",grp.s.els[0]);      // Intervall 1
          zeile.append(zwsp);
          zeile.append("\t");
          sprintf(zwsp,"% d",grp.s.apos[0]);      // Position 1
          zeile.append(zwsp);
          zeile.append("\t");
          sprintf(zwsp,"% d",grp.s.seq);      // Zeilenbreite
          zeile.append(zwsp);
          zeile.append("\t");
          sprintf(zwsp,"% d",grp.s.els[1]);      // Intervall 2
          zeile.append(zwsp);
          zeile.append("\t");
          sprintf(zwsp,"% d",grp.s.adom);      // Beginn Bereich
          zeile.append(zwsp);
          zeile.append("\t");
          sprintf(zwsp,"% d",grp.s.edom);       // Ende Bereich
          zeile.append(zwsp);
          zeile.append("\t");
          sprintf(zwsp,"% d",grp.s.proz);      // Prozent
          zeile.append(zwsp);
          zeile.append("\t");

          // Lexika Worte schreiben
          uwort="";
          int k;
          for(k=0;k<MAXWRTLNG;k++)
            {
              if(grp.s.heb[k]==0)
                break;
              uwort.append(1,grp.s.heb[k]);        // hebr. Wort schreiben
            }
          zeile.append(uwort);
          zeile.append("\t ");
          uwort="";
          for(k=0;k<MAXWRTLNG;k++)
            {
              if(grp.s.deu[k]==0)
                break;
              uwort.append(1,grp.s.deu[k]);        // deutsch Wort schreiben
            }
          zeile.append(uwort);
          zeile.append("\n");
          fwrite(zeile.c_str(),1,zeile.length(),a1);
        }
      fclose(e1);
    }
  else
    zeile="Es wurden keine Nachbarschaften gefunden\n  \n";
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  fclose(a1);
  return 0;
}
/**************************************************************************/
int CNbrListen::nbrWortListe(string wort, int intervall, int pos,
                             int anzgef, int wrtlst,
                             string outdatei="txtnbr.bta",
                             string indatei="hebwrtls.nbr")
{
  // �ffnen Ausgabedatei
  FILE *a1;
  string verz=out_verz;
  verz.append(outdatei);
  a1=fopen(verz.c_str(),"w+b");
  if(a1==NULL)
    return 13;

  // Listenparameter schreiben
  char zwsp[20];
  string zeile="\a32\t1\t";
  strcpy(zwsp,hebbuch.c_str());
  zeile.append(zwsp);
  zeile.append("\t");          // Wort 1
  zeile.append(wort);
  zeile.append("\t\t\t");     // Wort 2-3 leer
  sprintf(zwsp,"% d",pos);
  zeile.append(zwsp);         // Position
  zeile.append("\t");
  zeile.append("\t");         // Bis Position
  sprintf(zwsp,"% d",intervall);
  zeile.append(zwsp);         // Von Intervall
  zeile.append("\t");
  zeile.append("\t");         // Bis Intervall
  zeile.append(outdatei);        // Ausgabedatei
  zeile.append("\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  // Schreiben Listenkopf
  string uwort=textUmkehr(wort);
  zeile="Liste der Nachbarschaftsworte zu ";
  zeile.append(wort);
  zeile.append("\n");
  zeile.append("im Buch ");
  strcpy(zwsp,hebbuch.c_str());
  int i=0;
  // Buchnamen in Grossbuchstaben
  for(i=0;i<(int)strlen(zwsp);i++)
    zwsp[i]=toupper(zwsp[i]);
  zeile.append(zwsp);
  zeile.append("\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  zeile=" mit Intervall ";
  sprintf(zwsp,"% d",intervall);
  zeile.append(zwsp);
  zeile.append(" bei Position ");
  sprintf(zwsp,"% d",pos);
  zeile.append(zwsp);
  zeile.append("\n\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  zeile="Es wurden ";
  sprintf(zwsp,"% d",anzgef);
  zeile.append(zwsp);
  zeile.append(" Worte gefunden\n   \n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  zeile="Es folgt die Liste der ";
  sprintf(zwsp,"% d",wrtlst);
  zeile.append(zwsp);
  zeile.append(" direkt benachbarten Worte\n  \n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  zeile=" Hinweise zur Liste\n";
  zeile.append(" Zaehlung der Spalten von rechts nach links\n");
  zeile.append(" Angaben zur Leserichtung\n");
  zeile.append("   xV = Vorwaerts\n");
  zeile.append("   xR = Rueckwaerts\n");
  zeile.append("   Wx = Wagerecht\n");
  zeile.append("   Sx = Senkrecht\n");
  zeile.append("   Rx = Rechtsdiagonal (v.links oben n.rechts unten)\n");
  zeile.append("   Lx = Linksdiagonal\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);


  zeile="\bllclccl\n";
  zeile.append("Abstand\tPos\tZl/Sp\tInterv\tRicht\tText hebr\tText deutsch\n   \n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  // Eingabedaten verarbeiten
  FILE *e1;
  UNIHEBWRT aus;
  // int i;
  char c[3];
  c[1]=0;
  string zwort;

  // Oeffnen Eingabedatei
  verz=tmp_verz;
  verz.append(indatei);
  e1=fopen(verz.c_str(),"rb");
  if(e1==NULL)
    return 14;

  rewind(e1);
  while(!feof(e1))
    {
      fread(aus.c,1,sizeof(UNIHEBWRT),e1);
      sprintf(zwsp,"% f",aus.s.abst);
      zeile=zwsp;
      zeile.append("\t");
      sprintf(zwsp,"% d",aus.s.pos);
      zeile.append(zwsp);
      zeile.append("\t");
      sprintf(zwsp,"% d",aus.s.zl);
      zeile.append(zwsp);
      zeile.append("/");
      sprintf(zwsp,"%-d",aus.s.sp);
      zeile.append(zwsp);
      zeile.append("\t");
      sprintf(zwsp,"% d",aus.s.seq);
      zeile.append(zwsp);
      zeile.append("\t");
      c[0]=aus.s.la;
      zeile.append(c);
      c[0]=aus.s.ri;
      zeile.append(c);
      zeile.append("\t");
      uwort="";
      for(i=0;i<MAXWRTLNG;i++)
        {
          if(aus.s.heb[i]==0)
            break;
          uwort.append(1,aus.s.heb[i]);        // hebr. Wort schreiben
        }
      zeile.append(uwort);
      zeile.append("\t ");
      uwort="";
      for(i=0;i<MAXWRTLNG;i++)
        {
          if(aus.s.deu[i]==0)
            break;
          uwort.append(1,aus.s.deu[i]);        // deutsch Wort schreiben
        }
      zeile.append(uwort);
      zeile.append("\n");
      fwrite(zeile.c_str(),1,zeile.length(),a1);
    }

  fclose(a1);
  fclose(e1);
  return 0;
}
/********************************************************************/
int CNbrListen::txtAbbildung(string buch, string wort, int intervall, int pos,
                             string outdatei="txtabbld.bta")
{

  int status=lesHebAbschnitt(buch,0,10);  // Pseudolesen fuer Buchkontrolle
  if(status)
    return status;

  wort=modifiWort(wort);
  string wort2=textUmkehr(wort);

  int anzbu=wort.length();

  // Berechne Textbereich
  int beg=pos;
  int end=pos;
  int i;
  int zlbrt;
  bool klint=false;

  if(intervall<8)                           // Zeilenbreite ermitteln
    {
      klint=true;
      if((intervall*anzbu)<ZLBRT)
        zlbrt=ZLBRT;
      else
        zlbrt=intervall*anzbu;
    }
  else
    zlbrt=intervall;
  end=pos+((anzbu-1)*intervall);             // Endposition des Suchwortes
  if(end>hebbuchlng-1)
    return -3;

  int anzl=0;                               // Anzahl Zeilen ermitteln
  if(klint)
    {
      anzl=ZLHOE;
      beg=beg-(((ZLHOE/2)*zlbrt)-(abs(end-beg)/2));      // Wort vertikal in die Mitte schieben
    }
  else
    {
      anzl=1+((end-beg)/zlbrt);                // Worthoehe in Zeilen
      beg=beg-(((ZLHOE/2)-(anzl/2))*zlbrt);    // Wort vertikal in die Mitte schieben
    }

  while(beg<0)
    beg+=intervall;               // Pruefen auf Textbeginn und evt.korrigieren

  if(zlbrt>ZLBRT)
    beg=beg-(ZLBRT/2);                       // Wort horizontal in die Mitte schieben
  else
    beg=beg-(zlbrt/2);

  while(beg<0)
    beg+=intervall;               // Pruefen auf Textbeginn und evt.korrigieren

  end=beg+(ZLHOE*zlbrt); // Darstellungsbereich Ende
  if(end>hebbuchlng)
    end=hebbuchlng-1;

  FILE *a1;

  // Oeffnen Ausgabedatei
  string verz=out_verz;
  verz.append(outdatei);
  a1=fopen(verz.c_str(),"w+b");
  if(a1==NULL)
    return 13;

  string zeile;
  char zwsp[20];
  string uwort=textUmkehr(wort);
  // Listenkopf schreiben
  strcpy(zwsp,buch.c_str());           // Buchnamen in Grossbuchstaben
  for(i=0;i<(int)strlen(zwsp);i++)
    zwsp[i]=toupper(zwsp[i]);

  zeile="Textdarstellung zum Wort ";
  zeile.append(wort);
  zeile.append(" aus Buch ");
  zeile.append(zwsp);
  zeile.append("\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);
  for(i=0;i<(int)strlen(zwsp);i++)
    zwsp[i]=toupper(zwsp[i]);
  zeile=" mit Intervallweite ";
  sprintf(zwsp,"% d",intervall);
  zeile.append(zwsp);
  zeile.append(" bei Positon ");
  sprintf(zwsp,"% d",pos);
  zeile.append(zwsp);
  zeile.append("\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);
  zeile=" in Zeilenbreite ";
  sprintf(zwsp,"% d",zlbrt);
  zeile.append(zwsp);
  if(zlbrt>ZLBRT)
    {
      zeile.append(" bei Darstellung von ");
      sprintf(zwsp,"% d",ZLBRT);
      zeile.append(zwsp);
      zeile.append(" Zeichen/Zeile");
    }
  zeile.append("\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);
  zeile=" Mit Textausschnitt von Position ";
  if(beg>=0)
    sprintf(zwsp,"% d",beg);
  else
    sprintf(zwsp,"% d",0);
  zeile.append(zwsp);
  zeile.append(" (");
  posKap(buch, beg);
  zeile.append(kap_vers);
  zeile.append(") bis Position ");
  sprintf(zwsp,"% d",end);
  zeile.append(zwsp);
  zeile.append(" (");
  posKap(buch, end);
  zeile.append(kap_vers);
  zeile.append(")\n\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  // Schreibe Matrix Parameter
  zeile="\v";
  if(zlbrt>ZLBRT)
    sprintf(zwsp,"% d",ZLBRT);
  else
    sprintf(zwsp,"% d",zlbrt);
  zeile.append(zwsp);
  zeile.append("\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  // Spaltenlineal einbringen
  int j,k;
  if(zlbrt>ZLBRT)
    k=ZLBRT-2;
  else
    k=zlbrt-2;
  zeile="1";
  j=2;
  while(k>1)
    {
      if(j<10)
        zeile.append("\t.");
      else
        {
          zeile.append("\t|");
          j=0;
        }
      j++;
      k--;
    }
  zeile.append("2\t6\t");
  zeile=textUmkehr(zeile);
  zeile.append("\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  // Schreibe die Matrix
  int lfd=beg;
  int z=zlbrt;
  int c; //,i;
  int b=0;
  int a=anzbu;
  int u,v;
  char mbu[3];
  int aktpos=pos;

  mbu[1]=0;
  if(z>ZLBRT)
    z=ZLBRT;

  while(lfd<end)
    {
      if(lfd+z>end)
        z=end-lfd;
      zeile="";
      for(i=lfd;i<lfd+z;i++)
        {
          if(i>=0)                           // Einlesen des lfd Buchstabens
            {
              u=lesHebBuchstaben(buch,i);
              mbu[0]=heb_buchst;
              zeile.insert(0,mbu);
            }
          else
            zeile.insert(0," ");         // Leerzeichen wenn Beginn negativ
          if(i==aktpos)
            {
              c=(int)zeile.at(0);
              if(c==-22)
                c++;
              if(c==-19)
                c++;
              if(c==-17)
                c++;
              if(c==-13)
                c++;
              if(c==-11)
                c++;
              u=(int)wort.at(b);
              v=(int)wort2.at(b);
              if(c!=u && c!=v)
                {
                  zeile.append("\036\n");
                  zeile.append(" Fehler:\n");
                  zeile.append("Suchwort nicht an angegebener Position oder\n");
                  zeile.append("Intervallweite falsch angegeben\n\n");
                  zeile.append("Die Vorgaben fuer eine Wortsuche (Startposition und Intervall)\n");
                  zeile.append("sind der Intervallliste zum Wort ");
                  zeile.append(wort);
                  zeile.append(" zu entnehmen \n\n");
                  fwrite(zeile.c_str(),1,zeile.length(),a1);
                  fclose(a1);
                  return 3;
                }
              zeile.insert(0,"3");            // Farbmarkierung
              zeile.insert(0,"\f");
              b++;
              a--;
              if(a>0)
                aktpos=aktpos+intervall;
              else
                aktpos=999999;
            }
          if(i<lfd+z-1)
            zeile.insert(0,"\t");
        }
      lfd=lfd+zlbrt;
      zeile.append("\n");
      fwrite(zeile.c_str(),1,zeile.length(),a1);
    }
  zeile="\033\n";
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  fclose(a1);

  return 0;
}
/********************************************************************/
int CNbrListen::nbrDatenListe(string buch, string wo1, string wo2, string wo3, int fw,
                              string outdatei="datnbr.bta",
                              string indatei="gruppen.nbr")
{

  FILE *e1=NULL;
  FILE *a1=NULL;


  int wrt=2;
  if(wo3!="")
    wrt=3;

  float masp=berechneNachbar(wrt, "gruppen.nbr", true);

  // Oeffnen Ausgabedatei
  string verz=out_verz;
  verz.append(outdatei);
  a1=fopen(verz.c_str(),"w+b");
  if(a1==NULL)
    return 13;

  // Listenparameter schreiben
  string zeile="\a31\t1\t";
  zeile.append(buch);
  zeile.append("\t");          // Wort 1
  zeile.append(wo1);
  zeile.append("\t");          // Wort 2
  zeile.append(wo2);
  zeile.append("\t");          // Wort 2
  zeile.append(wo3);
  zeile.append("\t");         // Von Position
  zeile.append("\t");         // Bis Position
  zeile.append("\t");
  zeile.append("\t");         // Von Intervall
  zeile.append("\t");         // Bis Intervall
  zeile.append(outdatei);        // Ausgabedatei
  zeile.append("\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);
  // Daten fuer Listenkopf zusammenstellen
  string zwtxt;
  char zwsp[15];

  strcpy(zwsp,buch.c_str());           // Buchnamen in Grossbuchstaben
  for(unsigned int i=0;i<strlen(zwsp);i++)
    zwsp[i]=toupper(zwsp[i]);

  zeile="Die Nachbarschaftpruefung im Buch ";
  zeile.append(zwsp);
  zeile.append(" \nmit den Worten ");
  zeile.append(wo1);
  zeile.append(", ");
  zeile.append(wo2);
  if(wrt==3)
    {
      zeile.append(", ");
      zeile.append(wo3);
    }
  zeile.append("\n");
  zeile.append(" hat folgendes Ergebnis gebracht: \n    \n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);
  if(fw)
    {
      zeile="Fuer Wort ";
      if(fw==1)
        zeile.append(wo1);
      if(fw==2)
        zeile.append(wo2);
      if(fw==3)
        zeile.append(wo3);
      zeile.append(" keine Intervalle gefunden\n\n");
      fwrite(zeile.c_str(),1,zeile.length(),a1);
    }
  else
    {
      zeile="Die Anordnung als Nachbarschaft ist ";
      if(masp>0.0)
        {
          if(masp>0.5)
            zeile.append("sehr wahrscheinlich");
          else if(masp>0.4)
            zeile.append("wahrscheinlich");
          else if(masp>0.2)
            zeile.append("unwahrscheinlich");
          else
            zeile.append("nicht zutreffend");
        }
      else
        zeile.append("Nachbarschaft 2 ebenfalls betrachten,\n es gibt zwei gleichewertige Nachbarschaften");


      // +++++++++ bei erweiterter Intervallsuche (Zufallsmischung des Textes) ++++++++
      // if(masp<=0.0) if(masp>-0.1 && rang<3) zeile.append("noch wahrscheinlich");
      //               else zeile.append("unwahrscheinlich");

      zeile.append("\n");
      zeile.append(" Der Abstand zur Nachbarschaftsgruppe 2\n");
      zeile.append(" betraegt ");
      sprintf(zwsp,"% .4f",masp);
      zeile.append(zwsp);
      zeile.append("\n          \n");
      fwrite(zeile.c_str(),1,zeile.length(),a1);
      zeile=" Bewertung der Nachbarschaftsgruppen\n";
      fwrite(zeile.c_str(),1,zeile.length(),a1);
      zeile="\brrrrrr";
      if(wrt>2)
        zeile.append("rrrrrr\n");           // Tabellenstruktur
      else
        zeile.append("rrrr\n");
      zeile.append("Gruppe\tBewertung\tZlbrt\tBeg-\tEndber\t% ");
      for(int i=1;i<=wrt;i++)
        {
          sprintf(zwsp,"% d",i);
          zeile.append("\t Int");
          zeile.append(zwsp);
          zeile.append("\tPos");
        }
      zeile.append("\n");
      fwrite(zeile.c_str(),1,zeile.length(),a1);

      // Oeffnen Eingabedatei
      verz=tmp_verz;
      verz.append(indatei);
      e1=fopen(verz.c_str(),"rb");
      if(e1==NULL)
        return 14;

      UNIGRP grp;

      // Aufbau der Tabelle der Nachbarschaftsgruppen
      for(int j=0;j<ANZGRP;j++)
        {
          fread(grp.c,1,sizeof(STRGRP),e1);
          if(grp.s.entf==999999)
            break;
          if(feof(e1))
            break;
          sprintf(zwsp,"% d",j+1);            // Gruppennummer
          zeile=zwsp;
          zeile.append("\t");
          sprintf(zwsp,"% .6f",grp.s.koab);   // Wert Abstand
          zeile.append(zwsp);
          zeile.append("\t");
          //  if(grabst[0][j]== 1.0 || grabst[0][j]== 0.0) lste+=".000000";
          sprintf(zwsp,"% d",grp.s.seq);      // Zeilenbreite
          zeile.append(zwsp);
          zeile.append("\t");
          sprintf(zwsp,"% d",grp.s.adom);      // Beginn Bereich
          zeile.append(zwsp);
          zeile.append("\t");
          sprintf(zwsp,"% d",grp.s.edom);       // Ende Bereich
          zeile.append(zwsp);
          zeile.append("\t");
          sprintf(zwsp,"% d",grp.s.proz);      // Prozent
          zeile.append(zwsp);

          for(int i=0;i<wrt;i++)
            {
              zeile.append("\t");
              sprintf(zwsp,"% d",grp.s.els[i]);      // Intervall
              zeile.append(zwsp);
              zeile.append("\t");
              sprintf(zwsp,"% d",grp.s.apos[i]);      // Intervall
              zeile.append(zwsp);
            }
          zeile.append("\n");
          fwrite(zeile.c_str(),1,zeile.length(),a1);
        }
      fclose(e1);
    }                 // End else if(fw)

  fclose(a1);
  return 0;
}
/*****************************************************************/
int CNbrListen::nbrFlexAbbildung(string buch, string wo1, string wo2, string wo3, int zl, int fw,
                                 string outdatei="flexnbr.bta",
                                 string indatei="gruppen.nbr")
{
  FILE  *e1=NULL;
  FILE  *a1=NULL;
  string wrtsp[3];
  string verz=tmp_verz;

  int i=0;
  int j=0;
  int k=0;
  int anzwrt=2;
  if(wo3!="")
    anzwrt=3;
  wrtsp[0]=wo1;
  wrtsp[1]=wo2;
  wrtsp[2]=wo3;

  if(fw)  // Fehlende Intervalle
    {
      // Oeffnen Ausgabedatei
      verz=out_verz;
      verz.append(outdatei);
      a1=fopen(verz.c_str(),"w+b");
      if(a1==NULL)
        return 13;

      // Ausgabe der Liste
      char zwsp[15];
      string zeile="Darstellung der Nachbarschaft fuer die Intervalle\n";
      zeile.append(" der Worte ");
      for(i=0;i<anzwrt;i++)
        zeile.append(wrtsp[i]+", ");
      zeile.append(" im Buch ");
      strcpy(zwsp,buch.c_str());              // Buchnamen in Grossbuchstaben
      for(i=0;i<(int)strlen(zwsp);i++)
        zwsp[i]=toupper(zwsp[i]);
      zeile.append(zwsp);
      zeile.append("\n\n");
      fwrite(zeile.c_str(),1,zeile.length(),a1);

      zeile=" Fuer Wort ";
      zeile.append(wrtsp[fw-1]);
      zeile.append(" wurden keine Intervalle gefunden\n");
      fwrite(zeile.c_str(),1,zeile.length(),a1);

      fclose(a1);
      return 0;
    }

  // Oeffnen Eingabedatei
  verz=tmp_verz;
  verz.append(indatei);
  e1=fopen(verz.c_str(),"rb");
  if(e1==NULL)
    return 14;

  UNIGRP grp;

  while(i++<zl)
    fread(grp.c,1,sizeof(STRGRP),e1); // Datensatz aufsuchen
  fclose(e1);

  // Begin Aufbau der Hebr. Matrix
  // Uebertragen der ermittelten Werte zu den Nachbarschaftswoertern
  // fuer die Matrix
  for(i=0;i<anzwrt;i++)
    {
      aber[i]=grp.s.aber[i];
      eber[i]=grp.s.eber[i];
      apos[i]=grp.s.apos[i];
      epos[i]=grp.s.epos[i];
      inter[i]=grp.s.els[i];
    }
  seq=grp.s.seq;

  // Ermitteln der Beginn und Endwerte der Intervallworte
  // fuer den darzustellenden Text
  int beg=999999;
  int end=0;

  for(i=0;i<anzwrt;i++)
    {
      if(beg>apos[i])
        beg=apos[i];
      if(end<epos[i])
        end=epos[i];
    }

  // Vorbereiten fuer Matrixermitteln
  int refe=0;
  for(i=0;i<anzwrt;i++)
    {
      refe=0;
      if(inter[i]!=0)
        {

          if(apos[i]>epos[i])
            {
              refe=apos[i];
              apos[i]=epos[i];
              epos[i]=refe;
            }
        }
    }

  // Minimale Anordnungsbreite bestimmen
  div_t zw;
  int bre1, bre2;
  int begf=0;
  int begalt=0;
  int intalt=0;
  int bre=999999;
  int begzw=beg;
  int brealt=999999;
  int basint=0;
  int brt=0;
  int gesanz=0;
  bool ok;
  bool kmpl;

  for(k=0;k<anzwrt;k++)
    {
      basint=inter[k];
      if(basint<8)
        basint=46;
      bre=999999;
      for(i=0;i<basint;i++)
        {
          bre1=999999;
          bre2=0;
          kmpl=true;
          for(j=0;j<anzwrt;j++)
            {
              if(inter[j]!=0)
                {
                  ok=inFlaeche(begzw,seq,apos[j],inter[j],wrtsp[j].size());
                  if(ok)                                     // Ermitteln Differrenz zum Rand
                    {
                      zw=div(apos[j]-begzw,seq);
                      if(bre1>zw.rem)
                        bre1=zw.rem;
                      if(bre2<zw.rem)
                        bre2=zw.rem;
                      zw=div(epos[j]-begzw,seq);
                      if(bre1>zw.rem)
                        bre1=zw.rem;
                      if(bre2<zw.rem)
                        bre2=zw.rem;
                    }
                  else
                    kmpl=false;

                }
              if(!ok)
                break;
            }

          if(kmpl && (bre2-bre1)<=seq && (bre2-bre1)<bre)
            {
              bre=bre2-bre1;
              begf=begzw;
            }
          begzw--;
        }
      if(bre<brealt)
        {
          brealt=bre;
          begalt=begf;
          intalt=basint;
        }
    }

  if(brealt!=999999)
    {
      bre=brealt;
      beg=begalt;
      basint=intalt;
    }
  else
    {
      gesanz=99;
      bre=basint;
    }

  // Abbbildung zentrieren
  basint=seq;
  beg=beg-((basint-bre)/2);                      // zum zentrieren Schnittlinie verschieben
  brt=basint;
  if(basint>46 && basint>bre)
    {
      if(bre<46)
        brt=46;
      else
        brt=bre+8;
      beg=beg-(basint-((basint-brt)/2));
    }

  // Bildhoehe ermitteln
  int hoe=(((end+basint)-beg)/basint);                       // Anzahl Zeilen
  while(hoe<28)                                     // Hoehe erweitern auf 28 Zeilen
    {
      beg=beg-basint;
      end=end+basint;
      hoe+=2;
    }

  // Bestimmen Endposition der Darstellung
  end=(hoe*basint)+beg;
  if(end>hebbuchlng-1)
    end=hebbuchlng-1;
  while(beg<0)
    beg+=basint;

  // Oeffnen Ausgabedatei
  verz=out_verz;
  verz.append(outdatei);
  a1=fopen(verz.c_str(),"w+b");
  if(a1==NULL)
    return 13;

  // Ausgabe der Liste
  char zwsp[15];
  string zeile="Darstellung der Nachbarschaft fuer die Intervalle\n";
  zeile.append(" der Worte ");
  for(i=0;i<anzwrt;i++)
    zeile.append(wrtsp[i]+", ");
  zeile.append(" im Buch ");
  strcpy(zwsp,buch.c_str());              // Buchnamen in Grossbuchstaben
  for(i=0;i<(int)strlen(zwsp);i++)
    zwsp[i]=toupper(zwsp[i]);
  zeile.append(zwsp);
  zeile.append("\n\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  zeile=" Textausschnitt fuer Gruppe";
  sprintf(zwsp,"% d",zl);              // Gruppe
  zeile.append(zwsp);
  zeile.append(" mit Zeilenbreite");
  sprintf(zwsp,"% d",seq);             // Zeilenbreite
  zeile.append(zwsp);
  zeile.append("\n");
  zeile.append(" bei Darstellung von");
  sprintf(zwsp,"% d",brt);
  zeile.append(zwsp);
  zeile.append(" Buchstaben/Zeile\n");
  zeile.append(" von Position ");
  sprintf(zwsp,"% d",beg);
  zeile.append(zwsp);
  zeile.append(" (");
  posKap(buch, beg);
  zeile.append(kap_vers);
  zeile.append(") bis Position ");
  sprintf(zwsp,"% d",end);
  zeile.append(zwsp);
  zeile.append(" (");
  posKap(buch, end);
  zeile.append(kap_vers);
  zeile.append(")\n\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  // Schreibe Matrix
  int aktpos[MAXWRT];
  int f;
  char mbu[3];
  int zwpos=beg;

  for(i=0;i<MAXWRT;i++)
    aktpos[i]=0;
  for(i=0;i<anzwrt;i++)
    aktpos[i]=apos[i];    // Position fuer Farbe

  // Matrixdaten fuer Listensteuerung
  zeile="\v";
  sprintf(zwsp,"% d",brt);
  zeile.append(zwsp);
  zeile.append("\n");
  fwrite(zeile.c_str(),1,zeile.length(),a1);

  mbu[1]=0;
  while(beg<end)
    {
      j=0;
      zeile="";
      while(j<brt)
        {
          f=0;
          for(i=0;i<anzwrt;i++)
            {
              if(aktpos[i]==beg)
                {
                  f=i+3;
                  sprintf(zwsp,"%.1d",f);
                  if(aktpos[i]<epos[i])
                    aktpos[i]+=inter[i];
                }
            }
          i=lesHebBuchstaben(buch,beg);
          mbu[0]=heb_buchst;
          zeile.insert(0,mbu);
          if(f)
            {
              zeile.insert(0,zwsp);
              zeile.insert(0,"\f");
            }
          j++;
          if(j!=0 && j<brt)
            zeile.insert(0,"\t");
          beg++;
          if(beg>(int)hebbuchlng)
            break;
        }
      zeile.append("\n");
      fwrite(zeile.c_str(),1,zeile.length(),a1);
      beg=zwpos+seq;
      if(beg>(int)hebbuchlng)
        break;
      zwpos=beg;
    }

  fclose(a1);
  return 0;
}

