/***************************************************************************
                          bdoclst.cpp  -  description
                             -------------------
    begin                : Mon Jan 3 2000
    copyright            : (C) 2000 by Hans-Jrgen Schumann
    email                : hans@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
#include <iostream>
// include files for QT
#include <qdir.h>
#include <qfileinf.h>
#include <qmessagebox.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qdialog.h>

#include <string>
using  namespace std;
//#include <qpopupmenu.h>
//#include <qlistview.h>
//#include <qpoint.h>

// include files for KDE
//#include <kapp.h>
//#include <klocale.h>

// application specific includes
#include "bdoclst.h"
#include "bdoclstren.h"

#include "cbtaconvert.h"
//#include "bitana.h"

BDocLst::BDocLst(QWidget *parent, const char *name ) : QListView(parent, name)
{

    addColumn("Ergebnisse");
    addColumn("Datum-Zeit");
    setSorting(1, false);
    // groups  3. Spalte fr Gruppeneinteilung
    rgr.append(new QListViewItem(this, "Textanzeige","","anz_ block dar txt"));
    rgr.append(new QListViewItem(this, "Intervallsuche","","itv_ such inter"));
    rgr.append(new QListViewItem(this, "Nachbarschaftsprfung","", "nbr_"));
    rgr.append(new QListViewItem(this, "Nachbarschaftssuche","", "wrt_ find"));
    rgr.append(new QListViewItem(this, "Matrixsuche","", "mas_ "));
    setRootIsDecorated(true);

    rfi.setAutoDelete(true);
    rfi.clear();

    initListMenu();
    connect(this, SIGNAL(rightButtonPressed(QListViewItem*,const QPoint&,int) ), this, SLOT(slotMenList(QListViewItem*,const QPoint&,int)));

}

int BDocLst::scanResultList(QString rdir)
{

    resdir = rdir;
    QDir rd;
    QFileInfo *rf;
    QString grlist;
    int gpos;
    int numfil = 0;
    QListViewItem *group;

    setSorting(1, false);
    rfi.clear();
    rd.setPath(resdir);
    const QFileInfoList *list = rd.entryInfoList("*");
    QFileInfoListIterator it(*list);

    group = rgr.first();
    while (group != NULL)
    {
        grlist = group->text(2);
        while (!grlist.isEmpty())
        {
            gpos = grlist.find(' ');
            if (gpos > 0)
            {
                list = rd.entryInfoList(grlist.left(gpos)+ "*.bta");
                grlist.remove(0, gpos + 1);
            }
            else
            {
                list = rd.entryInfoList(grlist + "*.bta");
                grlist.remove(0, grlist.length());
            }
            it = *list;
            while ((rf = it.current()) != 0)
            {
                rfi.append(new QListViewItem(rgr.current(),
                                             rf->baseName().mid(4), toDTString(rf->lastModified()), rf->fileName()));
                ++numfil;
                ++it;
            }
        }
        group = rgr.next();
    }
    return(numfil);

    return 0;
}

// Umwandlung des dateTime - Formates / mit QT3 als Formatstring
QString BDocLst::toDTString(QDateTime dt)
{

    QTime t = dt.time();
    QDate d = dt.date();
    QString s;
    s.setNum(d.year()*10000 + d.month()*100 + d.day());

    // const QString dt = "yyyy/MM/dd hh:mm:ss";   qt3

    return (s + "-" + t.toString() );
}

//------------------
QListViewItem *BDocLst::itemFile(QString file)
{

    rfi.first();
    do
        if ((rfi.current()->text(2)) == file)
            return (rfi.current());
    while (rfi.next() != NULL)
        ;

    return NULL;
}

/** Initialisiert das popup-Men fr die Bearbeitung der Listeneintrge */
void BDocLst::initListMenu()
{

    men = new QPopupMenu(this);
    men->insertItem("Umbenennen", this, SLOT(slotMenUmbenennen()), 0, 1);
    men->insertItem("Lschen", this, SLOT(slotMenLoeschen()), 0, 2);
    men->insertItem("Nach PDF  konvertieren", this, SLOT(slotMenTexconv()), 0, 3);
    men->insertItem("Nach HTML konvertieren", this, SLOT(slotMenHtmlconv()), 0, 4);

    // men->insertItem("ndern", this, SLOT(menAendern()), 0, 3);

}

/** Menu rechte Maustaste */
void BDocLst::slotMenList(QListViewItem *item, const QPoint &point, int i)
{
    // wenn i <0  dann wurde kein Item angeklickt
    if (i < 0)
        return;
    selfile = item;
    if (selfile->parent() == NULL)
        return;   // Gruppeneintrag
    men->setItemEnabled(1, true);             // umbenennen
    men->setItemEnabled(2, true);             // lschen
    //  men->setItemEnabled(3, true);
    men->popup(point);
}

/** Menpunkt 1  umbenennen */
void BDocLst::slotMenUmbenennen()
{

    QDir rd;
    rd.setPath(resdir);

    QString oname, nname;
    oname = selfile->text(2);

    BDocLstRen *rdlg =  new BDocLstRen(this, "Rename", true);

    rdlg->neu_prae->setText(oname.left(4));
    rdlg->neu_name->setText(oname.mid(4, oname.find(".bta")-4));
    rdlg->neu_post->setText(".bta");

    if (rdlg->exec() == 1 )
    {  // ok;
        nname = oname.left(4)
                + rdlg->neu_name->text().stripWhiteSpace()+ ".bta";
        rd.rename(oname, nname);
        scanResultList(resdir);
        setSelected(itemFile(nname), true);
    }
    //  else cout << "Abbruch" << endl;
    return;

}

/** Menpunkt 2 Lschen */
void BDocLst::slotMenLoeschen()
{

    QDir rd;
    rd.setPath(resdir);
    QString name;
    name = selfile->text(2);
    rd.remove(name);
    scanResultList(resdir);
}

/** Menpunkt 3 nach Tex Konvertieren */
void BDocLst::slotMenTexconv()
{

    QDir rd;
    rd.setPath(resdir);
    string name;
    //    String texname;

    //    name = selfile->text(2);
    name = (selfile->text(2).left(selfile->text(2).find(".bta"))).ascii();

    //    texname = name+ ".tex";

    CbtaConvert *konv = new CbtaConvert();
    konv->bta2tex(resdir + "/" +name + ".bta", resdir + "/" + name + ".tex");

    string cmd;
    string bitaoutdir	= resdir.ascii();				// Kommando zum Latex-Lauf

    cmd = "cd " + bitaoutdir + "; elatex --interaction nonstopmode " + name + ".tex >> latex.log;";
    cmd += " dvipdf " + name + ".dvi >> latex.log 2>&1";

    //  cout << cmd << endl;

    if (!system(cmd.c_str()))
    {

        QMessageBox::information(this, tr("PDF Generierung ok."),
                                 name + ".pdf - erstellt",
                                 QMessageBox::Ok );
        cmd = "cd "+ bitaoutdir + "; rm *.dvi; rm *.aux; rm *.log; rm *.tex";
        system(cmd.c_str());
    }
    else
    {
        QMessageBox::information(this, tr("LaTex-Lauf oder pdf - Generierung mit Fehler!"),
                                 cmd,
                                 QMessageBox::Ok);
        return;
    }

    scanResultList(resdir);
}
/** Menpunkt 4 nach HTML konvertieren */
void BDocLst::slotMenHtmlconv()
{

    QDir rd;
    rd.setPath(resdir);
    string name;
    //    String texname;

    //    name = selfile->text(2);
    name = (selfile->text(2).left(selfile->text(2).find(".bta"))).ascii();

    //    texname = name+ ".tex";

    CbtaConvert *konv = new CbtaConvert();
    bool result = konv->bta2html(resdir + "/" +name + ".bta", resdir + "/" + name + ".html");

    if (result)
    {

        QMessageBox::information(this, tr("HTML Generierung ok."),
                                 name + ".html - erstellt",
                                 QMessageBox::Ok );

    }
    else
    {
        QMessageBox::information(this, tr("HTML - Generierung mit Fehler!"),
                                 "???",
                                 QMessageBox::Ok);
        return;
    }

    scanResultList(resdir);
}

BDocLst::~BDocLst()
{}


