/***************************************************************************
                          bdoclst.h  -  description
                             -------------------
    begin                : Mon Jan 3 2000
    copyright            : (C) 2000 by  Hans-Jrgen Schumann
    email                : hans@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef BDOCLST_H
#define BDOCLST_H

// include files for QT
#include <qwidget.h>
#include <qlist.h>
#include <qlistview.h>
#include <qstring.h>
#include <qpopupmenu.h>
#include <qpoint.h>
#include <qdatetime.h>

/** Widget for result list
	* in each group for serch or view methods are listed
	* the files of results
  * @author Hans-Jrgen Schumann
  */

class BDocLst : public QListView
{

    Q_OBJECT

public:
    BDocLst(QWidget *parent=0, const char *name=0);
    /** marked the  item  where the result file
    * is connected
    */
    QListViewItem *itemFile(QString file);
    /** seach the resultfiles in the Directory TmpDir and
    * rebuild tehe DocList-Widget
    */
    int scanResultList(QString rdir);
    ~BDocLst();

protected slots:

    void slotMenList(QListViewItem *item, const QPoint &point, int i);
    void slotMenUmbenennen();
    void slotMenLoeschen();
    void slotMenTexconv();
    void slotMenHtmlconv();
private:
    QString resdir;
    QListViewItem *selfile;
    QList<QListViewItem> rfi, rgr;  // resultfiles, resultgroups
    QPopupMenu *men;
    //    CbtaConvert *konv;
    void initListMenu();
    QString toDTString(QDateTime dt);  // Ersatz fr qt3 Formatumwandlung

};

#endif





