/***************************************************************************
                          		bhebinp.h
                             -------------------
    begin                : Sun Jan 2 2000
    copyright            : (C) 2000 by Hans-Jrgen Schumann
    email                : hans@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef BHEBINP_H
#define BHEBINP_H

#include <qwidget.h>
#include <qlined.h>
#include <qcombo.h>
#include <qstrlist.h>
#include <qstring.h>
#include <qtextcodec.h>
//#include "cbitanaconfig.h"
#include "qtbitanadoc.h"

/**Hebrew - Eingabehilfe
  *@author  Hans-Jrgen Schumann
  */

class BHebInp : public QWidget  {
   Q_OBJECT

public:

	BHebInp(QWidget *parent=0, const char *name=0);
	~BHebInp();

  /** Initialisierung */
  void init(QtBitanaDoc *bc);
  /** Reading the Input */
  QString readInput();
	void setInputStack();
	void getInputStack();

private:
    void setWord();
// Layoutgren entspr. der Fontgre !

	int 	HEB_BEG;		// 1. Heb-Zeichen ALEPH
	int		ANZB;			// Anzeigenbreite
									// Rechtsbndig mit Leerzeichen links
  int	MAX_INP_STACK;

//  CBitanaConfig *bc;
  QtBitanaDoc *bc;
	QComboBox *in;
	QStrList *inpstack;
	QString word;			// Wort zur Bearbeitung
	QTextCodec* codec;
	bool wmod;				// Wort gendert
  char c;

private slots:
  /** Tastendruck */
  void slotPressx(int sloti);
  /** Auswahl aus Liste */
  void slotNewWord(int item);

};

#endif

































