/***************************************************************************
                          bibtext.cpp  -  description
                             -------------------
    begin                : Fre Aug 30 2002
    copyright            : (C) 2002 by Hans-Jrgen Schumann
    email                : hans@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "bibtext.h"

#include "openbook.xpm"
#include "forward.xpm"
#include "redo.xpm"
#include "undo.xpm"

//#include "fileopen.xpm"

#include <qaccel.h>
#include <qaction.h>
#include <qpixmap.h>
#include <qmainwindow.h>
#include <qfiledialog.h>
#include <qlabel.h>
#include <qtooltip.h>
#include <qwhatsthis.h>


BibText::BibText(QMainWindow *parent, QString name, QtBitanaDoc *d ): QToolBar(parent, name) {

/** Baut BookBar (2. Toolbar) auf */

  doc = d;
  connect(doc, SIGNAL(documentChanged()), this, SLOT(slotDocumentChanged()));
  connect(doc, SIGNAL(textPosChanged()), this, SLOT(slotPos2Kap()));
  doc->setSection("kern");
  bindex = new CBuchIndex();
  bindex->setzBasBuchVerzeichnis(doc->getStringEntry("BookDir"));
  bindex->setzBasVerzeichnis(doc->getStringEntry("TempDir"));
  bindex->setzBasOutVerzeichnis(doc->getStringEntry("OutDir"));

  QPixmap newBookIcon, toIcon, toPosIcon, fromPosIcon;
  newBookIcon = QPixmap(openbook);
  toIcon = QPixmap(forward);
  toPosIcon = QPixmap(redo);
  fromPosIcon  = QPixmap(undo);

//  openIcon = QPixmap(fileopen);
//  saveIcon = QPixmap(filesave);

  QAction *newBookDir = new QAction(tr("New Book Dir"), newBookIcon, tr("&NewBooks"), QAccel::stringToKey(tr("Ctrl+B")), this);
  newBookDir->setStatusTip(tr("Open a new Book Dir"));
  newBookDir->setWhatsThis(tr("New BookDir\n\nSelect a new Directory with books"));
  connect(newBookDir, SIGNAL(activated()), this, SLOT(slotBookDir()));
  newBookDir->addTo(this);
  newBookDir->setEnabled(false);

  addSeparator();

//  QLabel *la1 = new QLabel(this);
//  la1->setText("Buch:  ");

  comboBookList = new QComboBox(this);
  QToolTip::add(  comboBookList, tr( "Liste der verfgbaren Bcher" ) );
  QWhatsThis::add(  comboBookList, tr( "Asuswahl aus der Liste\n der verfgbaren Bcher" ) );

  QLabel *la2 = new QLabel(this);
  la2->setText("     ");

  kpvon = new QLineEdit(this);
  kpvon->setMaxLength(6);
  kpvon->setFixedWidth(50);
  connect(kpvon, SIGNAL( returnPressed()), this, SLOT(slotReturnPressed()));
//  connect(kpvon, SIGNAL( textChanged(QString &)), this, SLOT(slotTextChanged(QString &)));

  QAction *toText = new QAction(tr("To"), toIcon, tr("&NewBooks"), QAccel::stringToKey(tr("Ctrl+B")), this);
//  newBookDir->setStatusTip(tr("Open a new Book Dir"));
//  newBookDir->setWhatsThis(tr("New BookDir\n\nSelect a new Directory with books"));
//  connect(newBookDir, SIGNAL(activated()), this, SLOT(slotBookDir()));
  toText->addTo(this);
  toText->setEnabled(false);

  kpbis = new QLineEdit(this);
  kpbis->setMaxLength(6);
  kpbis->setFixedWidth(50);
  connect(kpbis, SIGNAL( returnPressed()), this, SLOT(slotReturnPressed()));

  addSeparator();

  QAction *fromPos = new QAction(tr("pos2kap"), fromPosIcon, tr("&NewBooks"), QAccel::stringToKey(tr("Ctrl+B")), this);
  fromPos->setStatusTip(tr("Position nach Kapitel:Vers"));
  fromPos->setWhatsThis(tr("Rechner position nach Kapitel:vers im angegebenen Buch um"));
  connect(fromPos, SIGNAL(activated()), this, SLOT(slotPos2Kap()));
  fromPos->addTo(this);

  QAction *toPos = new QAction(tr("kap2pos"), toPosIcon, tr("&NewBooks"), QAccel::stringToKey(tr("Ctrl+B")), this);
  toPos->setStatusTip(tr("Kapitel:Vers nach Position"));
  toPos->setWhatsThis(tr("Rechnet kapitel:Vers nach Position im Buch um"));
  connect(toPos, SIGNAL(activated()), this, SLOT(slotKap2Pos()));
  toPos->addTo(this);

  addSeparator();

//  QLabel *la2 = new QLabel(this);
//  la2->setText("Von Kap:Vers ");

  posvon = new QLineEdit(this);
  posvon->setMaxLength(6);
  posvon->setFixedWidth(50);
  connect(posvon, SIGNAL( returnPressed()), this, SLOT(slotReturnPressed()));

//  QAction *toText = new QAction(tr("To"), toIcon, tr("&NewBooks"), QAccel::stringToKey(tr("Ctrl+B")), this);
//  newBookDir->setStatusTip(tr("Open a new Book Dir"));
//  newBookDir->setWhatsThis(tr("New BookDir\n\nSelect a new Directory with books"));
//  connect(newBookDir, SIGNAL(activated()), this, SLOT(slotBookDir()));
  toText->addTo(this);

  posbis = new QLineEdit(this);
  posbis->setMaxLength(6);
  posbis->setFixedWidth(50);
  connect(posbis, SIGNAL( returnPressed()), this, SLOT(slotReturnPressed()));

  doc->setSection("kern");
  scanBookDir();

  connect(comboBookList, SIGNAL(activated(int)), SLOT(slotBookChanged(int)));

}

BibText::~BibText(){
}

void BibText::setDoc(QtBitanaDoc *d) {
  doc = d;
  slotDocumentChanged();
}

//* setzt neuse Buch mit Grenzen */
void BibText::slotInitBook(){
  doc->setSection("book");
  QString nb(doc->getStringEntry("book").c_str());
	int i;
  for (i=0; i<comboBookList->count(); i++) {
		if (nb == comboBookList->text(i)){
			comboBookList->setCurrentItem(i);
      slotBookChanged(i);
			break;
		}
	}
  if (i == comboBookList->count()) {
//    QMessageBox::warning(0,("Error"),
//                         i18n("Cannot find the book ")+ namebuch +
//												 i18n("\nin the directory ") + lesBuchDir());

  }


}

/** setzt ein neues Bcherverzeichnis */
void BibText::slotBookDir(){

  QString newdir = QFileDialog::getExistingDirectory(books, this, tr("select bookdir..."));
	if(!newdir.isEmpty()) books = newdir;
  scanBookDir();
  slotDocumentChanged();
}



/** No descriptions */
void BibText::scanBookDir(){

  books = doc->getStringEntry("BookDir", "books").c_str();
  // neue Liste aufbauen
  comboBookList->clear();
//	QDir hebdir(buchdir + "/he", "*.cod");
	QDir hebdir(books, "*.cod");
	const QFileInfoList *list = hebdir.entryInfoList();
  QFileInfoListIterator it( *list );
  QFileInfo *bname;

  while ((bname = it.current()) != 0) {
		bname->setFile(hebdir, bname->baseName() + ".idx");
   	if  (bname->exists()) comboBookList->insertItem(bname->baseName());
    ++it;
  }
}

/*
void BibText::setBookName(QString nb) {
	namebuch = nb;
	for (int i=0; i<buch->count(); i++)
		if (nb == buch->text(i)){
			buch->setCurrentItem(i);
			return;
		}
	QMessageBox::warning(0,i18n("Error"),
                         i18n("Cannot find the book ")+ namebuch +
												 i18n("\nin the directory ") + lesBuchDir());

}
*/

/** Book changed */
void BibText::slotBookChanged(int i){

  i=0;
  doc->setSection("book");
  doc->setStringEntry("book",  comboBookList->currentText().latin1());


  if (comboBookList->currentText().find("orah") > 0 )  kpvon->setText("101:1");
  else kpvon->setText("1:1");
  posvon->setText("1");

  // um das Buch zu setzen und Lnge ermitteln
  bindex->posKap(doc->getStringEntry("book"), 1);
  long endpos =  bindex->hebbuchlng;

  QString sendp;
  sendp = QString::number(endpos);

  posbis->setText(sendp);
  bindex->posKap(doc->getStringEntry("book"), endpos-1);

  kpbis->setText(QString::number(bindex->ikapitel) + ":" + QString::number(bindex->ivers));
  slotReturnPressed();

//	BHebIdx *hebidx = new BHebIdx();

//	setPosVon(0);
//	hebidx->endBuch(namebuch);
//	setPosBis(hebidx->versdat.epos);
//	slotPos2Kap();

}
void BibText::slotTextChanged(QString s) {
  s = "";
  slotReturnPressed();
}

void BibText::slotReturnPressed() {

	QString lin;

  doc->setSection("book");
  doc->setStringEntry("book",  comboBookList->currentText().latin1());

  lin =  kpvon->text();
	doc->setStringEntry("Kap_vers_von", lin.latin1());
  doc->setIntEntry("kap_von", lin.left(lin.find(':')).toInt());
  lin.remove(0, (lin.find(':') + 1));
	doc->setIntEntry("vers_von", lin.toInt());

  lin =  kpbis->text();
	doc->setStringEntry("Kap_vers_bis", lin.latin1());
  doc->setIntEntry("kap_bis", lin.left(lin.find(':')).toInt());
  lin.remove(0, (lin.find(':') + 1));
	doc->setIntEntry("vers_bis", lin.toInt());

	lin = posvon->text();
  doc->setIntEntry("pos_von", lin.toInt());

  lin = posbis->text();
  doc->setIntEntry("pos_bis", lin.toInt());

}

void BibText::slotDocumentChanged() {

  doc->setSection("book");
  QString nb(doc->getStringEntry("book").c_str());
	int i;
  for (i=0; i<comboBookList->count(); i++) {
		if (nb == comboBookList->text(i)){
			comboBookList->setCurrentItem(i);
			break;
		}
	}
  if (i == comboBookList->count()) {
//    QMessageBox::warning(0,("Error"),
//                         i18n("Cannot find the book ")+ namebuch +
//												 i18n("\nin the directory ") + lesBuchDir());

  }
  kpvon->setText(QString::QString(doc->getStringEntry("Kap_vers_von").c_str()));
  posvon->setText(QString::QString(doc->getStringEntry("pos_von").c_str()));
  posbis->setText(QString::QString(doc->getStringEntry("pos_bis").c_str()));
  kpbis->setText(QString::QString(doc->getStringEntry("Kap_vers_bis").c_str()));
  slotReturnPressed();

}

void BibText::slotKap2Pos() {

  
  doc->setSection("book");
  bindex->kapPos(doc->getStringEntry("book"), doc->getIntEntry("kap_von"), doc->getIntEntry("vers_von"));

  //

  posvon->setText(QString::number(bindex->kapvpos));

  bindex->kapPos(doc->getStringEntry("book"), doc->getIntEntry("kap_bis"), doc->getIntEntry("vers_bis"));
  posbis->setText(QString::number(bindex->kapbpos));

  slotReturnPressed();

}

void BibText::slotPos2Kap() {

  doc->setSection("book");
  bindex->posKap(doc->getStringEntry("book"), doc->getIntEntry("pos_von") );
  kpvon->setText(QString::number(bindex->ikapitel) + ":" + QString::number(bindex->ivers));

  bindex->posKap(doc->getStringEntry("book"), doc->getIntEntry("pos_bis") );
  kpbis->setText(QString::number(bindex->ikapitel) + ":" + QString::number(bindex->ivers));
  slotReturnPressed();
}
