/***************************************************************************
                          bibtext.h  -  description
                             -------------------
    begin                : Fre Aug 30 2002
    copyright            : (C) 2002 by Heinz & Hans-Jrgen Schumann
    email                : heinz@bitana.de; hans@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BIBTEXT_H
#define BIBTEXT_H

#include <qtoolbar.h>
#include <qcombobox.h>
#include <qstring.h>
#include <qlineedit.h>
#include <qlineedit.h>

//#include "cbitanaconfig.h"
#include "cbuchindex.h"
#include "qtbitanadoc.h"

/**Selection of Bibtext
  *@author Heinz & Hans-Jrgen Schumann
  */

class BibText : public QToolBar  {
  Q_OBJECT

public:
	BibText(QMainWindow *parent, QString name ="", QtBitanaDoc *doc=0);
	~BibText();
  /** bernimmt Doc fr Einstellungen */
  void setDoc(QtBitanaDoc *d);
public slots: // Public slots
  /** neues Buch wird mit Grenzen eingestellt */
  void slotInitBook();
  /** setzt ein neues Bcherverzeichnis */
  void slotBookDir();
  // Bei Return in einem Eingabefeld werden alle Werte neu gelesen
  // spter mit validator (Eingabeprfung)
  void slotReturnPressed();
 // neues Dokument wurde geladen
  void slotDocumentChanged();
  void scanBookDir();



private:

  /** No descriptions */
  QComboBox *comboBookList;
  QLineEdit *kpvon;
  QLineEdit *kpbis;
  QLineEdit *posvon;
  QLineEdit *posbis;

  QString books;
 // CBitanaConfig *bc;
  QtBitanaDoc *doc;
  CBuchIndex *bindex;


private slots:
    // neues Buch setzt kap:ver auf Buchgrenzen
  void slotBookChanged(int);

  void slotTextChanged(QString);
  void slotKap2Pos();
  void slotPos2Kap();


};

#endif
