/***************************************************************************
                          btextmatrix.cpp  -  description
                             -------------------
    begin                : Sat Jan 22 2000
    copyright            : (C) 2000 by Hans-Jrgen Schumann
    email                : hans@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "btextmatrix.h"
#include <iostream>

BTextMatrix::BTextMatrix(QWidget *parent, const char *name ) : QGridView(parent, name)
{ // qt3 QTableView(parent,name) {

    const int CELL = 15;
    codec = QTextCodec::codecForName("ISO 8859-8-I");

    setCellWidth (CELL);
    setCellHeight (CELL);

    setSpalten(1);
    //	setTableFlags(Tbl_autoScrollBars);

    //------------------------------------------------

    // Font setzten

    //	QFont f1 = QFont(family, point, weight, ital, QFont::CharSet(set));

    //   	fo = QFont("misc [fixed]", 19,50, 0); //, QFont::CharSet(8));
    //	setFont(fo);

    // ---------------------

    //    Aufbau der Farbtabelle
    // id, rgb-Werte oder Farbname aus  /usr/X11R6/lib/X11/rgb.txt

    ftab.setAutoDelete(true);
    ftab.insert(0, new QColor("black")); // Schwarz - default
    ftab.insert(1, new QColor("white"));
    ftab.insert(2, new QColor("gray"));
    ftab.insert(3, new QColor("red"));
    ftab.insert(4, new QColor("darkGreen"));
    ftab.insert(5, new QColor("blue"));
    ftab.insert(6, new QColor("cyan"));
    ftab.insert(7, new QColor("magneta"));
    ftab.insert(8, new QColor("yellow"));
    ftab.insert(9, new QColor("magneta"));
    ftab.insert(10, new QColor("magneta"));

    // Testausgabe der farbtabelle

    /*
      ftab.first();
    	do
    		cout << ftab.at() << " r-" << ftab.current()->red()  << " g-"
    			 << ftab.current()->green() << " b-" << ftab.current()->blue() << endl;
      while (ftab.next() != NULL);
     
    	ftab.at(2);
      cout << ftab.at() << " r-" << ftab.current()->red()  << " g-"
    			 << ftab.current()->green() << " b-" << ftab.current()->blue() << endl;
     
    */

    matrix = "";

    mtab.setAutoDelete(true);
    mtab.clear();

    setBackgroundColor("white");
    repaint(TRUE);

}
BTextMatrix::~BTextMatrix()
{}

/**  */
void BTextMatrix::paintCell(QPainter *p, int y, int x)
{

    QColor *m;
    unsigned i;
    i = coordsToIndex(x, y);
    p->setFont(fo);

    p->setPen(QColor(200,200,200));

    if (matrix.length() > i)
    {
        if ( (m = isColored(i)) != NULL )
        {

            p->setBackgroundMode (OpaqueMode);
            p->setBackgroundColor(QColor(230, 230, 230));
            p->setPen(QColor(black));
            p->setPen(*m);
            p->drawText(0, 0, cellWidth(), cellHeight(), AlignCenter, matrix.mid(i,1));

            // Werte zurcksetzen
            p->setPen(QColor(200,200,200));
            p->setBackgroundMode (TransparentMode);
            p->setBackgroundColor(QColor(white));
        }
        else
            p->drawText(0, 0, cellWidth(), cellHeight(), AlignCenter, matrix.mid(i,1));
    }
}


/** Anz.Spalten der Matrix / Zeilen werden angepasst*/
void BTextMatrix::setSpalten( int s)
{

    if (s > 0)
        setNumCols(s);
    setNumRows(matrix.length() / numCols() + 1);
}

/** Anz.Spalten der Matrix / Zeilen werden angepasst*/
void BTextMatrix::setZeilen( int z)
{

    if (z > 0)
        setNumRows(z);
    else
        setNumRows(matrix.length() / numCols() + 1);

}

void BTextMatrix::clear()
{

    matrix = "";
    mtab.clear();
}

/** Fgt bergebenen String in Matrix-String - noch keine Ausgabe */
int BTextMatrix::addMatrixLine(QString s)
{

    unsigned mpos;
    QChar c;

    mpos = matrix.length();

    for (unsigned i=0; i < s.length(); i++ )
    {
        c = s.at(i);
        if (c == '\t')
            continue;
        if (c == '\f')
        {
            i++;
            c = s.at(i);
            mtab.append(new mark);
            mtab.current()->pos = mpos;
            if ( ((unsigned)c - '0' ) < ftab.count() )
                mtab.current()->color = ( (unsigned)c - '0' );
            else
                mtab.current()->color = 0;
            i++;
            c = s.at(i);
        }
        matrix.append(c);
        mpos++;
    }
    return 0;
}


/** Umrechnung Spalte Zeile nach Position */
int BTextMatrix::coordsToIndex(int x, int y)
{

    if(x<0 || x>numCols() || y<0 || y>numRows() )
        ;
    //		cout << "btextmatrix: Fehler Koordinatenumrechnung "<< endl;

    return(y * numCols() + x);
}

/** prft, ob Position markiert ist und gibt Zeigar auf Farbe aus Farbtabelle */
QColor* BTextMatrix::isColored(int p)
{

    if (mtab.first() == NULL)
        return (NULL);
    do
    {
        if (mtab.current()->pos == p)
            return(ftab.at(mtab.current()->color));
    }
    while (mtab.next() != NULL);
    return(NULL);
}

//Del von KDevelop:void BTextMatrix::setMaFont(QFont f) {
//Del von KDevelop:
//Del von KDevelop:  QString hf = "'misc-fixed,19,50,0,22'";
//Del von KDevelop:
//Del von KDevelop:  QString family(hf.mid(1,hf.find(',')-1));
//Del von KDevelop:  hf = hf.mid(hf.find(',')+1);
//Del von KDevelop:
//Del von KDevelop:	int point = hf.mid(1,hf.find(',')+1).toInt();
//Del von KDevelop:  hf = hf.mid(hf.find(',')+1);
//Del von KDevelop:
//Del von KDevelop: 	int weight = hf.left(hf.find(',')).toInt();
//Del von KDevelop:  hf = hf.mid(hf.find(',')+1);
//Del von KDevelop:
//Del von KDevelop:	bool ital = hf.left(hf.find(',')).toInt();
//Del von KDevelop:  hf = hf.mid(hf.find(',')+1);
//Del von KDevelop:
//Del von KDevelop:	int set = hf.left(hf.find('\'')).toInt();
//Del von KDevelop:  hf = "";
//Del von KDevelop:
//Del von KDevelop://	hfont1 = QFont(family, point, weight, ital, QFont::CharSet(set));
//Del von KDevelop:}

































































