/***************************************************************************
                          cbtaconvert.cpp  -  description
                             -------------------
    begin                : Sat Jun 1 2002
    copyright            : (C) 2002 by Heinz & Hans-Jürgen Schumann
    email                : heinz@bitana.de; hans@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cbtaconvert.h"
#include <string>
#include <fstream>
//#include <ofstream>

using namespace std;

CbtaConvert::CbtaConvert()
{}
CbtaConvert::~CbtaConvert()
{}
/** Konvertierung nach LaTex */
bool CbtaConvert::bta2tex(string input, string output)
{

    // Typ 2 = .bta Datei --> tex Datei

    string farbtab[10] = {"{black}","{white}","{gray}","{red}","{blue}","{cyan}","{yellow}","{green}","{magenta}"};

    // Eingabedatei
    ifstream e1(input.c_str());
    if (!e1.good())
        return false;


    // Ausgabedatei
    ofstream tex(output.c_str(), ios::out);
    if (!tex.good())
        return false;

    bool hz, mz;
    char c;
    int ci;

    string num;

    tex << "\\documentclass[12pt,a4paper]{article}" << endl;
    tex << "\\usepackage[german,hebrew]{babel}" << endl;
    //  tex << "\\usepackage{geometry} " << endl;
    //  tex << "\\geometry{landscape,a4paper,tmargin=2cm,bmargin=1cm,lmargin=2cm,rmargin=1cm}" << endl;

    tex << "\\usepackage{hebcal}" << endl;
    tex << "\\usepackage{hebfont}" << endl;
    tex << "\\usepackage{color}" << endl;
    //    tex << "\\usepackage{fontenc,latexsym}" << endl;


    //    tex << "\\usepackage{times}" << endl;
    tex << "\\usepackage[T1]{fontenc}" << endl;
    tex << "\\usepackage[latin1]{inputenc}" << endl;



    tex << "\\usepackage{supertabular}" << endl;
    tex << "\\setlength\\parskip{\\medskipamount}" << endl;
    tex << "\\setlength\\parindent{0pt}" << endl << endl;

    tex << "\\begin{document}" << endl;
    tex << "\\hyphenation{";
    tex << "\xe3\xf7\x2d\xe3\xe5\x2d\xf7\xe9\x2d\xe9\xed\x20\xe1\xec\xf7\x2d\xf1\xe9\x2d\xf7\xe5\xef";
    tex << "}" << endl;
    tex << "\\unsethebrew" << endl;
    tex << "\\title{Antwort zu Ihrer Mailanfrage}" << endl;
    tex << "\\author{www.bitana.de}" << endl;
    tex << "\\maketitle\n" << endl;

    hz = false;   // Hebräische Zeichen

    while(!e1.eof())
    {
        e1.get(c);
        ci = (int)c;

        //    if(ci>223 && ci<251) {       // Hebräischer Buchstabe (keine Matix)
        if (ci> -33 && ci < -6)
        {
            if (!hz)
            {
                tex << "\\R{";
                hz=true;
            }
        }
        else if (hz)
        {             // Hebzeichenausgabe abschliessen
            hz = false;
            tex << "}";
        }

        if (c==7)
        {                   // Zeile überlesen
            while (c!=10 && !e1.eof())
                e1.get(c);
        }

        // Tabellenausgabe
        if (c==8)
        {                           // Tabellenbeginn
            tex << endl << "\\scriptsize" << endl;
            tex << "\\begin{center} " << endl;

            string tabbeg = "\\begin{supertabular}{|";
            e1.get(c);
            while (c!=10 && !e1.eof())
            {        // Ausrichtung der Spalten
                tabbeg += (char)c;
                tabbeg += "|";
                e1.get(c);
            }
            tabbeg += "}";
            tabbeg  += (char)c ;
            tabbeg += "\n";
            tex << endl << "\\vspace{0.5cm}" << endl;
            tex << "\\tablecaption{}" << endl;
            tex << "\\tablehead{\\hline ";
            e1.get(c);
            while (c!=10 && !e1.eof())
            {        // Spaltenköpfe

                if (c == '\t')
                    tex << " & ";
                else if (c== '%')
                    tex << "\\%";   // % in Kopf / Kommentar in Tex !!
                else
                    tex << c;
                e1.get(c);
            }
            tex << "\\\\" << "\\hline }" << endl;
            tex << "\\tabletail{\\hline}" << endl;
            tex << tabbeg;

            e1.get(c);
            ci = (int)c;

            while (c != '\e' && !e1.eof() )
            {   // Tabellenzeilen

                while (ci != 10 && !e1.eof())
                {

                    //          if(ci>223 && ci<251) {       // Hebräischer Buchstabe (keine Matix)
                    if (ci> -33 && ci < -5)
                    {
                        if (!hz)
                        {
                            tex << "\\R{";
                            hz=true;
                        }
                    }
                    else if (hz)
                    {             // Hebzeichenausgabe abschliessen
                        hz = false;
                        tex << "}";
                    }
                    if (c == '\t')
                        tex << " & ";
                    else
                        tex << c;
                    e1.get(c);
                    ci = (int)c;
                }
                tex << " \\\\" << endl;
                e1.get(c);
                ci = (int)c;
            }
            tex << "\\hline"<<endl;
            tex << "\\end{supertabular}"<<endl;
            tex << "\\vspace{0.5cm}" << endl;
            tex << "\\end{center}" << endl;
            tex << "\\normalsize" << endl << endl;
            continue;
        }


        if (c==11)
        {                  // Matrixbeginn
            tex << "\\vspace{0.5cm}" << endl;
            tex << "\\scriptsize" << endl;
            tex << "\\begin{center} " << endl;
            tex << "\\tablecaption{{Matrix}}" << endl;
            tex << "\\tablehead{}" << endl;
            tex << "\\tabletail{}" << endl;
            //      tex << "\\begin{center} " << endl;
            //      tex << "\\sethebrew " << endl;
            tex << "\\begin{supertabular}{|*{";
            e1.get(c);
            while(c!=10)
            {
                tex << c;           // lesen Anzahl Zeichen für Matrix
                e1.get(c);
            }
            tex << "}{@{}c}|}" << endl;
            tex << "\\hline " << endl;

            while (c != '\e' && !e1.eof() )
            {   // Matrixzeilen
                e1.get(c);
                mz = false;
                while (c != 10 && !e1.eof())
                {
                    mz = true;
                    if(c==12)                                // Farbe einbringen
                    {
                        e1.get(c);
                        int i=int(c)-48;
                        tex <<"\\color"+farbtab[i];
                        e1.get(c);
                    }
                    if (c == '\t' )
                        tex << '&';
                    else
                        tex << "\\R{" << c << "}";
                    e1.get(c);
                }
                if (mz)
                    tex << "\\\\" << endl;
            }
            tex << "\\hline " << endl;
            tex << "\\end{supertabular}" << endl;
            tex << "\\end{center}" << endl;
            tex << "\\vspace{0.5cm}" << endl;
            tex << "\\normalsize" << endl;
            //      tex << "\\unsethebrew" << endl;

            continue;

        }


        tex << c;
    }

    tex << endl<< endl;
    tex << "***  Ende Liste ***" << endl;
    //  tex << "\\end{center}" << endl;
    tex << "\\end{document} " << endl;
    tex.close();
    e1.close();
    return true;
}


/*!
    \fn CbtaConvert::bta2html(string input, strind output)
    Konvertierung nach html
 */
bool CbtaConvert::bta2html(string input, string output)
{
    // Typ 2 = .bta Datei --> html Datei

    string farbtab[10] = {"<font color=\"#000000\">",			// black
                          "<font color=\"#FFFFFF\">",			// withe
                          "<font color=\"#696969\">", 			// gray
                          "<font color=\"#CD0000\">", 			// red
                          "<font color=\"#0000FF\">",			// blue
                          "<font color=\"#00CDCD\">",			// cyan
                          "<font color=\"#EEEE00\">", 			// yellow
                          "<font color=\"#1DD624\">",			// green
                          "<font color=\"#CD00CD\">" 			//magenta
                         };

    // Eingabedatei
    ifstream e1(input.c_str());
    if (!e1.good())
        return false;


    // Ausgabedatei
    ofstream html(output.c_str(), ios::out);
    if (!html.good())
        return false;

    bool hz, mz;
    char c;
    int ci;

    string num;

    html << "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\"> " << endl;
    html << "<!-- Bitana v. 3.0 -->" << endl;
    html << "<!--Generated by bitana --> " << endl;
    html << "<html>" << endl;
    html << "<head>" << endl;
    html << "<title>Bitana - HTML - Ausgabe</title>" << endl;
    html << "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"> " << endl;
    html << "<meta name=\"GENERATOR\" content=\"Bitana V. 3.0\"> " << endl;
    html << "</head>" << endl;
    html << "<h3>Bibeltextanalyse</h3>" << endl;
    html << "<body>" << endl;

    hz = false;   // Hebräische Zeichen

    while(!e1.eof())
    {
        e1.get(c);
        ci = (int)c;
        if (c == 10)
            html << "<br>" << endl;

        //    if(ci>223 && ci<251) {       // Hebräischer Buchstabe (keine Matix)
        if (ci> -33 && ci < -5)
        {
            html << (char)0xD7;
            c = c - 80;
        }

        if (c==7)
        {                   // Zeile überlesen
            while (c!=10 && !e1.eof())
                e1.get(c);
        }

		
        // Tabellenausgabe
        if (c==8)
        {                           // Tabellenbeginn
	    html << "<br>" << endl;
            html << "<table>" << endl << "   <tbody>"<< endl;
            string tabalign[100];
            int n = 0;
            e1.get(c);
            while (c!=10 && !e1.eof())
            {
                // Ausrichtung der Spalten
                switch (c)
                {
                case 'l':
                    tabalign[n] = "align=\"left\"> ";
                    break;
                case 'c':
                    tabalign[n] = "align=\"center\"> ";
                    break;
                case 'r':
                    tabalign[n] = "align=\"right\"> ";
                    break;
                }
                n++;
                e1.get(c);
            }

            // Spaltenkpfe
            html << endl << "<tr>" << endl;
            e1.get(c);
            n = 0;
            html << "<th " << tabalign[n];
            while (c!=10 && !e1.eof())
            {
                if (c == '\t')
                {
                    n++;
                    html << " </th> <th " << tabalign[n];
                }
                else
                    html << c;
                e1.get(c);
            }
            html << "</th></tr>" << endl;

            // Tabellenzeilen
            e1.get(c);

            ci = (int)c;

            while (c != '\e' && !e1.eof() )
            {   // Tabellenzeilen
                n=0;
                html << endl << "<tr><td " << tabalign[n];
                while (ci != 10 && !e1.eof())
                {

                    if (ci> -33 && ci < -5)
                    {
                        html << (char)0xD7;
                        c = c - 80;
                    }
                    if (c == '\t')
                    {
                        n++;
                        html << " </td> <td " << tabalign[n];
                    }
                    else
                        html << c;
                    e1.get(c);
                    ci = (int)c;
                }
                html << "</td></tr>" << endl;
                e1.get(c);
                ci = (int)c;
            }
            html << "</tbody></table>" << endl;
            continue;
        }

        // Matrix
        bool farbe = false;
        if (c==11)
        {
            // Matrixbeginn
	    html << "<br>" << endl;
            html << "<table>" << endl;
            e1.get(c);
            while(c!=10)
            {
                //   html << c;           // lesen Anzahl Zeichen für Matrix
                e1.get(c);
            }


            while (c != '\e' && !e1.eof() )
            {   // Matrixzeilen
                e1.get(c);
                mz = false;
                while (c != 10 && !e1.eof())
                {
                    if (!mz)
                    {
                        mz = true;
                        html << "<tr>";
                        html << "<td>";
                    }
                    if(c==12)                                // Farbe einbringen
                    {
                        farbe = true;
                        e1.get(c);
                        int i=int(c)-48;
                        html << farbtab[i];
                        e1.get(c);

                    }

                    if (c == '\t' )
                        html << " </td> <td>";
                    else
                    {
                        html << (char)0xD7;
                        c = c - 80;
                        html << c;
                        if (farbe)
                        {
                            farbe = false;
                            html << "</font>";
                        }
                        html << "</td>";
                    }
                    e1.get(c);
                }
                if (mz)
                    html << "</tr>" << endl;

            }
            html << "</table>" << endl;
        }
        html << c;
    }
    html << endl << "<br>" << endl;
    html << "<sub><em>generiert mit Bitana v. 3.0</em></sub>" << endl;
    html << "</body></html> " << endl;
    html.close();
    e1.close();
    return true;
}
