/***************************************************************************
                          qtbitanadoc.cpp  -  description
                             -------------------
    begin                : Don Aug  8 22:46:53 CEST 2002
    copyright            : (C) 2002 by Heinz & Hans-Jrgen Schumann
    email                : heinz@bitana.de; hans@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "qtbitanadoc.h"

QtBitanaDoc::QtBitanaDoc()
{
  modified = false;
  propName = "";
}

QtBitanaDoc::~QtBitanaDoc()
{
}

void QtBitanaDoc::newTextPos() {
  emit textPosChanged();
}

void QtBitanaDoc::newDoc()
{
emit documentChanged();
}

bool QtBitanaDoc::save()
{
  if (modified) {
    addNoSave("kern--hebinput--fonts");
    bool b = saveConfig(docName.latin1());
    clearNoSave();
    return b;
  }
  else {
    return false;
  }

}

bool QtBitanaDoc::saveProperties()
{
  if (propName != NULL ) return saveConfig(propName.latin1());
  else return false;
}

bool QtBitanaDoc::saveAs(const QString &filename)
{
  docName = filename;
  modified = true;
  addNoSave("kern--hebinput--fonts");
  bool b = saveConfig(filename.latin1());
  clearNoSave();
  return b;
}

bool QtBitanaDoc::load(const QString &filename)
{
  docName = filename;
  modified = true;
  readConfig(filename.latin1(), true);
  emit documentChanged();
  return true;
}

bool QtBitanaDoc::loadProperties(const QString &filename)
{
  propName = filename;
  readConfig(filename.latin1(), true);
//  emit documentChanged();
  return true;
}

bool QtBitanaDoc::isModified() const
{
  return modified;
}
