/***************************************************************************
                          qtbitanadoc.h  -  description
                             -------------------
    begin                : Don Aug  8 22:46:53 CEST 2002
    copyright            : (C) 2002 by Heinz & Hans-Jrgen Schumann
    email                : heinz@bitana.de; hans@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef QTBITANADOC_H
#define QTBITANADOC_H

// include files for QT
#include <qobject.h>

// application specific includes
#include "cbitanaconfig.h"

/**
  * the Document Class
  */

class QtBitanaDoc : public QObject, public CBitanaConfig
{
  Q_OBJECT

  public:
    QtBitanaDoc();
    ~QtBitanaDoc();
    void newTextPos();
    void newDoc();
    bool save();
    bool saveProperties();
    bool saveAs(const QString &filename);
    bool load(const QString &filename);
    bool loadProperties(const QString &filename);
    bool isModified() const;

  signals:
    void documentChanged();
    void textPosChanged();

  protected:
    bool modified;
    QString docName;
    QString propName;
};

#endif
